//trieda na pracu s animaciami

//konstruktor
//destruktor

//add
//set
//get
//draw
#include "anim.h"
animation::animation(HGE *nhge, int nw, int nh)
{
 no_frames = 0;     
 current_frame = 0;            
 hgge = nhge;     
 w = nw;
 h = nh;
 //printf("spravil som animaciu");                      
}


animation::~animation()
{
 //printf("zrusil som animaciu");                      
}


int animation::add_frame(char *filename)
{
 hgeQuad *q = dl_util_makeHgeQuad(hgge, 0,0,w,h,0xffffffff, filename);
 
 frames.push_back(q); 
 
 
 //tu moze byt aj no_frames++ ale toto bude asi bezpecnejsie
 no_frames = frames.size();    

 return 1;    
}

int animation::set_frame(int new_frame)
{
 if(new_frame >= no_frames) new_frame = new_frame % no_frames;
 if(new_frame < 0)new_frame = 0;
 current_frame = new_frame; 
 
 return 1;    
}

list<hgeQuad*>::iterator animation::get_frame(int frm)
{
  list<hgeQuad*>::iterator it;
  int i = 0;
  for(it = frames.begin(); it != frames.end(); it++)
  {
    if(i == frm) break;
    i++;
  }
  return it;
}

int animation::draw_at(int x, int y, bool horflip)
{
 list<hgeQuad*>::iterator it;
 
 //tu sa da dat aj for
 it = frames.begin();
 int counter;
 counter = 0;
 while(counter != current_frame)
 {
  counter++;
  it++;         
 }
 (*it)->v[0].x = x; (*it)->v[0].y = y;
 (*it)->v[1].x = x+w; (*it)->v[1].y = y;
 (*it)->v[2].x = x+w; (*it)->v[2].y = y+h;
 (*it)->v[3].x = x; (*it)->v[3].y = y+h;
  if(horflip)
  {
    (*it)->v[0].tx = 1.0f;
    (*it)->v[1].tx = 0.0f;
    (*it)->v[2].tx = 0.0f;
    (*it)->v[3].tx = 1.0f;
  }
  else
  {
    (*it)->v[0].tx = 0.0f;
    (*it)->v[1].tx = 1.0f;
    (*it)->v[2].tx = 1.0f;
    (*it)->v[3].tx = 0.0f;
  }
  hgge->Gfx_RenderQuad(*it);
 return 1;    
}
