#include "dl_hge_checkbox.h"

CHECKBOX::CHECKBOX(HGE *h)
{
  m_hge = h;
  trigger = false;
  //printf("urobil som checkbox\n");
}

CHECKBOX::~CHECKBOX()
{
  //printf("zrusil som checkbox\n");
}

int CHECKBOX::draw()
{
  if(trigger) m_hge->Gfx_RenderQuad(&checked);
  else m_hge->Gfx_RenderQuad(&unchecked);
  
  return 1;
}

int CHECKBOX::manage()
{
  int kliklo_sa;
  kliklo_sa = 0;
  if(mir(m_hge, x, y, x+w, y+h, 0))
  {
    if(!lb_is_pressed() && lb_was_pressed())
    {
      set_lb_unpressed();
      trigger =! trigger;
      kliklo_sa = ID;
      if(proc != NULL)
      {
        proc(trigger);
      }
    }
  }
  
  return kliklo_sa;
}

int CHECKBOX::set_bitmaps(char *checked_bmp, char *unchecked_bmp)
{
  unchecked = *dl_util_makeHgeQuad(m_hge, x, y, w, h, 0xffffffff, unchecked_bmp);
  checked   = *dl_util_makeHgeQuad(m_hge, x, y, w, h, 0xffffffff, checked_bmp);
  return 1;
}
