#ifndef __BUTTON_H
#define __BUTTON_H

#include "dl_hge_util.h"

#define BUTT_TYPE_PLAY 1
#define BUTT_TYPE_WAY  2
#define BUTT_TYPE_GOTO 2
#define BUTT_TYPE_PROC 2
#define BUTT_TYPE_EXIT 3

class BUTTON
{
 public:
        BUTTON(HGE *h);
        BUTTON();
        ~BUTTON();
        int draw();
        int manage(int *ap, float delta);
        int set_bitmaps(char *normal_bmp, char *hover_bmp);
        void(*proc)();
        
        int alpha;
        int x, y, w, h;
        int invisible;
        int type;
        int way;
        int ID;
        bool has_hover;
        hgeQuad normal;
        hgeQuad hover;
        HGE *m_hge;
};

#endif
