#include "fireball.h"

FIREBALL::FIREBALL(HGE *nhge)
{
 hgge = nhge;          
 x = 5.0f;
 y = 384.0f; 
 vystreleny = 0;           
 //printf("mame fireball");                   
}

FIREBALL::FIREBALL()
{
 x = 5.0f;
 y = 384.0f;   
 vystreleny = 0;                
 //printf("mame fireball");                    
}

FIREBALL::~FIREBALL()
{
 //printf("nemame fireball");                    
}

int FIREBALL::init(HTEXTURE tex)
{
 spr = new hgeSprite(tex, 64, 64, 32, 32);
 spr->SetColor(0xffffffff);
 spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
 par = new hgeParticleSystem("par/fireball.psi", spr);    
 par->info.nEmission = 25;
 //par->Fire();
 
 if(par == NULL)printf("nemame par");
 
 return 1;    
}

int FIREBALL::draw()
{
 //if(vystreleny)
 //{
  par->Render();
 //}
 
 return 1;    
}

int FIREBALL::manage(float cl)
{
 float dt;
 
  dt = hgge->Timer_GetDelta();
  par->Update(dt);   
 if(vystreleny)
 {
  par->MoveTo(x, y);
  par->Transpose(-cl, 0);
  x += vx;
  if((x-cl) < -32 || (x-cl) > 1024)
  {
    vystreleny = 0;
    par->Stop();
  }
 }
 else
 {
   if(par->GetParticlesAlive() == 0)
     par->Stop(true);
 }
 return 1;    
}

