#include "freeze.h"

FREEZE::FREEZE(HGE *nhge)
{
 hgge = nhge;          
 x = 5.0f;
 y = 500.0f; 
 vystreleny = 0;           
 //printf("mame freeze");                   
}

FREEZE::FREEZE()
{
 x = 5.0f;
 y = 500.0f; 
 vystreleny = 0;                  
 //printf("mame freeze");                    
}

FREEZE::~FREEZE()
{
 //printf("nemame freeze");                    
}

int FREEZE::init(HTEXTURE tex)
{
 spr = new hgeSprite(tex, 0, 96, 32, 32);
 spr->SetColor(0xffffffff);
 spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
 par = new hgeParticleSystem("par/freeze.psi", spr);    
 par->info.nEmission = 25;
 //par->Fire();
 
 if(par == NULL)printf("nemame par");
 
 return 1;    
}

int FREEZE::draw()
{
 //if(vystreleny)
 //{
  par->Render();
 //}
 
 return 1;    
}

int FREEZE::manage(float cl)
{
 float dt;
 dt = hgge->Timer_GetDelta();
 par->Update(dt);  
 if(vystreleny)
 { 
  par->MoveTo(x, y);
  par->Transpose(-cl, 0);
  x += vx;
  if((x-cl) < -32 || (x-cl) > 1024)
  {
    vystreleny = 0;
    par->Stop();
  }
 }
 else
 {
   if(par->GetParticlesAlive() == 0)
     par->Stop(true);
 }
 
 return 1;    
}
