#include "lifedrain.h"

LIFEDRAIN::LIFEDRAIN(HGE *nhge)
{
 hgge = nhge;          
 x = 5.0f;
 y = 500.0f; 
 vystreleny = 0;           
 nesiem = 0;
 vraciasa = false;
 //printf("mame freeze");                   
}

LIFEDRAIN::LIFEDRAIN()
{
 x = 5.0f;
 y = 200.0f;                   
 vystreleny = 0;
 nesiem = 0;
 vraciasa = false;
 //printf("mame freeze");                    
}

LIFEDRAIN::~LIFEDRAIN()
{
 //printf("nemame freeze");                    
}

int LIFEDRAIN::init(HTEXTURE tex)
{
 spr = new hgeSprite(tex, 96, 64, 32, 32);
 spr->SetColor(0xffffffff);
 spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
 par = new hgeParticleSystem("par/lifedrain.psi", spr);    
 par->info.nEmission = 25;
 //par->Fire();
 
 if(par == NULL)printf("nemame par");
 
 return 1;    
}

int LIFEDRAIN::draw()
{
 //if(vystreleny)
 //{
  par->Render();
 //}
 
 return 1;    
}

int LIFEDRAIN::manage(float cl)
{
 float dt;
 dt = hgge->Timer_GetDelta();
 par->Update(dt);   
 if(vystreleny)
 {
  par->MoveTo(x, y);
  par->Transpose(-cl, 0);
  x += vx;
  if((x-cl) < -32 || (x-cl) > 1024)
  {
    nesiem = 0;
    vraciasa = false;
    vystreleny = 0;
    par->Stop();
  }
 }
 else
 {
   if(par->GetParticlesAlive() == 0)
     par->Stop(true);
 }
 return 1;    
}
