#include "dl_hge_listbox.h"

LISTBOX::LISTBOX(HGE *nhge)
{
 //printf("mame listbox");
 index = 0;
 in_action = 0;
 value = 0;
 min = 0;
 hgge = nhge;
 up.m_hge = nhge;
 down.m_hge = nhge;
}

LISTBOX::~LISTBOX()
{
 //printf("nemame listbox");
}

int LISTBOX::draw()
{
 int i;
 i = 0;
 list<ITEM>::iterator it;
 for(it = items.begin(); it != items.end(); it++)
 {
  if(i >= index && i <= index+showing-1)
  {
   if(it->selected)
   {
    hoverone.v[0].x = x; 
    hoverone.v[1].x = x+w;
    hoverone.v[2].x = x+w;
    hoverone.v[3].x = x;
    
    hoverone.v[0].y = y+i*30-index*30; 
    hoverone.v[1].y = y+i*30-index*30;
    hoverone.v[2].y = y+i*30-index*30+30;
    hoverone.v[3].y = y+i*30-index*30+30;
    
    hgge->Gfx_RenderQuad(&hoverone);
   }
   fnt->printf(x+10, y+i*30-index*30, HGETEXT_LEFT, "%s", it->text);
  }
  i++;       
 }
 if(items.size() > showing)
 {
  //hgge->Gfx_RenderQuad(&kolajnica);
  //hgge->Gfx_RenderQuad(&vlak);
  up.draw();
  down.draw();
 }
 return 1;    
}

int LISTBOX::manage(int *aap, float delta)
{
 if(items.size() > showing)
 {
  up.manage(aap, delta);
  down.manage(aap, delta);
 }
 int i;
 i = 0;
 
 list<ITEM>::iterator it;
 list<ITEM>::iterator it2;
 for(it = items.begin(); it != items.end(); it++)
 {
  if(i >= index && i <= index+showing-1)//ak je ho vobec vidno
  {
   if(mir(hgge, x, y+i*30-index*30, x+w-kolajnica_w, y+i*30+7-index*30 + 30, 1))
   {
    for(it2 = items.begin(); it2 != items.end(); it2++)it2->selected = false;
    it->selected = true;
    proc(it->ID, it->text); 
   }
  }
  i++;       
 }
 
 //slider manage
 /*float mouse_x, mouse_y;
 
 if(mir(hgge, x+w-kolajnica_w, y+kolajnica_w+value, x+w, y+kolajnica_w+value+kolajnica_w, 1))
 {
  in_action = 1;
  hgge->Input_GetMousePos(&mouse_x,&mouse_y);
  rozdiel = mouse_y - y - value -kolajnica_w;
  //printf("rozdiel> %d>>>", rozdiel);
 }
 if(in_action)
 {
  hgge->Input_GetMousePos(&mouse_x,&mouse_y);
  if(mouse_y < y+kolajnica_w)value = min;
  else if(mouse_y > y+h-kolajnica_w)value = max;  
  else value = mouse_y - y;
  
  value-=rozdiel;
  
  vlak.v[0].y = y+value;
  vlak.v[1].y = y+value;
  vlak.v[2].y = y+value+kolajnica_w;
  vlak.v[3].y = y+value+kolajnica_w;
  
  //proc(value);
              
 }
 if(in_action && hgge->Input_GetKeyState(HGEK_LBUTTON) == false)in_action = 0;
 */
 return 1;    
}

int LISTBOX::set_font(char *font)
{
 fnt = new hgeFont(font);   
 return 1;
}

void LISTBOX::up_callback()
{
 //printf("upp\n");
 index--;   
}

void LISTBOX::down_callback()
{
 //printf("downn\n");
 index++;   
}

int LISTBOX::set_buttons(char *up_normal, char *up_hover, char *down_normal, char *down_hover)
{
 up.x = x+w-kolajnica_w;
 down.x = x+w-kolajnica_w;
 up.y =  y;
 down.y = y+h-kolajnica_w;
 
 up.w = kolajnica_w;
 down.w = kolajnica_w;
 up.h = kolajnica_w;
 down.h = kolajnica_w;
 
 up.ID = 321321321;
 down.ID = 321321322;
 
 up.type = BUTT_TYPE_WAY;
 down.type = BUTT_TYPE_WAY;
 up.way = 5;
 down.way = 5;
 
/* up.proc = (&up_callback);
 down.proc = down_callback;*/
 
 up.set_bitmaps(up_normal, up_hover);
 down.set_bitmaps(down_normal, down_hover);
    
 return 1;
} 

int LISTBOX::set_bitmap(char *vlakfilename, char *hoveronefilename, char *kolajnicafilename)
{
 //vlak = *dl_util_makeHgeQuad(hgge, x+w-kolajnica_w, y+kolajnica_w, kolajnica_w, kolajnica_w, 0xffffffff, vlakfilename);
 hoverone = *dl_util_makeHgeQuad(hgge, x, y, w, h/showing, 0x99aaaaaa, NULL);
 kolajnica = *dl_util_makeHgeQuad(hgge, x+w-kolajnica_w, y, kolajnica_w, h, 0xffffffff, kolajnicafilename);
 max = h-(1*kolajnica_w);
 return 1;
}

int LISTBOX::add_item(int id, char *text)
{
 //printf("pridavam item %d %s", id, text);
 ITEM i;
 i.ID = id;
 memset(i.text, '\0', 128);
 sprintf(i.text, text);
 i.selected = false;
 
 items.push_back(i);
 
 return 1;
}


