#include "dl_level.h"
#include "dl_hge_menu.h"
#include "dl_hge_dist.h"

#define ID_RADIOGROUP 2778
#define ID_FIRSTBUTTON 27781
#define ID_SECONDBUTTON 27782
#define ID_THIRDBUTTON 27783
#define ID_SLIDER 3000
#define ID_BITMAP 4000
#define ID_LISTBOX1 5000
#define ID_TEXTBOX 6000

#define ID_SRV_DANO   15901
#define ID_SRV_OG     15902
#define ID_SRV_LAN    15903
#define ID_SRV_LOGIN  15904
#define ID_SRV_CREAT  15905
#define ID_SRV_IPBOX  15906
#define ID_SRV_NICK   15907
#define ID_SRV_PWD    15908

#define ID_GM_JOIN    75301
#define ID_GM_CREAT   75302
#define ID_GM_NAME    75303
#define ID_GM_PWD     75304
#define ID_GM_LOGOUT  75305
#define ID_GM_LBOX    75306
#define ID_GM_REFRESH 75307

#define RED_TEAM   1
#define BLUE_TEAM  2
#define ROGUE      3
int myteamcolor = RED_TEAM;
int musicvol = 50, soundvol = 50;


HTEXTURE	logotex;
DL_HGE_DIST dist;
int playlogo = 250;

///danova ipcka 87.197.130.210
#define SINGLEP 0
#define MULTIP 1
int cur_rmlbx_id = 50011;
int sp_or_mp = SINGLEP;//0 sp 1 mp
int player_id = 0;

HSTREAM hsles, hsluka, hsjaskyna, hszamok, hsplaz, hssopka, hstheme;
HCHANNEL hudba;

DL_WS_CLIENT client;
hgeQuad *mouse;
HGE *hge = 0;
DL_HGE_MENU m;

hgeDistortionMesh*	dis;
HTARGET targo;

bool godlikemode;
int servertype = 0;

DL_LEVEL lvl;
hgeFont *fnt, *font;
HEFFECT moonwalk;
hgeQuad *mw;
hgeSprite *mw_spr;
hgeParticleSystem *mwpar;
int mwvystreleny = 0;
int menugotolevel = -1;
const int nRows=64;
const int nCols=64;
const float cellw=1024.0f/(nCols-1);
const float cellh=768.0f/(nRows-1);

float laplas[nRows][nCols], vel[nRows][nCols], arr[nRows][nCols];
float blur_coefficient=0.015f;
float pressure=-10;

int meshx = 0;
int meshy = 0;

float t = 0.0f;
float dt;
bool mouse_move;
float oldx = -30.0f, oldy = -30.0f;

void ExitFunc(void){
     client.disconnect();
}
void SIGFunc(int param){
     client.disconnect();
     exit(1);
}

bool FrameFunc()
{
  if(playlogo > 0)
  {
    dist.manage();
    if(dist.t >= dist.time)
      playlogo--;
  }
  else
  {
  float mx, my;
  hge->Input_GetMousePos(&mx, &my);
  mouse->v[0].x = mx;
  mouse->v[1].x = mx+32;
  mouse->v[2].x = mx+32;
  mouse->v[3].x = mx;
  
  mouse->v[0].y = my;
  mouse->v[1].y = my;
  mouse->v[2].y = my+32;
  mouse->v[3].y = my+32;
  
  if(m.active_paper == 50)
  {
    if(m.manage() == 0) return true;
    for(int k = 0; k < 15; k++)
    {
      if(lvl.unlockedlevels[k] == 0)
        m.search_paper(50)->search_button(201+k)->invisible = 1;
      else
        m.search_paper(50)->search_button(201+k)->invisible = 0;
    }
  }
  if(m.active_paper != 50 && m.active_paper != -1)
  {
    if(m.manage() == 0) return true;
    int ax, ay;
    int i, j;
    dt = hge->Timer_GetDelta();
    t+=dt;
    
    // Process keys
    if((int)mx == (int)oldx && (int)my == (int)oldy)
    {
      mouse_move = false;  
    }
    else mouse_move = true;
      
    
    
    oldx = mx; oldy = my;
    
    if(m.active_paper != 70)
    if(hge->Input_KeyDown(HGEK_ESCAPE))
        return true;
    
    //if(hge->Input_GetKeyState(HGEK_LBUTTON))
    if(mouse_move)
    {
      ax=int((mx-meshx)/cellw);
      ay=int((my-meshy)/cellh);
      if(ax>1 && ax<nCols-1 && ay>1 && ay<nRows-1)
      {
        arr[ay][ax]=pressure;
        if(ay+1<nRows-1) arr[ay+1][ax]=pressure;
        if(ax+1<nCols-1) arr[ay][ax+1]=pressure;
        if(ay+1<nRows-1 && ax+1<nCols-1) arr[ay+1][ax+1]=pressure;
      }
    }
    
    
    for(i=1;i<nRows-1;i++)
    for(j=1;j<nCols-1;j++)
    {
      laplas[i][j]=-arr[i][j]*4+arr[i+1][j]+arr[i-1][j]+arr[i][j+1]+arr[i][j-1];
      vel[i][j]+=laplas[i][j];
    }
    
    for(i=1;i<nRows-1;i++)
    for(j=1;j<nCols-1;j++)
      arr[i][j]+=dt*vel[i][j];
    
    for(i=1;i<nRows-1;i++)
    for(j=1;j<nCols-1;j++)
      arr[i][j]+=dt*vel[i][j]+blur_coefficient*laplas[i][j]; 
    
    for(i=0;i<nRows;i++)
    for(j=0;j<nCols;j++)
    {
      dis->SetDisplacement(j,i,0,arr[i][j],HGEDISP_NODE);
      //dis->SetColor(j,i,0xFF<<24 | 0x00FF<<16 | (0x00FF/2)<<8);
    }
  }
  else if(m.active_paper == -1)
  {
    if(sp_or_mp == SINGLEP)
    {
        if(hge->Input_GetKeyState(HGEK_ESCAPE))
        {
           m.active_paper = 50;
           lvl.deinit();
           hge->Channel_Stop(hudba);
           hudba = hge->Stream_Play(hstheme, true);
           hge->Channel_SetVolume(hudba, musicvol);
        }
        else
        {
          float dt = hge->Timer_GetDelta();
          if(lvl.showing == 0)
          {
            lvl.manage(0, soundvol);
          }
          mwpar->Update(dt);
          
          if(lvl.search_player(0)->skoncillevel == 1)
          {
            if(lvl.slide3 && lvl.showing == 0)
            {
              lvl.load_slide(3);
              lvl.showing = 3;
            }
            else if(lvl.slide4 && lvl.showing == 0)
            {
              lvl.load_slide(4);
              lvl.showing = 4;
            }
            else if(!lvl.slide3 && !lvl.slide4 && lvl.showing == 0)
            {
              lvl.showing = 5;
            }
            if(lvl.showing == 5)
            {
              lvl.donelevels[lvl.curlvl] = 1;
              lvl.deinit();
              m.active_paper = 50;
              hge->Channel_Stop(hudba);
              hudba = hge->Stream_Play(hstheme, true);
              /*lvl.showing = 0;
              lvl.hgge = hge;
              lvl.data = (int**)malloc(sizeof(int*) * 192);
              for(int i = 0; i < 192; i++)
                lvl.data[i] = (int*)malloc(sizeof(int) * 24);
              lvl.add_player_single(0, godlikemode);
              lvl.init(lvl.curlvl+1);*/
            }
          }
        }
    }
    else if(sp_or_mp == MULTIP)
    {
        if(hge->Input_GetKeyState(HGEK_ESCAPE))
        {
           m.active_paper = 50;
           lvl.deinit();
           client.dl_send("13");
           client.dl_send("06");
           client.disconnect();
           hge->Channel_Stop(hudba);
           hudba = hge->Stream_Play(hstheme, true);
           hge->Channel_SetVolume(hudba, musicvol);
        }
        else
        {
          float dt = hge->Timer_GetDelta();
          lvl.manage_mp(&client, player_id);
          mwpar->Update(dt);
        }
    }
  }
  }
  return false;
}

bool RenderFunc()
{
  if(playlogo > 0)
  {
    hge->Gfx_BeginScene();
	hge->Gfx_Clear(0);
	dist.draw();
	hge->Gfx_EndScene();
  }
  else
  {
  if(m.active_paper == -1)
  {
    hge->Gfx_BeginScene();
    hge->Gfx_Clear(0);
    if(sp_or_mp == SINGLEP)
      lvl.draw();
    //else
      //lvl.draw_mp();
    //fnt->printf(5, 5, HGETEXT_LEFT, "FPS:%d LVL:%d", hge->Timer_GetFPS(), lvl.curlvl);
    //fnt->printf(5, 25,HGETEXT_LEFT, "FRM:%f %f", lvl.search_player(0)->frame, lvl.search_player(0)->search_cernoch(0)->frame);
    //fnt->printf(5, 45,HGETEXT_LEFT, "LIFE:%f MANA:%f", lvl.search_player(0)->life, lvl.search_player(0)->mana);
    //fnt->printf(5, 65,HGETEXT_LEFT, "bt:%f", lvl.search_player(0)->bubbletime);
    //fnt->printf(5, 105,HGETEXT_LEFT, "is_eol %d skoncillevel %d", lvl.search_player(0)->is_eol, lvl.search_player(0)->skoncillevel);
    //if((lvl.search_player(0)->smer == 4 && hge->Input_GetKeyState(HGEK_RIGHT)) || (lvl.search_player(0)->smer == 6 && hge->Input_GetKeyState(HGEK_LEFT)))
    list<PLAYER>::iterator razer;
    if(sp_or_mp == SINGLEP)
      razer = lvl.search_player(0);
    //else
      //razer = lvl.search_player(player_id);
    //fnt->printf(5, 85,HGETEXT_LEFT, "MOONWALK: %f SMER: %d", razer->kraca, razer->smer);
    //fnt->printf(5, 125, HGETEXT_LEFT, "%f %f %d %d", razer->x, razer->y, razer->endx, razer->endy);
    if(lvl.showing == 0 && razer->kraca > 1.0f && /*!razer->lieta && */((razer->smer == 4 && hge->Input_GetKeyState(HGEK_RIGHT)) || (razer->smer == 6 && hge->Input_GetKeyState(HGEK_LEFT))))
    {
      if(mwvystreleny == 0 && ((hge->Input_GetKeyState(HGEK_LEFT) && !hge->Input_GetKeyState(HGEK_RIGHT)) || (!hge->Input_GetKeyState(HGEK_LEFT) && hge->Input_GetKeyState(HGEK_RIGHT))) )
      {
        mwpar->FireAt(512,384);
        mwvystreleny = 1;
        hge->Effect_PlayEx(moonwalk, soundvol);
      }
      if(mwvystreleny)
      {
        mwpar->Render();
        hge->Gfx_RenderQuad(mw);
      }
    }
    else if(mwpar->GetParticlesAlive() == 0) mwvystreleny = 0;
    
    hge->Gfx_EndScene();
  }
  else
  {
    hge->Gfx_BeginScene(targo);
    hge->Gfx_Clear(0xff000000);
    m.draw();
    //fnt->printf(5, 5, HGETEXT_LEFT, "FPS:%d %d", hge->Timer_GetFPS(), myteamcolor);
    if(m.active_paper == 70)
    {
      font->printf(587+40, 285, HGETEXT_LEFT, "RED TEAM");
      font->printf(587+40, 285+32+2, HGETEXT_LEFT, "BLUE TEAM");
      font->printf(587+40, 285+32+2+32+2, HGETEXT_LEFT, "ROGUE");
    }
    
    float mx, my;
    hge->Input_GetMousePos(&mx,&my);
    //fnt->printf(20, 200, HGETEXT_LEFT, "%.1f %.1f", mx, my);
    
    hge->Gfx_EndScene();
    hge->Gfx_BeginScene();
    hge->Gfx_Clear(0);
    dis->Render(0, 0);
    hge->Gfx_RenderQuad(mouse);
    hge->Gfx_EndScene();
  }
  }
  return false;
}

bool GfxRestoreFunc()
{
  if(dis && targo)
       dis->SetTexture(hge->Target_GetTexture(targo));

  return false;
}

void set_levelmp_og(void)
{
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.init_mp(1);
    sp_or_mp = MULTIP;
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
}
void set_levelmp_dano(void)
{
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.init_mp(2);
    sp_or_mp = MULTIP;
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
    lvl.add_player_multi(0, "ogboop");
}
void set_levelmp_lan(void)
{
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.init_mp(3);
    sp_or_mp = MULTIP;
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
}

void set_level0(void)
{
  lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(0);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
}
void set_level1(void)//{menugotolevel = 1;}
{
  if(lvl.unlockedlevels[1]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(1);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level2(void)//{menugotolevel = 2;}
{
  if(lvl.unlockedlevels[2]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(2);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level3(void)//{menugotolevel = 3;}
{
  if(lvl.unlockedlevels[3]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(3);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level4(void)//{menugotolevel = 4;}
{
  if(lvl.unlockedlevels[4]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(4);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level5(void)//{menugotolevel = 5;}
{
  if(lvl.unlockedlevels[5]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(5);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level6(void)//{menugotolevel = 6;}
{
  if(lvl.unlockedlevels[6]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(6);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level7(void)//{menugotolevel = 7;}
{
  if(lvl.unlockedlevels[7]==1)
  {  
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(7);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level8(void)//{menugotolevel = 8;}
{
  if(lvl.unlockedlevels[8]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(8);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level9(void)//{menugotolevel = 9;}
{
  if(lvl.unlockedlevels[9]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(9);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level10(void)//{menugotolevel = 10;}
{
  if(lvl.unlockedlevels[10]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(10);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level11(void)//{menugotolevel = 11;}
{
  if(lvl.unlockedlevels[11]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(11);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level12(void)//{menugotolevel = 12;}
{
  if(lvl.unlockedlevels[12]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(12);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level13(void)//{menugotolevel = 13;}
{
  if(lvl.unlockedlevels[13]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(13);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level14(void)//{menugotolevel = 14;}
{
  if(lvl.unlockedlevels[14]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(14);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level15(void)//{menugotolevel = 15;}
{
  if(lvl.unlockedlevels[15]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(15);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level16(void)//{menugotolevel = 16;}
{
  if(lvl.unlockedlevels[16]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(16);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level17(void)//{menugotolevel = 17;}
{
  if(lvl.unlockedlevels[17]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(17);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level18(void)//{menugotolevel = 18;}
{
  if(lvl.unlockedlevels[18]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(18);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}
void set_level19(void)//{menugotolevel = 19;}
{
  if(lvl.unlockedlevels[19]==1)
  {
    lvl.data = (int**)malloc(sizeof(int*) * 192);
    for(int i = 0; i < 192; i++)
      lvl.data[i] = (int*)malloc(sizeof(int) * 24);
    lvl.add_player_single(0, godlikemode);
    lvl.init(19);
    hge->Channel_Stop(hudba);
    if(lvl.typpozadia == MEADOW) hudba = hge->Stream_Play(hsluka, true);
    else if(lvl.typpozadia == FORREST) hudba = hge->Stream_Play(hsles, true);
    else if(lvl.typpozadia == VOLCANO) hudba = hge->Stream_Play(hssopka, true);
    else if(lvl.typpozadia == BEACH) hudba = hge->Stream_Play(hsplaz, true);
    else if(lvl.typpozadia == CASTLE) hudba = hge->Stream_Play(hszamok, true);
    else if(lvl.typpozadia == CAVE) hudba = hge->Stream_Play(hsjaskyna, true);
    hge->Channel_SetVolume(hudba,musicvol);
  }
  else m.active_paper = 50;
}

void set_godlike_mode(bool set)
{
  godlikemode = set;
}

void slider_callback(int i)
{
 //printf("slider_callback> %d", i);    
}

void musicslider_callback(int i)
{
  musicvol = (float)(i/512.0f)*100.0f;
  if(musicvol < 0) musicvol = 0;
  if(musicvol > 100) musicvol = 100;
  hge->Channel_SetVolume(hudba,musicvol);
}

void soundslider_callback(int i)
{
  soundvol = (float)(i/512.0f)*100.0f;
  if(soundvol < 0) soundvol = 0;
  if(soundvol > 100) soundvol = 100;
}

void radiogroup_callback(int i)
{
  //printf("radiogroup_callback> %d", i);
  servertype = i;
}

void team_select_callback(int i)
{
  //printf("radiogroup_callback> %d", i);
  myteamcolor = i;
}

void listbox1_callback(int i, char *c)
{
 //printf("listbox1_callback> %d %s", i, c);
 sprintf(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, c);
}

void uplist_callback()
{
 //printf("upp %d\n", m.search_paper(70)->search_listbox(ID_GM_LBOX)->index);
 if(m.search_paper(70)->search_listbox(ID_GM_LBOX)->index > 0)
 m.search_paper(70)->search_listbox(ID_GM_LBOX)->index--;   
}

void downlist_callback()
{
 //printf("downn %d\n", m.search_paper(70)->search_listbox(ID_GM_LBOX)->index);
 if(m.search_paper(70)->search_listbox(ID_GM_LBOX)->index+m.search_paper(70)->search_listbox(ID_GM_LBOX)->showing < m.search_paper(70)->search_listbox(ID_GM_LBOX)->items.size())
 m.search_paper(70)->search_listbox(ID_GM_LBOX)->index++;   
}

void set_sp_mode()
{
  sp_or_mp = SINGLEP;
}

void set_mp_mode()
{
  sp_or_mp = MULTIP;
}

bool is_good_ip(char *ip)
{
  int nofbodiek = 0;
  int cislo1 = 0; 
  int cislo2 = 0; 
  int cislo3 = 0; 
  int cislo4 = 0; 
  int n = 0;
  int i;
  //printf("\n\n ipcka: %s\n\n", ip);
  for(i = 0; i < 15; i++)
  {
    if(ip[i] == '.'){nofbodiek++;break;}
    if(ip[i] == '\0')break;
    if(ip[i] >= '0' && ip[i] <= '9') {cislo1 *= 10; cislo1 += ip[i]-48;}
  }
  n = i+1;
  for(i = n; i < 15; i++)
  {
    if(ip[i] == '.'){nofbodiek++;break;}
    if(ip[i] == '\0')break;
    if(ip[i] >= '0' && ip[i] <= '9') {cislo2 *= 10; cislo2 += ip[i]-48;}
  }
  n = i+1;
  for(i = n; i < 15; i++)
  {
    if(ip[i] == '.'){nofbodiek++;break;}
    if(ip[i] == '\0')break;
    if(ip[i] >= '0' && ip[i] <= '9') {cislo3 *= 10; cislo3 += ip[i]-48;}
  }
  n = i+1;
  for(i = n; i < 15; i++)
  {
    if(ip[i] == '.'){nofbodiek++;break;}
    if(ip[i] == '\0')break;
    if(ip[i] >= '0' && ip[i] <= '9') {cislo4 *= 10; cislo4 += ip[i]-48;}
  }
  //printf("cisla: %d %d %d %d %d", cislo1, cislo2, cislo3, cislo4, nofbodiek);
  if(cislo1 < 256 && cislo2 < 256 && cislo3 < 256 && cislo4 < 256 && nofbodiek == 3)
    return true;
  else return false;
}

int init_and_connect()
{
  if(client.init_ws() == 0)
  {
    printf("SOME HORRIBLE ERROR KILLED OUR WINSOCK..\n");
    return 0;
  }
  if(servertype == ID_SRV_OG)
  {
    client.select_server("87.197.129.185", "25560");
    sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "CONNECTING...");
    RenderFunc();
  }
  else if(servertype == ID_SRV_DANO)
  {
    client.select_server("87.197.130.210", "25560");
    sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "CONNECTING...");
    RenderFunc();
  }
  else if(servertype == ID_SRV_LAN)
  {
    if(is_good_ip(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text))
    {
      client.select_server(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "25560");
      sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "CONNECTING...");
      RenderFunc();
    }
    else {sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "wrong IP");return 0;}
  }
    
  if(client.connect_to_server() == 0)
  {
    printf("connecting to our server FAILed.\n");
    sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "FAILED");
    return 0;
  }
  else return 1;
}

void refresh_callback();

void create_acc_callback()
{
// client sa v hre ale nesmie snazit initnut na zaciatku, ale az ked bude chiet hrat MP
  //MessageBox(NULL, "kkot", "pnis", MB_OK);
  
  m.active_paper = 60;
  if(init_and_connect())
  {
    m.active_paper = 70;
    BUFFER buffer;
    sprintf(buffer.buffer, "01%s?%s?", m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, m.search_paper(60)->search_textbox(ID_SRV_PWD)->text);
    //printf("[%s]\n", buffer.buffer);
    client.dl_send(buffer.buffer);
    while(1)
    {
      client.dl_recv();
      if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '1' && client.recvbuffer[2] != '-')
      {
        client.ID += 10*client.recvbuffer[2]-48;
        client.ID += client.recvbuffer[3]-48;
        refresh_callback();
        memset(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_NAME)->cursor = 0;
        memset(m.search_paper(70)->search_textbox(ID_GM_PWD)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_NICK)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_PWD)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->cursor = 0;
        break;
      }
      if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '1' && client.recvbuffer[2] == '-')
      {
        m.active_paper = 60;
        client.disconnect();
        client.deinit_ws();
        sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "FAILED");
        break;
      }
    }
  }
  else m.active_paper = 60;
}

void login_callback()
{
// client sa v hre ale nesmie snazit initnut na zaciatku, ale az ked bude chiet hrat MP
  
  m.active_paper = 60;
  if(init_and_connect())
  {
    m.active_paper = 70;
    BUFFER buffer;
    sprintf(buffer.buffer, "02%s?%s?", m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, m.search_paper(60)->search_textbox(ID_SRV_PWD)->text);
    client.dl_send(buffer.buffer);
    while(1)
    {
      client.dl_recv();
      if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '2' && client.recvbuffer[2] == '1')
      {
        client.ID += 10*client.recvbuffer[2]-48;
        client.ID += client.recvbuffer[3]-48;
        memset(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_NAME)->cursor = 0;
        memset(m.search_paper(70)->search_textbox(ID_GM_PWD)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_NICK)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_PWD)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->cursor = 0;
        break;
      }
      if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '2' && client.recvbuffer[2] == '0')
      {
        m.active_paper = 60;
        client.disconnect();
        client.deinit_ws();
        sprintf(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, "FAILED");
        break;
      }
    }
  }
  else m.active_paper = 60;
}

void join_callback()
{
  BUFFER b;
  sprintf(b.buffer, "05%s?%s?", m.search_paper(70)->search_textbox(ID_GM_NAME)->text, m.search_paper(70)->search_textbox(ID_GM_PWD)->text);
  client.dl_send(b.buffer);
  while(1)
  {
    client.dl_recv();
    if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '4' && client.recvbuffer[2] == '1')
    {
      //printf("\n\nWOO, JOINT ROOM\n\n");
        memset(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_NAME)->cursor = 0;
        memset(m.search_paper(70)->search_textbox(ID_GM_PWD)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_NICK)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_PWD)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->cursor = 0;
        client.dl_send("12");
        set_levelmp_dano();
      break;
    }
    if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '4' && client.recvbuffer[2] == '0')
    {
      //printf("\n\nHUH, DIDNT JOINT ROOM\n\n");
      break;
    }
  }
}

void create_game_callback()
{
  BUFFER b;
  sprintf(b.buffer, "04%s?%s?", m.search_paper(70)->search_textbox(ID_GM_NAME)->text, m.search_paper(70)->search_textbox(ID_GM_PWD)->text);
  client.dl_send(b.buffer);
  while(1)
  {
    client.dl_recv();
    if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '3' && client.recvbuffer[2] != '-')
    {
      //printf("\n\nWOO, CREATED ROOM\n\n");
        memset(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_NAME)->cursor = 0;
        memset(m.search_paper(70)->search_textbox(ID_GM_PWD)->text, '\0', 1024);
        m.search_paper(70)->search_textbox(ID_GM_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_NICK)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_PWD)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_PWD)->cursor = 0;
        memset(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, '\0', 1024);
        m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->cursor = 0;
        client.dl_send("12");
        set_levelmp_dano();
      break;
    }
    if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '3' && client.recvbuffer[2] == '-')
    {
      //printf("\n\nHUH, DIDNT CREATE ROOM\n\n");
      break;
    }
  }
}

void logout_callback()
{
  memset(m.search_paper(70)->search_textbox(ID_GM_NAME)->text, '\0', 1024);
  m.search_paper(70)->search_textbox(ID_GM_NAME)->cursor = 0;
  memset(m.search_paper(70)->search_textbox(ID_GM_PWD)->text, '\0', 1024);
  m.search_paper(70)->search_textbox(ID_GM_PWD)->cursor = 0;
  memset(m.search_paper(60)->search_textbox(ID_SRV_NICK)->text, '\0', 1024);
  m.search_paper(60)->search_textbox(ID_SRV_NICK)->cursor = 0;
  memset(m.search_paper(60)->search_textbox(ID_SRV_PWD)->text, '\0', 1024);
  m.search_paper(60)->search_textbox(ID_SRV_PWD)->cursor = 0;
  memset(m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->text, '\0', 1024);
  m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->cursor = 0;
  client.dl_send("06");
  client.disconnect();
  client.deinit_ws();
}

void refresh_callback()
{
  client.dl_send("07");
  BUFFER b;
  char nazov[128];
  /*
  07 - refresh nof roomz    07
  08 - get name of room     08ID[2]
  55 - nof roomz            55int[2]
  56 - name of room         56nazov?
  */
  int nofroomz = 0;
  while(1)
  {
    client.dl_recv();
    if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '5')
    {
      nofroomz += (client.recvbuffer[2]-48)*10;
      nofroomz += client.recvbuffer[3]-48;
      m.search_paper(70)->search_listbox(ID_GM_LBOX)->items.clear();
      cur_rmlbx_id = 50011;
      for(int i = 0; i < nofroomz; i++)
      {
        sprintf(b.buffer, "08%d%d", i/10, i%10);
        client.dl_send(b.buffer);
        while(1)
        {
          client.dl_recv();
          if(client.recvbuffer[0] == '5' && client.recvbuffer[1] == '6')
          {
            memset(nazov, '\0', 128);
            for(int k = 2; k < 128; k++)
            {
              if(client.recvbuffer[k] != '?' && client.recvbuffer[k] != '\0')
                nazov[k-2] = client.recvbuffer[k];
              else
              {
                nazov[k-2] = '\0';
                break;
              }
            }
            m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(cur_rmlbx_id, nazov);
            cur_rmlbx_id++;
            break;
          }
        }
      }
      if(nofroomz > 0)m.search_paper(70)->search_listbox(ID_GM_LBOX)->items.begin()->selected = true;
      break;
    }
  }
}

#define BUTTON_SINGLEPLAYER 1000
#define BUTTON_MULTIPLAYER  1001
#define BUTTON_SETTINGS     1002
#define BUTTON_CREDITS      1003
#define BUTTON_HELP         1004
#define BUTTON_EXIT         1005

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  hge = hgeCreate(HGE_VERSION);
  hge->System_SetState(HGE_FPS, 100);
  hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);
  hge->System_SetState(HGE_RENDERFUNC, RenderFunc);
  hge->System_SetState(HGE_WINDOWED, false);
  hge->System_SetState(HGE_USESOUND, true);
  hge->System_SetState(HGE_GFXRESTOREFUNC, GfxRestoreFunc);
  hge->System_SetState(HGE_TITLE, "spongia 08");
  hge->System_SetState(HGE_SCREENWIDTH, 1024);
  hge->System_SetState(HGE_SCREENHEIGHT, 768);
  hge->System_SetState(HGE_SCREENBPP, 32);
  hge->System_SetState(HGE_SHOWSPLASH, false);
  
  memset(laplas,0,sizeof(laplas));
	memset(vel,0,sizeof(laplas));
	memset(arr,0,sizeof(laplas));
	
	hge->Random_Seed();
	
  atexit(ExitFunc);
  if (signal(SIGABRT,SIGFunc)==SIG_IGN) signal (SIGABRT,SIG_IGN);
  if (signal(SIGSEGV,SIGFunc)==SIG_IGN) signal (SIGSEGV,SIG_IGN);
  if (signal(SIGFPE,SIGFunc)==SIG_IGN)  signal (SIGFPE,SIG_IGN);
  if (signal(SIGILL,SIGFunc)==SIG_IGN)  signal (SIGILL,SIG_IGN);
  if (signal(SIGINT,SIGFunc)==SIG_IGN)  signal (SIGINT,SIG_IGN);
  if (signal(SIGTERM,SIGFunc)==SIG_IGN) signal (SIGTERM,SIG_IGN);
  //      SIGABRT, SIGSEGV
  if(hge->System_Initiate())
  {
    //hudba
    hsluka = hge->Stream_Load("snd/luka.mp3");
    hsles = hge->Stream_Load("snd/les.mp3");
    hsjaskyna = hge->Stream_Load("snd/jaskyna.mp3");
    hsplaz = hge->Stream_Load("snd/plaz.mp3");
    hszamok = hge->Stream_Load("snd/zamok.mp3");
    hssopka = hge->Stream_Load("snd/sopka.mp3");
    hstheme = hge->Stream_Load("snd/intro.mp3");
    ///init menu
    targo = hge->Target_Create(1024,768,false);
      dis=new hgeDistortionMesh(nCols, nRows);
      dis->SetTexture(hge->Target_GetTexture(targo));
      dis->SetTextureRect(0,0,1024,768);
      dis->SetBlendMode(BLEND_COLORADD | BLEND_ALPHABLEND | BLEND_ZWRITE);
      dis->Clear(0xFF000000);                         
     
     mouse = dl_util_makeHgeQuad(hge, 0, 0, 32, 32, 0xffffffff, "images/mouse.png");                         
                              
    fnt = new hgeFont("font1.fnt");
    m.link_hge(hge);
    //m.init_mouse("images/mouse.png", 0,0);
    //m.init_mouse_particle("menumouse.psi", "images/particles.png", 0, 0, 32, 32, 0, 0);
    
    
    
    m.add_paper(10);
    m.search_paper(10)->set_background("images/menu_bg.png");
    //m.search_paper(10)->add_particle("menumouse.psi", "images/particles.png", 0, 0, 32, 32, 0, 0, 10, PAR_FIRE_ON_START);

    m.search_paper(10)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,set_sp_mode);
    m.search_paper(10)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    //m.search_paper(10)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,60,set_mp_mode);
    //m.search_paper(10)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(10)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(10)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(10)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(10)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    
    
    
    
    m.add_paper(20);
    m.search_paper(20)->bg = m.search_paper(10)->bg;
    
    m.search_paper(20)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,set_sp_mode);
    m.search_paper(20)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    //m.search_paper(20)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,60,set_mp_mode);
    //m.search_paper(20)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(20)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(20)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(20)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(20)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    m.search_paper(20)->add_bitmap(9678);
    m.search_paper(20)->search_bitmap(9678)->set_xywh(80, 240, 512, 512);
    m.search_paper(20)->search_bitmap(9678)->set_bitmap("images/menuHelp.png");
    
    
    m.add_paper(30);
    m.search_paper(30)->bg = m.search_paper(10)->bg;
    
    m.search_paper(30)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,set_sp_mode);
    m.search_paper(30)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    //m.search_paper(30)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,60,set_mp_mode);
    //m.search_paper(30)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(30)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(30)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(30)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(30)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    m.search_paper(30)->add_bitmap(9678);
    m.search_paper(30)->search_bitmap(9678)->set_xywh(80, 240, 512, 512);
    m.search_paper(30)->search_bitmap(9678)->set_bitmap("images/menuCredits.png");
    
    m.add_paper(40);
    m.search_paper(40)->bg = m.search_paper(10)->bg;
    
    m.search_paper(40)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,set_sp_mode);
    m.search_paper(40)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    //m.search_paper(40)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,60,set_mp_mode);
    //m.search_paper(40)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(40)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(40)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(40)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(40)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    
    m.search_paper(40)->add_slider(80, 465, 512, 16, 34, soundslider_callback);
    m.search_paper(40)->search_slider(34)->set_data(0, 512, 256);
    m.search_paper(40)->search_slider(34)->set_bitmaps("images/menu_sliderhead.png", "images/menu_slider.png", 64, 64);
    
    m.search_paper(40)->add_slider(80, 365, 512, 16, 35, musicslider_callback);
    m.search_paper(40)->search_slider(35)->set_data(0, 512, 256);
    m.search_paper(40)->search_slider(35)->set_bitmaps("images/menu_sliderhead.png", "images/menu_slider.png", 64, 64);
    
    
    m.search_paper(40)->add_checkbox(460,545,32,32,121, set_godlike_mode);// x 460 y 545
    m.search_paper(40)->search_checkbox(121)->set_bitmaps("images/menu_checkbox_actif.png", "images/menu_checkbox_unact.png");
    
    m.search_paper(40)->add_bitmap(5656);
    m.search_paper(40)->search_bitmap(5656)->set_xywh(269,305,124, 31);
    m.search_paper(40)->search_bitmap(5656)->set_bitmap("images/menusetmusic.png");

    m.search_paper(40)->add_bitmap(5757);
    m.search_paper(40)->search_bitmap(5757)->set_xywh(260,410,148,30);
    m.search_paper(40)->search_bitmap(5757)->set_bitmap("images/menusetsound.png");
    
    m.search_paper(40)->add_bitmap(5858);
    m.search_paper(40)->search_bitmap(5858)->set_xywh(145,545,299,31);
    m.search_paper(40)->search_bitmap(5858)->set_bitmap("images/menusetgodli.png");
    
    /*m.search_paper(10)->add_button(10,10,128,32,101,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(10)->search_button(101)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(10)->add_button(50,50,128,32,102,BUTT_TYPE_WAY,20,boopy);
    m.search_paper(10)->search_button(102)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_button(450,300,128,32,103,BUTT_TYPE_PROC,10,pridaj_item);
    m.search_paper(10)->search_button(103)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_button(450+128+35,300,128,32,104,BUTT_TYPE_PROC,10,odober_item);
    m.search_paper(10)->search_button(104)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_checkbox(500,10,32,32,121, boolpy);
    m.search_paper(10)->search_checkbox(121)->set_bitmaps("images/checked.png", "images/unchecked.png");
    m.search_paper(10)->set_background("images/menu_bg.png");
    m.search_paper(10)->add_radiogroup(400, 400, 50, ID_RADIOGROUP, radiogroup_callback);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_FIRSTBUTTON, 32, 32);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_SECONDBUTTON, 32, 32);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_THIRDBUTTON, 32, 32);
    m.search_paper(10)->add_slider(200, 550, 256, 64, ID_SLIDER, slider_callback);
    m.search_paper(10)->search_slider(ID_SLIDER)->set_data(0, 255, 128);
    m.search_paper(10)->search_slider(ID_SLIDER)->set_bitmaps("images/vlak.png", "images/kolajnica.png", 16, 64);
    
    m.search_paper(10)->add_listbox(623, 93,  258, 208, ID_LISTBOX1, 32, listbox1_callback);
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_buttons("images/button_normal.png", "images/button_hover.png", "images/button_normal.png", "images/button_hover.png");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_font("fonts/font2.fnt");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_bitmap("images/button_normal.png", "momo", "images/slider_kolajnica.png");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->up.way = 10; //paper id 1, must be the one, where is the listbox
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->down.way = 10; //paper id 1, too
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->up.proc = uplist_callback;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->down.proc = downlist_callback;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->showing = 7;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(5001, "ahoj");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50012, "ahoj2");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50013, "ahoj3");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50014, "ahoj4");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->items.begin()->selected = true; //ak si prave nakodil menu a divis sa, preco to v listboxe pada, pravdepodobne si zabudol tento riadok. teda preco to pada, ked user na nic neklikne a defaultne oznaci OK... dano> 19.septembra, 23:37
    m.search_paper(10)->add_textbox(600, 600, ID_TEXTBOX);
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->set_font("fonts/font1.fnt");
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->type = NORMAL;
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->maxchar = 5;
    
    */
    /*
    m.add_paper(60);
    m.search_paper(60)->bg = m.search_paper(10)->bg;
    
    m.search_paper(60)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,set_sp_mode);
    m.search_paper(60)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    m.search_paper(60)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,60,set_mp_mode);
    m.search_paper(60)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(60)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(60)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(60)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(60)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(60)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(60)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(60)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(60)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    //serverchoose.png            / x  80 y 240 (512x256)
    m.search_paper(60)->add_bitmap(7771);
    m.search_paper(60)->search_bitmap(7771)->set_xywh(80,240,512, 256);
    m.search_paper(60)->search_bitmap(7771)->set_bitmap("img/serverchoose.png");
    //nopassreq.png               / x  80 y 590 (512x64)
    m.search_paper(60)->add_bitmap(7772);
    m.search_paper(60)->search_bitmap(7772)->set_xywh(80,590,512, 64);
    m.search_paper(60)->search_bitmap(7772)->set_bitmap("img/nopassreq.png");
    /*
      textbox.png                 / x 295 y 355 (224*32)
      textbox.png                 / x 330 y 412 (224*32)
      textbox.png                 / x 330 y 465 (224*32)
    *//*
    m.search_paper(60)->add_bitmap(7773);
    m.search_paper(60)->search_bitmap(7773)->set_xywh(295,355,224, 32);
    m.search_paper(60)->search_bitmap(7773)->set_bitmap("img/textbox.png");
    m.search_paper(60)->add_bitmap(7774);
    m.search_paper(60)->search_bitmap(7774)->set_xywh(330,412,224, 32);
    m.search_paper(60)->search_bitmap(7774)->set_bitmap("img/textbox.png");
    m.search_paper(60)->add_bitmap(7775);
    m.search_paper(60)->search_bitmap(7775)->set_xywh(330,465,224, 32);
    m.search_paper(60)->search_bitmap(7775)->set_bitmap("img/textbox.png");
    
    m.search_paper(60)->add_textbox(300, 355, 220, 32, ID_SRV_IPBOX);
    m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->set_font("fonts/menufont.fnt");
    m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->type = IPBOX;
    m.search_paper(60)->search_textbox(ID_SRV_IPBOX)->maxchar = 15;
    m.search_paper(60)->add_textbox(335, 412, 220, 32, ID_SRV_NICK);
    m.search_paper(60)->search_textbox(ID_SRV_NICK)->set_font("fonts/menufont.fnt");
    m.search_paper(60)->search_textbox(ID_SRV_NICK)->type = NORMAL;
    m.search_paper(60)->search_textbox(ID_SRV_NICK)->maxchar = 8;
    m.search_paper(60)->add_textbox(335, 465, 220, 32, ID_SRV_PWD);
    m.search_paper(60)->search_textbox(ID_SRV_PWD)->set_font("fonts/menufont.fnt");
    m.search_paper(60)->search_textbox(ID_SRV_PWD)->type = PASSWD;
    m.search_paper(60)->search_textbox(ID_SRV_PWD)->maxchar = 20;
    /*
menu_radiobut_unact.png     / x 187 y 285 (32*32)
menu_radiobut_unact.png     / x 187 y 320 (32*32) 
menu_radiobut_unact.png     / x 187 y 255 (32*32) 
login.png                   / x 170 y 505 (225*90)
createacc.png               / x 395 y 525 (125*55)
    *//*
    m.search_paper(60)->add_button(395,525,125,55,ID_SRV_CREAT,BUTT_TYPE_WAY,70,create_acc_callback);
    m.search_paper(60)->search_button(ID_SRV_CREAT)->set_bitmaps("img/createacc.png","img/createacc_g.png");
    
    m.search_paper(60)->add_button(170,505,225,90,ID_SRV_LOGIN,BUTT_TYPE_WAY,70,login_callback);
    m.search_paper(60)->search_button(ID_SRV_LOGIN)->set_bitmaps("img/login.png","img/login_g.png");
    
    m.search_paper(60)->add_radiogroup(187, 285, 35, ID_RADIOGROUP, radiogroup_callback);
    m.search_paper(60)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", ID_SRV_OG, 32, 32);
    m.search_paper(60)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", ID_SRV_DANO, 32, 32);
    m.search_paper(60)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", ID_SRV_LAN, 32, 32);
    m.search_paper(60)->search_radiogroup(ID_RADIOGROUP)->radiobuttons.begin()->trigger = true;
    servertype = ID_SRV_OG;
    
    /*
    gamechoose.png              / x  80 y 240 (512x230)
gamechoosetwo.png           / x  80 y 470 (512x128)
textbox.png                 / x 340 y 480 (224*32)
textbox.png                 / x 340 y 535 (224*32)
arrowup.png                 / x 515 y 280 (32*32)
arrowdown.png               / x 515 y 410 (32*32)
join.png                    / x 210 y 570 (155*90)
creategame.png              / x 365 y 585 (128*60)
    *//*
    m.add_paper(70);
    m.search_paper(70)->bg = m.search_paper(10)->bg;
    
    m.search_paper(70)->add_bitmap(7773);
    m.search_paper(70)->search_bitmap(7773)->set_xywh(80,240,512, 230);
    m.search_paper(70)->search_bitmap(7773)->set_bitmap("img/gamechoose.png");
    m.search_paper(70)->add_bitmap(7774);
    m.search_paper(70)->search_bitmap(7774)->set_xywh(80,470,512, 128);
    m.search_paper(70)->search_bitmap(7774)->set_bitmap("img/gamechoosetwo.png");
    
    m.search_paper(70)->add_button(210,570,155,90,ID_GM_JOIN,BUTT_TYPE_PLAY,70,join_callback);
    m.search_paper(70)->search_button(ID_GM_JOIN)->set_bitmaps("img/join.png","img/join_g.png");
    
    m.search_paper(70)->add_button(365,585,128,60,ID_GM_CREAT,BUTT_TYPE_PLAY,70,create_game_callback);
    m.search_paper(70)->search_button(ID_GM_CREAT)->set_bitmaps("img/creategame.png","img/creategame_g.png");
    /*refresh.png                 / x 298 y 432 (116*24)
      logout.png                  / x 420 y 680 (185*60)*/
    /*m.search_paper(70)->add_button(420,680,185,60,ID_GM_LOGOUT,BUTT_TYPE_WAY,60,logout_callback);
    m.search_paper(70)->search_button(ID_GM_LOGOUT)->set_bitmaps("img/logout.png","img/logout_g.png");
    
    m.search_paper(70)->add_button(298,432,116,24,ID_GM_REFRESH,BUTT_TYPE_WAY,70,refresh_callback);
    m.search_paper(70)->search_button(ID_GM_REFRESH)->set_bitmaps("img/refresh.png","img/refresh_g.png");
    
    m.search_paper(70)->add_bitmap(7775);
    m.search_paper(70)->search_bitmap(7775)->set_xywh(340,480,224, 32);
    m.search_paper(70)->search_bitmap(7775)->set_bitmap("img/textbox.png");
    m.search_paper(70)->add_bitmap(7776);
    m.search_paper(70)->search_bitmap(7776)->set_xywh(340,535,224, 32);
    m.search_paper(70)->search_bitmap(7776)->set_bitmap("img/textbox.png");
    
    m.search_paper(70)->add_textbox(345, 480, 220, 32, ID_GM_NAME);
    m.search_paper(70)->search_textbox(ID_GM_NAME)->set_font("fonts/menufont.fnt");
    m.search_paper(70)->search_textbox(ID_GM_NAME)->type = NORMAL;
    m.search_paper(70)->search_textbox(ID_GM_NAME)->maxchar = 8;
    m.search_paper(70)->add_textbox(345, 535, 220, 32, ID_GM_PWD);
    m.search_paper(70)->search_textbox(ID_GM_PWD)->set_font("fonts/menufont.fnt");
    m.search_paper(70)->search_textbox(ID_GM_PWD)->type = PASSWD;
    m.search_paper(70)->search_textbox(ID_GM_PWD)->maxchar = 20;
    
    m.search_paper(70)->add_listbox(80+80+15, 280,  258+80, 208-32-35, ID_GM_LBOX, 32, listbox1_callback);
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->set_buttons("img/arrowup.png", "img/arrowup.png", "img/arrowdown.png", "img/arrowdown.png");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->set_font("fonts/menufont.fnt");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->set_bitmap("images/button_normal.png", "momo", "images/slider_kolajnica.png");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->up.way = 70; //paper id 1, must be the one, where is the listbox
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->down.way = 70; //paper id 1, too
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->up.proc = uplist_callback;
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->down.proc = downlist_callback;
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->showing = 5;
    
    m.search_paper(70)->add_radiogroup(587, 285, 35, ID_RADIOGROUP, team_select_callback);
    m.search_paper(70)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", RED_TEAM, 32, 32);
    m.search_paper(70)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", BLUE_TEAM, 32, 32);
    m.search_paper(70)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("img/menu_radiobut_actif.png", "img/menu_radiobut_unact.png", ROGUE, 32, 32);
    m.search_paper(70)->search_radiogroup(ID_RADIOGROUP)->radiobuttons.begin()->trigger = true;
    myteamcolor = RED_TEAM;
    
    /*m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(5001, "ahoj");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50012, "ahoj2");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50013, "ahoj3");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50014, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50015, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50016, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50017, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50018, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50019, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50020, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50021, "ahoj4");
    m.search_paper(70)->search_listbox(ID_GM_LBOX)->add_item(50022, "ahoj4");*/
    //m.search_paper(70)->search_listbox(ID_GM_LBOX)->items.begin()->selected = true; //ak si prave nakodil menu a divis sa, preco to v listboxe pada, pravdepodobne si zabudol tento riadok. teda preco to pada, ked user na nic neklikne a defaultne oznaci OK... dano> 19.septembra, 23:37
    
    
    
    m.add_paper(50);
    m.search_paper(50)->set_background("images/mapa.png");
    
    m.search_paper(50)->add_button(0,675,240,93,200,BUTT_TYPE_WAY,10,NULL);
    m.search_paper(50)->search_button(200)->set_bitmaps("images/mapback.png","images/mapback_g.png");
    
    
    m.search_paper(50)->add_button(205,125,45,43,201,BUTT_TYPE_PLAY,0,set_level0);
    m.search_paper(50)->search_button(201)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(323,147,45,43,202,BUTT_TYPE_PLAY,0,set_level1);
    m.search_paper(50)->search_button(202)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(426,189,45,43,203,BUTT_TYPE_PLAY,0,set_level2);
    m.search_paper(50)->search_button(203)->set_bitmaps("images/normal.png","images/hover.png");
    
    //m.search_paper(50)->add_button(475,190,45,43,204,BUTT_TYPE_PLAY,0,set_level3);
    //m.search_paper(50)->search_button(204)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(530,225,45,43,204,BUTT_TYPE_PLAY,0,set_level3);
    m.search_paper(50)->search_button(204)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(490,273,45,43,205,BUTT_TYPE_PLAY,0,set_level4);
    m.search_paper(50)->search_button(205)->set_bitmaps("images/normal.png","images/hover.png");
    
    //m.search_paper(50)->add_button(615,290,45,43,207,BUTT_TYPE_PLAY,0,set_level6);
    //m.search_paper(50)->search_button(207)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(601,307,45,43,206,BUTT_TYPE_PLAY,0,set_level5);
    m.search_paper(50)->search_button(206)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(450,335,45,43,207,BUTT_TYPE_PLAY,0,set_level6);
    m.search_paper(50)->search_button(207)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(360,350,45,43,208,BUTT_TYPE_PLAY,0,set_level7);
    m.search_paper(50)->search_button(208)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(257,396,45,43,209,BUTT_TYPE_PLAY,0,set_level8);
    m.search_paper(50)->search_button(209)->set_bitmaps("images/normal.png","images/hover.png");

    //m.search_paper(50)->add_button(255,430,45,43,212,BUTT_TYPE_PLAY,0,set_level11);
    //m.search_paper(50)->search_button(212)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(300,490,45,43,210,BUTT_TYPE_PLAY,0,set_level9);
    m.search_paper(50)->search_button(210)->set_bitmaps("images/normal.png","images/hover.png");

    //m.search_paper(50)->add_button(350,595,45,43,214,BUTT_TYPE_PLAY,0,set_level13);
    //m.search_paper(50)->search_button(214)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(445,625,45,43,211,BUTT_TYPE_PLAY,0,set_level10);
    m.search_paper(50)->search_button(211)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(446,477,45,43,212,BUTT_TYPE_PLAY,0,set_level11);
    m.search_paper(50)->search_button(212)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(552,510,45,43,213,BUTT_TYPE_PLAY,0,set_level12);
    m.search_paper(50)->search_button(213)->set_bitmaps("images/normal.png","images/hover.png");
    
    //m.search_paper(50)->add_button(585,550,45,43,218,BUTT_TYPE_PLAY,0,set_level17);
    //m.search_paper(50)->search_button(218)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(625,605,45,43,214,BUTT_TYPE_PLAY,0,set_level13);
    m.search_paper(50)->search_button(214)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(750,650,45,43,215,BUTT_TYPE_PLAY,0,set_level14);
    m.search_paper(50)->search_button(215)->set_bitmaps("images/normal.png","images/hover.png");
    /*m.search_paper(20)->add_button(500,500,128,32,201,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(20)->search_button(201)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(20)->add_button(50,50,128,32,202,BUTT_TYPE_WAY,10,boopy);
    m.search_paper(20)->search_button(202)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(20)->set_background(NULL, 0xffff9600);
    m.search_paper(20)->add_bitmap(ID_BITMAP);
    m.search_paper(20)->search_bitmap(ID_BITMAP)->set_xywh(800, 200, 128, 64);
    m.search_paper(20)->search_bitmap(ID_BITMAP)->set_bitmap("images/bitmap.png");
    */
    
    
    
    
    
    
    hudba = hge->Stream_Play(hstheme, true);
    ///init game
    fnt = new hgeFont("font1.fnt");
    font = new hgeFont("fonts/menufont.fnt");
    moonwalk = hge->Effect_Load("snd/moonwalk.mp3");
    mw = dl_util_makeHgeQuad(hge, 256, 320, 512, 128, 0xffffffff, "img/moonwalk.png");
  
    HTEXTURE texmw = hge->Texture_Load("img/particles.png");
    mw_spr = new hgeSprite(texmw, 32, 32, 32, 32);
    mw_spr->SetColor(0xffffffff);
    mw_spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
    mwpar = new hgeParticleSystem("par/moonwalk.psi", mw_spr);
  
    lvl.hgge = hge;
    
    dist.init(hge, "images/welovefood.png", 512-400,384-300,800,600,5.0);
    
    hge->System_Start();
  }
  hge->System_Shutdown();
  hge->Release();
  
  
  printf("smrt blenderu");
  printf("%csanto je zly koder", '\n');
  return 0;
}
