#include "potion.h"

POTION::POTION()
{
  x = -32;
  y = -32;
  type = 0;
  ID = -1;
  potion = 0;
}
POTION::~POTION()
{
  
}

int POTION::init(HGE *nhge, char *filename, float x, float y, int type, int potion)
{
  hgge = nhge;
  this->x = x;
  this->y = y;
  this->type = type;
  this->potion = potion;
  startpotion = potion;
  potionquad = dl_util_makeHgeQuad(hgge, x, y, 32, 32, 0xffffffff, filename);
}

int POTION::manage()
{
  
}

int POTION::draw(float cl)
{
  if((x-cl) > -32 && (x-cl) < 1024)
  {
    if(potion > 0)
    {
      //[20:40:33] Milan pe: mwhhahahaha killall Garage Band
      potionquad->v[0].x = x-cl;    potionquad->v[0].y = y;
      potionquad->v[1].x = x-cl+32; potionquad->v[1].y = y;
      potionquad->v[2].x = x-cl+32; potionquad->v[2].y = y+32;
      potionquad->v[3].x = x-cl;    potionquad->v[3].y = y+32;
      hgge->Gfx_RenderQuad(potionquad);
    }
  }
}
