#include "dl_hge_slider.h"

SLIDER::SLIDER(HGE *h)
{
  m_hge = h;
  in_action = 0;
  //printf("urobil som slider\n");
}


SLIDER::~SLIDER()
{
  //printf("zrusil som slider\n");
}

int SLIDER::set_data(int nmin, int nmax, int nvalue)
{
 min = nmin;
 max = nmax;
 value = nvalue;
 
 return 1;                    
}

int SLIDER::set_bitmaps(char *svlak, char *skolajnica, int nvlak_w, int vlak_h)
{
  vlak        = *dl_util_makeHgeQuad(m_hge, x+value, y-16, nvlak_w, vlak_h, 0xffffffff, svlak);
  kolajnica   = *dl_util_makeHgeQuad(m_hge, x, y, w, h, 0xffffffff, skolajnica);
  vlak_w = nvlak_w;
  return 1;
}

int SLIDER::draw()
{
 m_hge->Gfx_RenderQuad(&kolajnica);
 m_hge->Gfx_RenderQuad(&vlak);

 return 1;
}

int SLIDER::manage()
{
 float mouse_x, mouse_y;
 
 if(mir(m_hge, x+value+10, (y-10), x+vlak_w+value-18, (y+h+20), 1))
 {
  in_action = 1;
  m_hge->Input_GetMousePos(&mouse_x,&mouse_y);
  rozdiel = mouse_x - x - value;
  //printf("rozdiel> %d>>>", rozdiel);
 }
 if(in_action)
 {
  m_hge->Input_GetMousePos(&mouse_x,&mouse_y);
  if(mouse_y > (y-10) && mouse_y < (y+h+20))
  {
   if(mouse_x < x)value = min;
   else if(mouse_x > x+w)value = max;  
   else value = mouse_x - x;
  
   value-=rozdiel;
  
   vlak.v[0].x = x+value;
   vlak.v[1].x = x+value+vlak_w;
   vlak.v[2].x = x+value+vlak_w;
   vlak.v[3].x = x+value;
  
   proc(value);
  }            
 }
 if(in_action && m_hge->Input_GetKeyState(HGEK_LBUTTON) == false)in_action = 0;
 return 1;    
}
