#include "dl_hge_textbox.h"

TEXTBOX::TEXTBOX(HGE *nhge)
{
 hgge = nhge;
 int i;
 cursor = 0;
 shftprssd = 0;
 memset(text, '\0', 1024);
 active = 0;
 
 //printf("mame textbox\n");                  
}

TEXTBOX::~TEXTBOX()
{
 //printf("smola, nemame uz textbox");                   
}

int TEXTBOX::set_font(char *fontfilename)
{
 fnt = new hgeFont(fontfilename);
    
 fnt->SetColor(0xff000000);
 return 1;
}

int TEXTBOX::move_from_cursor()
{
 int i;
 for(i = strlen(text)+1; i != cursor; i--)
 {
  text[i] = text[i-1];      
 } 
 
 return i;   
}


int TEXTBOX::draw()
{
 int width;
 int i;
 char pc[1024];
 
 
 if(type == NORMAL || type == IPBOX)
 {
  fnt->printf(x, y, HGETEXT_LEFT, "%s", text);
  memset(pc, '\0', 1024);
  for(i = 0; i < cursor; i++)
  {
   pc[i]=text[i];      
  }
 
  width = fnt->GetStringWidth(pc);
 
  if(active)
    hgge->Gfx_RenderLine(x+width, y, x+width, y+fnt->GetHeight());
 }
 
 
 if(type == PASSWD)
 {
  width =  fnt->GetStringWidth("*") * cursor;
  memset(pc, '\0', 1024);
  for(i = 0; i < strlen(text); i++)
  {
   pc[i]='*';      
  }
  fnt->printf(x, y, HGETEXT_LEFT, "%s", pc);    
  if(active)
    hgge->Gfx_RenderLine(x+width, y, x+width, y+fnt->GetHeight());
 }
 return 1;    
}

int TEXTBOX::manage()
{
 if(hgge->Input_KeyDown(HGEK_SHIFT))shftprssd = 1;
 if(hgge->Input_KeyUp(HGEK_SHIFT))shftprssd = 0;
 int i;
 int k;
 
 
 if(maxchar > strlen(text))
 {
 if(type == NORMAL || type == PASSWD)
 {
  for(i = 0; i < 26; i++)
  {
   if(hgge->Input_GetKey() == i+65)
   {
    k = move_from_cursor();
    text[k] = i+65+32;
    if(shftprssd)text[k] -= 32;
    cursor++;
   }      
  }
 }
 
 if(type == NORMAL)
 {
  if(hgge->Input_GetKey() == HGEK_SPACE)
  {
   k = move_from_cursor();
   text[k] = ' ';
   cursor++;                        
  }
 }
 
 if(type == NORMAL || type == IPBOX)
 {
  if(hgge->Input_GetKey() == HGEK_PERIOD)
  {
   k = move_from_cursor();
   text[k] = '.';
   if(shftprssd && type == NORMAL)text[k] = ':';
   cursor++;                        
  }
 }
 
  if(type == NORMAL)
  {
   if(hgge->Input_GetKey() == HGEK_COMMA)
   {
    k = move_from_cursor();
    text[k] = ',';
    if(shftprssd)text[k] = '?';
    cursor++;                        
   }
  }
 
  if(type == NORMAL)
  {
   if(hgge->Input_GetKey() == HGEK_BACKSLASH)
   {
    if(shftprssd)
    {
     k = move_from_cursor();
     text[k] = ')';
     cursor++;
    }                        
   }
 
   if(hgge->Input_GetKey() == HGEK_RBRACKET)
   {
    if(shftprssd)
    {
     k = move_from_cursor();
     text[k] = '(';
     cursor++;
    }                         
   }
  }
 
  if(type == NORMAL || type == IPBOX)
  {
   for(i = 0; i < 10; i++)
   {
    if(hgge->Input_GetKey() == i+48 || hgge->Input_GetKey() == i+0x60)
    {
     if(!shftprssd)
     {
      k = move_from_cursor();
      text[k] = i+48;
      cursor++;
     }
    }      
   }
  }
 }
  if(hgge->Input_GetKey() == HGEK_LEFT)
  {
   cursor--;
   if(cursor < 0)cursor = 0;                        
  }
 
  if(hgge->Input_GetKey() == HGEK_RIGHT)
  {
   cursor++;  
   if(cursor > strlen(text))cursor = strlen(text);                      
  }
 
  int momo;
 
  if(hgge->Input_GetKey() == HGEK_BACKSPACE && cursor > 0)
  {
   for(momo = cursor-1; momo < strlen(text); momo++)
   {
    text[momo] = text[momo+1];
   }  
   text[strlen(text)] = '\0';
   cursor--;                     
  }
 
  if(hgge->Input_GetKey() == HGEK_DELETE && cursor < strlen(text))
  {
   for(momo = cursor; momo < strlen(text); momo++)
   {
    text[momo] = text[momo+1];
   }  
   text[strlen(text)] = '\0';
  }
 
 return 1;
}    
