#ifndef __DL_ANIM_
#define __DL_ANIM_

#include "fireball.h"

#define MAXFRAME 8.0f


#define ANIM_SEKAC1 1
#define ANIM_SEKAC2 2
#define ANIM_SEKAC3 3

class animation
{
 public:
        animation(HGE *nhge, int nw, int nh);
        ~animation();
        int add_frame(char *filename);
        int set_frame(int new_frame);
        list<hgeQuad*>::iterator get_frame(int frm);
        int draw_at(int x, int y, bool horflip);
        
        int no_frames;
        int current_frame;
        list<hgeQuad*> frames;
        int w, h;
        HGE *hgge;
};

#endif
