#include "arcanespot.h"

ARCANESPOT::ARCANESPOT(HGE *nhge)
{
 hgge = nhge;
 vystreleny = 0;
 t = 0.0f;
 is1 = is2 = 0;
 //printf("mame freeze");                   
}

ARCANESPOT::ARCANESPOT()
{                 
 vystreleny = 0;
 t = 0.0f;
 is1 = is2 = 0;
 //printf("mame freeze");                    
}

ARCANESPOT::~ARCANESPOT()
{
 //printf("nemame freeze");                    
}

int ARCANESPOT::init(HGE *nhge, HTEXTURE tex)
{
  hgge = nhge;
  spr = new hgeSprite(tex, 64, 96, 32, 32);
  spr->SetColor(0xffffffff);
  spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
  par1 = new hgeParticleSystem("par/arcane.psi", spr);    
  par1->info.nEmission = 25;
  par2 = new hgeParticleSystem("par/arcane.psi", spr);    
  par2->info.nEmission = 25;
  //par1->Fire();
  //par2->Fire();
 
  return 1;    
}

int ARCANESPOT::draw(float camleft)
{
  if(is1)
  {
    par1->Transpose(x1 - camleft, y1);
    par1->Render();
  }
  if(is2)
  {
    par2->Transpose(x2 - camleft, y2);
    par2->Render();
  }
  return 1;    
}

int ARCANESPOT::manage()
{
 float dt;
 dt = hgge->Timer_GetDelta();
 par1->Update(dt);  
 par2->Update(dt);  
 if(vystreleny)
 {
    t -= dt;
    if(t <= 0.0f)
    {
      vystreleny = 0;
      par1->Stop();
      par2->Stop();
    }
 }
 else
 {
   if(par1->GetParticlesAlive() == 0)
   {
     par1->Stop(true);
     is1 = false;
   }
   if(par2->GetParticlesAlive() == 0)
   {
     par2->Stop(true);
     is2 = false;
   }
 }
 
 return 1;    
}
