#include "dl_hge_button.h"

BUTTON::BUTTON(HGE *h)
{
  m_hge = h;
  has_hover = 0;
  alpha = 0;
  //printf("umakal som button\n");
  invisible = 0;
}

BUTTON::BUTTON()
{
 has_hover = 0;
 invisible = 0;
 alpha = 0;
 //printf("mame button, alt\n");                
}

BUTTON::~BUTTON()
{
  //printf("zmazal som button\n");
}

int BUTTON::draw()
{
  /*if(has_hover) m_hge->Gfx_RenderQuad(&hover);
  else m_hge->Gfx_RenderQuad(&normal);
  */
  if(!invisible)
  {
    m_hge->Gfx_RenderQuad(&normal);
    m_hge->Gfx_RenderQuad(&hover);
  }
  
  //printf("nakreslil som button %d\n", ID);
  return 1;
}

int BUTTON::manage(int *ap, float delta)
{
  if(!invisible)
  {
    if(mir(m_hge, x, y, x+w, y+h, 0))
    {
      has_hover = true;
      if(!lb_is_pressed() && lb_was_pressed())
      {
        set_lb_unpressed();
        if(type == BUTT_TYPE_PLAY)*ap = -1;
        if(type == BUTT_TYPE_WAY) *ap = way;
        if(type == BUTT_TYPE_EXIT)return 0;
        if(proc != NULL)
        {
          proc();
        }
      }
    }
    else 
    {
      has_hover = false;
    }
    
    if(mir(m_hge, x, y, x+w, y+h, 0))
    {
      alpha += delta*255;
      if(alpha > 255)alpha = 255;              
    }
    else
    {
      alpha -= delta*255;
      if(alpha < 0)alpha = 0;    
    }
    
    hover.v[0].col = SETA(hover.v[0].col, alpha);
    hover.v[1].col = SETA(hover.v[1].col, alpha);
    hover.v[2].col = SETA(hover.v[2].col, alpha);
    hover.v[3].col = SETA(hover.v[3].col, alpha); 
    //printf("alpha %d\n", alpha);
    //printf("zmenezoval som button %d\n", ID);
  }
  return 1;
}

int BUTTON::set_bitmaps(char *normal_bmp, char *hover_bmp)
{
  normal = *dl_util_makeHgeQuad(m_hge, x, y, w, h, 0xffffffff, normal_bmp);
  hover  = *dl_util_makeHgeQuad(m_hge, x, y, w, h, 0xffffffff, hover_bmp);
  //printf("bitmaps set\n");
  return 1;
}
