#ifndef __DIST_H
#define __DIST_H

#include <hgedistort.h>
#include <hgecolor.h>
#include <math.h>

class DL_HGE_DIST
{
  public:
    DL_HGE_DIST();
    ~DL_HGE_DIST();
    int init(HGE *hge, char *texture, int x, int y, int w, int h, float time, int cols = 16, int rows = 16);
    int manage();
    int draw();
    
    int x, y, w, h;
    int rows, cols;
    float cellw;
    float cellh;
    float multiply;
    DWORD color;
    float time, t;
    hgeDistortionMesh*	dis;
    HTEXTURE tex;
    HGE *m_hge;
};

#endif
