#include "dl_hge_menu.h"

#define ID_RADIOGROUP 2778
#define ID_FIRSTBUTTON 27781
#define ID_SECONDBUTTON 27782
#define ID_THIRDBUTTON 27783
#define ID_SLIDER 3000
#define ID_BITMAP 4000
#define ID_LISTBOX1 5000
#define ID_TEXTBOX 6000

/*
SLIDER TOODOO
KOLAJNICA JE ZBYTOCNA, JE MOZNE JU INCLUDNUT V BACKGROUNDE!!!!
*/

hgeQuad *mouse;
HGE *hge = 0;
DL_HGE_MENU m;
hgeFont* fnt;

hgeDistortionMesh*	dis;
HTARGET targo;


const int nRows=64;
const int nCols=64;
const float cellw=1024.0f/(nCols-1);
const float cellh=768.0f/(nRows-1);

float laplas[nRows][nCols], vel[nRows][nCols], arr[nRows][nCols];
float blur_coefficient=0.015f;
float pressure=-10;

int meshx = 0;
int meshy = 0;

float t = 0.0f;
float dt;
bool mouse_move;
float oldx = -30.0f, oldy = -30.0f;
bool FrameFunc()
{
     
     float mx, my;
     hge->Input_GetMousePos(&mx, &my);
     mouse->v[0].x = mx;
            	mouse->v[1].x = mx+32;
            	mouse->v[2].x = mx+32;
            	mouse->v[3].x = mx;
            	
            	mouse->v[0].y = my;
            	mouse->v[1].y = my;
            	mouse->v[2].y = my+32;
            	mouse->v[3].y = my+32;
     
     
	if (hge->Input_GetKeyState(HGEK_ESCAPE)) return true;
	
	if(m.manage() == 0) return true;
	else if(m.active_paper != 50)
	{
                
                
                
            	int ax, ay;
            	int i, j;
                dt = hge->Timer_GetDelta();
            	t+=dt;
            
            	// Process keys
            	
            	
            	
            	
            	if((int)mx == (int)oldx && (int)my == (int)oldy)
            	{
                 mouse_move = false;  
                    
                }
                else mouse_move = true;
                
                //printf("x%d ox%d y%d oy%d\n", (int)mx , (int)oldx , (int)my , (int)oldy) ;    
                
                
                
                oldx = mx; oldy = my;
                
            	switch(hge->Input_GetKey())
            	{
            		case HGEK_ESCAPE:
            			return true;
            	}
            
            	//if(hge->Input_GetKeyState(HGEK_LBUTTON))
            	if(mouse_move)
                {
            		ax=int((mx-meshx)/cellw);
            		ay=int((my-meshy)/cellh);
            		if(ax>1 && ax<nCols-1 && ay>1 && ay<nRows-1)
            		{
            			arr[ay][ax]=pressure;
            			if(ay+1<nRows-1) arr[ay+1][ax]=pressure;
            			if(ax+1<nCols-1) arr[ay][ax+1]=pressure;
            			if(ay+1<nRows-1 && ax+1<nCols-1) arr[ay+1][ax+1]=pressure;
            		}
            	}
            	
            
            	for(i=1;i<nRows-1;i++)
            		for(j=1;j<nCols-1;j++)
            		{
            			laplas[i][j]=-arr[i][j]*4+arr[i+1][j]+arr[i-1][j]+arr[i][j+1]+arr[i][j-1];
            			vel[i][j]+=laplas[i][j];
            		}
            
            	for(i=1;i<nRows-1;i++)
            		for(j=1;j<nCols-1;j++)
            			arr[i][j]+=dt*vel[i][j];
            
            	for(i=1;i<nRows-1;i++)
            		for(j=1;j<nCols-1;j++)
            			arr[i][j]+=dt*vel[i][j]+blur_coefficient*laplas[i][j]; 
            
            	for(i=0;i<nRows;i++)
            	   for(j=0;j<nCols;j++)
            	   {
            		  dis->SetDisplacement(j,i,0,arr[i][j],HGEDISP_NODE);
            		  //dis->SetColor(j,i,0xFF<<24 | 0x00FF<<16 | (0x00FF/2)<<8);
            	   }
    }
	
	return false;
}

void boolpy(bool b)
{
  printf("BOOOOL SHIT %d\n",b);
}

void uplist_callback()
{
 printf("upp %d\n", m.search_paper(10)->search_listbox(ID_LISTBOX1)->index);
 if(m.search_paper(10)->search_listbox(ID_LISTBOX1)->index > 0)
 m.search_paper(10)->search_listbox(ID_LISTBOX1)->index--;   
}

void downlist_callback()
{
 printf("downn %d\n", m.search_paper(10)->search_listbox(ID_LISTBOX1)->index);
 if(m.search_paper(10)->search_listbox(ID_LISTBOX1)->index+m.search_paper(10)->search_listbox(ID_LISTBOX1)->showing < m.search_paper(10)->search_listbox(ID_LISTBOX1)->items.size())
 m.search_paper(10)->search_listbox(ID_LISTBOX1)->index++;   
}

int novy_item = 50015;

void boopy()
{
  printf("BOOOOOOOoooooooooooooooooPYYYYY\n");
}

void slider_callback(int i)
{
 printf("slider_callback> %d", i);    
}

void radiogroup_callback(int i)
{
  printf("radiogroup_callback> %d", i);    
}

void listbox1_callback(int i, char *c)
{
 printf("listbox1_callback> %d %s", i, c);     
}

void pridaj_item()
{
 m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(novy_item, "momco");
 novy_item++;     
}

void odober_item()
{
 if(m.search_paper(10)->search_listbox(ID_LISTBOX1)->items.size() > 1)m.search_paper(10)->search_listbox(ID_LISTBOX1)->items.pop_back();     
}

bool RenderFunc()
{
  /*
  hge->Gfx_BeginScene();
  hge->Gfx_Clear(0);
  
  m.draw();
  
  fnt->printf(5, 5, HGETEXT_LEFT, "FPS:%d", hge->Timer_GetFPS());
  hge->Gfx_EndScene();
*/
 hge->Gfx_BeginScene(targo);
 hge->Gfx_Clear(0xff000000);
 m.draw();
 fnt->printf(5, 5, HGETEXT_LEFT, "FPS:%d", hge->Timer_GetFPS());
 hge->Gfx_EndScene();
 
 
 
 hge->Gfx_BeginScene();
 hge->Gfx_Clear(0);
 dis->Render(0, 0);
 hge->Gfx_RenderQuad(mouse);
 hge->Gfx_EndScene();

  return false;
}

bool GfxRestoreFunc()
{
  if(dis && targo)
       dis->SetTexture(hge->Target_GetTexture(targo));

  return false;
}

#define BUTTON_SINGLEPLAYER 1000
#define BUTTON_MULTIPLAYER  1001
#define BUTTON_SETTINGS     1002
#define BUTTON_CREDITS      1003
#define BUTTON_HELP         1004
#define BUTTON_EXIT         1005

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	hge = hgeCreate(HGE_VERSION);
 hge->System_SetState(HGE_FPS, 100);	
 hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);
 hge->System_SetState(HGE_RENDERFUNC, RenderFunc);
 hge->System_SetState(HGE_GFXRESTOREFUNC, GfxRestoreFunc);
 hge->System_SetState(HGE_WINDOWED, false);
 hge->System_SetState(HGE_USESOUND, true);
 hge->System_SetState(HGE_TITLE, "DL HGE Menu");
 hge->System_SetState(HGE_SCREENWIDTH, 1024);
 hge->System_SetState(HGE_SCREENHEIGHT, 768);
 hge->System_SetState(HGE_SCREENBPP, 32);
 
 memset(laplas,0,sizeof(laplas));
	memset(vel,0,sizeof(laplas));
	memset(arr,0,sizeof(laplas));
  
	if(hge->System_Initiate())
	{
     targo = hge->Target_Create(1024,768,false);
      dis=new hgeDistortionMesh(nCols, nRows);
      dis->SetTexture(hge->Target_GetTexture(targo));
      dis->SetTextureRect(0,0,1024,768);
      dis->SetBlendMode(BLEND_COLORADD | BLEND_ALPHABLEND | BLEND_ZWRITE);
      dis->Clear(0xFF000000);                         
     
     mouse = dl_util_makeHgeQuad(hge, 0, 0, 32, 32, 0xffffffff, "images/mouse.png");                         
                              
    fnt = new hgeFont("font1.fnt");
    m.link_hge(hge);
    //m.init_mouse("images/mouse.png", 0,0);
    //m.init_mouse_particle("menumouse.psi", "images/particles.png", 0, 0, 32, 32, 0, 0);
    
    
    
    m.add_paper(10);
    m.search_paper(10)->set_background("images/menu_bg.png");
    //m.search_paper(10)->add_particle("menumouse.psi", "images/particles.png", 0, 0, 32, 32, 0, 0, 10, PAR_FIRE_ON_START);

    m.search_paper(10)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,NULL);
    m.search_paper(10)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    m.search_paper(10)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,0,NULL);
    m.search_paper(10)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(10)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(10)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(10)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(10)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(10)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    
    
    
    
    m.add_paper(20);
    m.search_paper(20)->bg = m.search_paper(10)->bg;
    
    m.search_paper(20)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,NULL);
    m.search_paper(20)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    m.search_paper(20)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,0,NULL);
    m.search_paper(20)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(20)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(20)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(20)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(20)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(20)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    m.search_paper(20)->add_bitmap(9678);
    m.search_paper(20)->search_bitmap(9678)->set_xywh(80, 240, 512, 512);
    m.search_paper(20)->search_bitmap(9678)->set_bitmap("images/menuHelp.png");
    
    
    m.add_paper(30);
    m.search_paper(30)->bg = m.search_paper(10)->bg;
    
    m.search_paper(30)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,NULL);
    m.search_paper(30)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    m.search_paper(30)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,0,NULL);
    m.search_paper(30)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(30)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(30)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(30)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(30)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(30)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    m.search_paper(30)->add_bitmap(9678);
    m.search_paper(30)->search_bitmap(9678)->set_xywh(80, 240, 512, 512);
    m.search_paper(30)->search_bitmap(9678)->set_bitmap("images/menuCredits.png");
    
    m.add_paper(40);
    m.search_paper(40)->bg = m.search_paper(10)->bg;
    
    m.search_paper(40)->add_button(640,250,384,60,BUTTON_SINGLEPLAYER,BUTT_TYPE_WAY,50,NULL);
    m.search_paper(40)->search_button(BUTTON_SINGLEPLAYER)->set_bitmaps("images/menu_singleplayer.png","images/menu_singleplayer_g.png");
 
    m.search_paper(40)->add_button(640,250+60,384,60,BUTTON_MULTIPLAYER,BUTT_TYPE_WAY,0,NULL);
    m.search_paper(40)->search_button(BUTTON_MULTIPLAYER)->set_bitmaps("images/menu_multiplayer.png","images/menu_multiplayer_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60,384,60,BUTTON_SETTINGS,BUTT_TYPE_WAY,40,NULL);
    m.search_paper(40)->search_button(BUTTON_SETTINGS)->set_bitmaps("images/menu_settings.png","images/menu_settings_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60,384,60,BUTTON_CREDITS,BUTT_TYPE_WAY,30,NULL);
    m.search_paper(40)->search_button(BUTTON_CREDITS)->set_bitmaps("images/menu_credits.png","images/menu_credits_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60+60,384,60,BUTTON_HELP,BUTT_TYPE_WAY,20,NULL);
    m.search_paper(40)->search_button(BUTTON_HELP)->set_bitmaps("images/menu_help.png","images/menu_help_g.png");
    
    m.search_paper(40)->add_button(640,250+60+60+60+60+60,384,60,BUTTON_EXIT,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(40)->search_button(BUTTON_EXIT)->set_bitmaps("images/menu_exit.png","images/menu_exit_g.png");
    
    m.search_paper(40)->add_slider(80, 465, 512, 16, 34, slider_callback);
    m.search_paper(40)->search_slider(34)->set_data(0, 512, 255);
    m.search_paper(40)->search_slider(34)->set_bitmaps("images/menu_sliderhead.png", "images/menu_slider.png", 64, 64);
    
    m.search_paper(40)->add_slider(80, 365, 512, 16, 35, slider_callback);
    m.search_paper(40)->search_slider(35)->set_data(0, 512, 255);
    m.search_paper(40)->search_slider(35)->set_bitmaps("images/menu_sliderhead.png", "images/menu_slider.png", 64, 64);
    
    
    m.search_paper(40)->add_checkbox(460,545,32,32,121, boolpy);// x 460 y 545
    m.search_paper(40)->search_checkbox(121)->set_bitmaps("images/menu_checkbox_actif.png", "images/menu_checkbox_unact.png");
    
    m.search_paper(40)->add_bitmap(5656);
    m.search_paper(40)->search_bitmap(5656)->set_xywh(269,305,124, 31);
    m.search_paper(40)->search_bitmap(5656)->set_bitmap("images/menusetmusic.png");

    m.search_paper(40)->add_bitmap(5757);
    m.search_paper(40)->search_bitmap(5757)->set_xywh(260,410,148,30);
    m.search_paper(40)->search_bitmap(5757)->set_bitmap("images/menusetsound.png");
    
    m.search_paper(40)->add_bitmap(5858);
    m.search_paper(40)->search_bitmap(5858)->set_xywh(145,545,299,31);
    m.search_paper(40)->search_bitmap(5858)->set_bitmap("images/menusetgodli.png");
    
    /*m.search_paper(10)->add_button(10,10,128,32,101,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(10)->search_button(101)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(10)->add_button(50,50,128,32,102,BUTT_TYPE_WAY,20,boopy);
    m.search_paper(10)->search_button(102)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_button(450,300,128,32,103,BUTT_TYPE_PROC,10,pridaj_item);
    m.search_paper(10)->search_button(103)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_button(450+128+35,300,128,32,104,BUTT_TYPE_PROC,10,odober_item);
    m.search_paper(10)->search_button(104)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(10)->add_checkbox(500,10,32,32,121, boolpy);
    m.search_paper(10)->search_checkbox(121)->set_bitmaps("images/checked.png", "images/unchecked.png");
    m.search_paper(10)->set_background("images/menu_bg.png");
    m.search_paper(10)->add_radiogroup(400, 400, 50, ID_RADIOGROUP, radiogroup_callback);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_FIRSTBUTTON, 32, 32);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_SECONDBUTTON, 32, 32);
    m.search_paper(10)->search_radiogroup(ID_RADIOGROUP)->add_radiobutton("images/checked.png", "images/unchecked.png", ID_THIRDBUTTON, 32, 32);
    m.search_paper(10)->add_slider(200, 550, 256, 64, ID_SLIDER, slider_callback);
    m.search_paper(10)->search_slider(ID_SLIDER)->set_data(0, 255, 128);
    m.search_paper(10)->search_slider(ID_SLIDER)->set_bitmaps("images/vlak.png", "images/kolajnica.png", 16, 64);
    
    m.search_paper(10)->add_listbox(623, 93,  258, 208, ID_LISTBOX1, 32, listbox1_callback);
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_buttons("images/button_normal.png", "images/button_hover.png", "images/button_normal.png", "images/button_hover.png");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_font("fonts/font2.fnt");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->set_bitmap("images/button_normal.png", "momo", "images/slider_kolajnica.png");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->up.way = 10; //paper id 1, must be the one, where is the listbox
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->down.way = 10; //paper id 1, too
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->up.proc = uplist_callback;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->down.proc = downlist_callback;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->showing = 7;
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(5001, "ahoj");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50012, "ahoj2");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50013, "ahoj3");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->add_item(50014, "ahoj4");
    m.search_paper(10)->search_listbox(ID_LISTBOX1)->items.begin()->selected = true; //ak si prave nakodil menu a divis sa, preco to v listboxe pada, pravdepodobne si zabudol tento riadok. teda preco to pada, ked user na nic neklikne a defaultne oznaci OK... dano> 19.septembra, 23:37
    m.search_paper(10)->add_textbox(600, 600, ID_TEXTBOX);
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->set_font("fonts/font1.fnt");
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->type = NORMAL;
    m.search_paper(10)->search_textbox(ID_TEXTBOX)->maxchar = 5;
    
    */
    
   // m.add_paper(30);
   // m.search_paper(30)->bg = m.search_paper(10)->bg;
    /*m.search_paper(30)->bg.v[0].x = 0;
    m.search_paper(30)->bg.v[1].x = 1024;
    m.search_paper(30)->bg.v[2].x = 1024;
    m.search_paper(30)->bg.v[3].x = 0;
    
    m.search_paper(30)->bg.v[0].y = 0;
    m.search_paper(30)->bg.v[1].y = 0;    
    m.search_paper(30)->bg.v[2].y = 768;
    m.search_paper(30)->bg.v[3].y = 768;

    m.search_paper(30)->bg.v[0].tx = 0.0f;
    m.search_paper(30)->bg.v[1].tx = 1.0f;
    m.search_paper(30)->bg.v[2].tx = 1.0f;
    m.search_paper(30)->bg.v[3].tx = 0.0f;
    
    m.search_paper(30)->bg.v[0].ty = 0.0f;
    m.search_paper(30)->bg.v[1].ty = 0.0f;    
    m.search_paper(30)->bg.v[2].ty = 1.0f;
    m.search_paper(30)->bg.v[3].ty = 1.0f;

    m.search_paper(30)->bg.v[0].col = 0xffffffff;
    m.search_paper(30)->bg.v[1].col = 0xffffffff;    
    m.search_paper(30)->bg.v[2].col = 0xffffffff;
    m.search_paper(30)->bg.v[3].col = 0xffffffff;
    
    m.search_paper(30)->bg.blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
    */
    
    m.add_paper(50);
    m.search_paper(50)->set_background("images/mapa.png");
    
    m.search_paper(50)->add_button(0,675,240,93,200,BUTT_TYPE_WAY,10,NULL);
    m.search_paper(50)->search_button(200)->set_bitmaps("images/mapback.png","images/mapback_g.png");
    
    
    m.search_paper(50)->add_button(205,125,45,43,201,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(201)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(280,140,45,43,202,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(202)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(350,150,45,43,203,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(203)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(475,190,45,43,204,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(204)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(530,225,45,43,205,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(205)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(490,273,45,43,206,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(206)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(615,290,45,43,207,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(207)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(560,340,45,43,208,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(208)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(450,335,45,43,209,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(209)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(360,350,45,43,210,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(210)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(290,375,45,43,211,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(211)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(255,430,45,43,212,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(212)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(300,490,45,43,213,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(213)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(350,595,45,43,214,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(214)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(445,625,45,43,215,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(215)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(400,475,45,43,216,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(216)->set_bitmaps("images/normal.png","images/hover.png");

    m.search_paper(50)->add_button(510,500,45,43,217,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(217)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(585,550,45,43,218,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(218)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(625,605,45,43,219,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(219)->set_bitmaps("images/normal.png","images/hover.png");
    
    m.search_paper(50)->add_button(750,650,45,43,220,BUTT_TYPE_PLAY,0,NULL);
    m.search_paper(50)->search_button(220)->set_bitmaps("images/normal.png","images/hover.png");
    /*m.search_paper(20)->add_button(500,500,128,32,201,BUTT_TYPE_EXIT,0,NULL);
    m.search_paper(20)->search_button(201)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(20)->add_button(50,50,128,32,202,BUTT_TYPE_WAY,10,boopy);
    m.search_paper(20)->search_button(202)->set_bitmaps("images/normal.png","images/hover.png");
    m.search_paper(20)->set_background(NULL, 0xffff9600);
    m.search_paper(20)->add_bitmap(ID_BITMAP);
    m.search_paper(20)->search_bitmap(ID_BITMAP)->set_xywh(800, 200, 128, 64);
    m.search_paper(20)->search_bitmap(ID_BITMAP)->set_bitmap("images/bitmap.png");
    */
    
		hge->System_Start();
	}
	else
	{
		MessageBox(NULL, hge->System_GetErrorMessage(), "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
	}
	
	hge->System_Shutdown();
	hge->Release();

	return 0;
}
