#ifndef __MENU_H
#define __MENU_H

#include "dl_hge_paper.h"

class DL_HGE_MENU
{
 public:
        DL_HGE_MENU();
        ~DL_HGE_MENU();
        int draw();
        int manage();
        void link_hge(HGE *h) {  m_hge = h;  }
        int init_mouse(char *filename, int hotspotx, int hotspoty);
        int init_mouse_particle(char *particle_system, char *particle_texture, int tex_x, int tex_y, int tex_w, int tex_h, int hotspotx, int hotspoty);
        int add_paper(int id);
        list<PAPER>::iterator search_paper(int id);
        
        list<PAPER> papers;
        int active_paper;
        hgeSprite* spt_mouse;
        HTEXTURE mouse_tex;
        hgeSprite *mouse_spr;
        hgeParticleSystem *mouse_par;
        HGE *m_hge;
};

#endif
