#include "dl_level.h"

#define B_H 32
#define B_W 32
#define M_H 64
#define M_W 32

#define AIR   0
#define BRICK 1

DL_LEVEL::DL_LEVEL()
{
  //printf("mame level\n");
  camleft = 0;
  slide1 = 0;
  slide2 = 0;
  slide3 = 0;
  slide4 = 0;
  memset(unlockedlevels, 0, 15);
  memset(donelevels, 0, 15);
  FILE *prog;
  prog = fopen("lvl/progress.txt","r");
  for(int i = 0; i < 15; i++)
    fscanf(prog, "%d", &unlockedlevels[i]);
  for(int i = 0; i < 15; i++)
    fscanf(prog, "%d", &donelevels[i]);
  fclose(prog);
  memset(slidefn[0], '\0', 33);
  memset(slidefn[1], '\0', 33);
  memset(slidefn[2], '\0', 33);
  memset(slidefn[3], '\0', 33);
  curlvl = 0;
}

DL_LEVEL::~DL_LEVEL()
{
  //deinit();
  //printf("nemame level\n");
}

bool DL_LEVEL::pt_in(float x, float y)
{
  if(data[((int)x/B_W)][((int)y)/B_H] > 0 && data[((int)x/B_W)][((int)y)/B_H] < 100)
    return true;
  else return false;
}

int DL_LEVEL::manage(int id, int soundvol)
{
  list<PLAYER>::iterator it = search_player(id);
  int i;
  
  if(it->x < 512) camleft = 0;
  else if(it->x > 5632)camleft = 5120;
  else
  {
    camleft = it->x-512;
  }
  if(hgge->Input_KeyDown(HGEK_UP) && !it->lieta && it->frozen <= 0.0f/* && !it->utoci && !it->qutoci && !it->wutoci && !it->eutoci && !it->rutoci*/ && !it->autoci && !it->sutoci && !it->dutoci && !it->futoci)
    it->idehore = 1;
  if(hgge->Input_KeyUp(HGEK_UP))
    it->idehore = 0;
    
    //EASTER EGG :)
    
  if(hgge->Input_KeyDown(HGEK_LEFT) && it->frozen <= 0.0f)
  {
    it->idedolava = 1;
    it->smer = 4;
    it->frame = 0.0f;
  }
  if(hgge->Input_KeyUp(HGEK_LEFT)) {it->idedolava = 0; it->kraca = 0.0f;}
  if(hgge->Input_KeyDown(HGEK_RIGHT) && it->frozen <= 0.0f)
  {
    it->idedoprava = 1;
    it->smer = 6;
    it->frame = 0.0f;
  }
  if(hgge->Input_KeyUp(HGEK_RIGHT)) {it->idedoprava = 0; it->kraca = 0.0f;}
  
  
  /*if(hgge->Input_KeyDown(HGEK_LEFT) && it->frozen <= 0.0f)
  {
    it->idedolava = 1;
    it->idedoprava = 0;
    it->smer = 4;
    it->frame = 0.0f;
  }
  if(hgge->Input_KeyUp(HGEK_LEFT))
  {
    it->idedolava = 0;
    if(hgge->Input_GetKeyState(HGEK_RIGHT))
    {
      it->idedoprava = 1;
      it->idedolava = 0;
      it->smer = 6;
      it->frame = 0.0f;
    }
  }
  if(hgge->Input_KeyDown(HGEK_RIGHT) && it->frozen <= 0.0f)
  {
    it->idedoprava = 1;
    it->idedolava = 0;
    it->smer = 6;
    it->frame = 0.0f;
  }
  if(hgge->Input_KeyUp(HGEK_RIGHT))
  {
    it->idedoprava = 0;
    if(hgge->Input_GetKeyState(HGEK_LEFT))
    {
      it->idedoprava = 0;
      it->idedolava = 1;
      it->smer = 4;
      it->frame = 0.0f;
    }
  }*/
  
  
  if(it->idehore && it->frozen <= 0.0f)
  {
    it->vy = -5.3f;
    it->y += it->vy;
    it->idehore = 0;
  }
  if (it->idedolava && it->frozen <= 0.0f)// && !it->utoci && !it->qutoci && !it->wutoci && !it->eutoci && !it->rutoci && !it->autoci && !it->sutoci && !it->dutoci && !it->futoci)
  {
    it->x -= 2.0f;
    it->kraca += 0.01f;
    it->frame -= 0.1f;
  }
  if (it->idedoprava && it->frozen <= 0.0f)// && !it->utoci && !it->qutoci && !it->wutoci && !it->eutoci && !it->rutoci && !it->autoci && !it->sutoci && !it->dutoci && !it->futoci)
  {
    it->x += 2.0f;
    it->kraca += 0.01f;
    it->frame += 0.1f;
  }
  
  
  //coldet
  bool col1 = false, col2 = false, col3 = false, col4 = false;
  bool col5 = false, col6 = false, col7 = false, col8 = false;
  col1 = pt_in(it->x+2.0f, it->y);
  col2 = pt_in(it->x, it->y+((float)M_H/3));
  col3 = pt_in(it->x, it->y+(2*(float)M_H/3));
  col4 = pt_in(it->x+2.0f, it->y+(float)M_H-5.0f);
  col5 = pt_in(it->x-3.0f+(float)M_W, it->y);
  col6 = pt_in(it->x+(float)M_W, it->y+((float)M_H/3));
  col7 = pt_in(it->x+(float)M_W, it->y+(2*(float)M_H/3));
  col8 = pt_in(it->x-3.0f+(float)M_W, it->y+(float)M_H-5.0f);
  //printf("\n%d %d %d %d %d %d %d %d   %d\n", (col1), (col2), (col3), (col4), (col5), (col6), (col7), (col8), it->lieta);
  
  if(col1 || col5)// && (!col2 && !col3 && !col6 && !col7))
  {
    it->y = (float)(((int)it->y/B_H+1)*B_H);
    it->vy = 0.0;
  }
  //gravitacia
  if(!col4 && !col8)
  {
    it->lieta = 1;
    it->vy += 0.1f;
    it->y += it->vy;
  }
  if(col4 || col8 && it->lieta)
  {
    it->y = (float)(((int)it->y/B_H)*B_H)+5.0f;
    it->vy = 0.0;
    it->lieta = 0;
  }
  /*if((col4 || col8) && (!col2 && !col3 && !col6 && !col7) && it->lieta)
  {
    //printf("hah tu som ho zastavil");
    it->y = (float)(((int)it->y/B_H)*B_H)+5.0f;
    it->vy = 0.0;
    it->lieta = 0;
  }*/
  //coldet do smeru
  if(!col2 && !col3 && !it->idedolava && hgge->Input_GetKeyState(HGEK_LEFT))
    it->idedolava = 1;
  if(col2 || col3)
  {
    it->x = (float)(((int)it->x/B_W+1)*B_W);
    it->vx = 0.0f;
    it->kraca = 0.0f;
    it->idedolava = 0;
  }
  if(!col6 && !col7 && !it->idedoprava && hgge->Input_GetKeyState(HGEK_RIGHT))
    it->idedoprava = 1;
  if(col6 || col7)
  {
    it->x = (float)(((int)it->x/B_W)*B_W);
    it->vx = 0.0;
    it->kraca = 0.0f;
    it->idedoprava = 0;
  }
  
  
  float camleft;
  if(it->x < 512) camleft = 0;
  else if(it->x > 5632)camleft = 5120;
  else
  {
    camleft = it->x-512;
  };
  it->manage(camleft, soundvol);
  
  //limit
  if(it->x < 0) it->x = 0;
  if(it->x > 6108) it->x = 6108;
  if(it->y < 0) it->y = 0;
  if(it->y > 704) it->y = 704;
  
  return 1;
}

int DL_LEVEL::draw()
{ 
  if(showing == 1)
  {
    hgge->Gfx_RenderQuad(slide);
    if(hgge->Input_KeyDown(HGEK_SPACE))
    {
      unload_slide();
      if(slide2)
      {
        showing = 2;
        load_slide(2);
      }
      else
      {
        showing = 0;
      }
    }
  }
  else if(showing == 2)
  {
    hgge->Gfx_RenderQuad(slide);
    if(hgge->Input_KeyDown(HGEK_SPACE))
    {
      unload_slide();
      showing = 0;
    }
  }
  else if(showing == 3)
  {
    hgge->Gfx_RenderQuad(slide);
    if(hgge->Input_KeyDown(HGEK_SPACE))
    {
      unload_slide();
      if(slide4)
      {
        showing = 4;
        load_slide(4);
      }
      else showing = 5;
    }
  }
  else if(showing == 4)
  {
    hgge->Gfx_RenderQuad(slide);
    if(hgge->Input_KeyDown(HGEK_SPACE))
    {
      unload_slide();
      showing = 5;
    }
  }
  else if(showing == 0)
  {
    list<PLAYER>::iterator it = search_player(0);
    //prvy slice = camleft / 128
    camleft = (it->x - 512)/5;
    if(camleft < 0) camleft = 0;
    if(camleft > 1024) camleft = 1024;
    
    
    for(int i = camleft/128; i < camleft/128+8; i++)
    {
      if(i < 16)
      {
        bg[i]->v[0].x = (int)(i*128-camleft);
        bg[i]->v[1].x = (int)(i*128-camleft+128);
        bg[i]->v[2].x = (int)(i*128-camleft+128);
        bg[i]->v[3].x = (int)(i*128-camleft);
        hgge->Gfx_RenderQuad(bg[i]);
      }
    }
    
    //kreslenie brickov
    if(it->x < 512) camleft = 0;
    else if(it->x > 5632)camleft = 5120;
    else
    {
      camleft = it->x-512;
    }
    
    for(int yy = 0; yy < hh; yy++)
    for(int i = 0; i < camleft/32+32; i++)
    {
      if(data[i][yy] > 0)
      {
        if(i < 192)
        {
         int b = data[i][yy];
         //printf("%d %d gogo 1 %d\n", i, yy, b);
         brick[b-1]->v[0].x = i*32-camleft;    brick[b-1]->v[0].y = yy*32;
         brick[b-1]->v[1].x = i*32-camleft+32; brick[b-1]->v[1].y = yy*32;
         brick[b-1]->v[2].x = i*32-camleft+32; brick[b-1]->v[2].y = yy*32 + 32;
         brick[b-1]->v[3].x = i*32-camleft;    brick[b-1]->v[3].y = yy*32 + 32;
         hgge->Gfx_RenderQuad(brick[b-1]);
         //printf("%d %d gogo 2\n", i, yy);
        }
      }
    }
    for(it = players.begin(); it != players.end(); it++)
    {
     it->draw(camleft);       
    }
  }
  return 1;
}


int DL_LEVEL::manage_mp(DL_WS_CLIENT *c, int player_id)
{
  for(int i = 0; i <= 10; i++)
  {
      c->dl_recv();
      char *rbuf = c->recvbuffer;
      if(rbuf[0] == '\0') break;
      
      int odkoho = -1;
      odkoho = (rbuf[2]-48)*10;
      odkoho += (rbuf[3]-48);
      list<PLAYER>::iterator it;
      for(it = players.begin(); it != players.end(); it++)
      {
        if(it->ID == odkoho && it != search_player(player_id))
        {
        //  60 - new player joined    60int[2]nick?
          if(rbuf[0] == '6' && rbuf[1] == '0')
          {
            char nick[32];
            memset(nick, '\0', 32);
            for(int i = 0; i < 30; i++)
            {
              if(rbuf[4+i] == '?') break;
              nick[i] = rbuf[4+i];
            }
            add_player_multi(odkoho, nick);
          }
          //70 - pozicia      id, x, y, smer, frame, frameutok, team, frozen
          if(rbuf[0] == '7' && rbuf[1] == '0')
          {
            int x = 0, y = 0, smer = 6, frame = 0, frameutok = 0, team = 0, frozen = 0;
            /*x = (rbuf[5]-48)*1000;
            x = (rbuf[6]-48)*100;
            x = (rbuf[7]-48)*10;
            x = (rbuf[8]-48)*1;*/
            for(int i = 0; i < 4; i++)
            {
              if(rbuf[5+i] == '?') break;
              x *= 10;
              x += (rbuf[5+i]-48);
            }
            for(int i = 0; i < 3; i++)
            {
              if(rbuf[10+i] == '?') break;
              y *= 10;
              y += (rbuf[10+i]-48);
            }
            /*
            y = (rbuf[10]-48)*100;
            y = (rbuf[11]-48)*10;
            y = (rbuf[12]-48)*1;
            */
            smer = (rbuf[14]-48);
            frame = (rbuf[16]-48);
            frameutok = (rbuf[18]-48);
            team = (rbuf[20]-48);
            frozen = (rbuf[22]-48);
            it->x = x;
            it->y = y;
            it->smer = smer;
            it->frame= frame;
            it->frameutok = frameutok;
            it->team = team;
          }
          //71 - kuzlo        id, kuzlo, x, y, smer, idcislo
          else if(rbuf[0] == '7' && rbuf[1] == '1')
          {
            int akekuzlo = 0, x = 0, y = 0, smer = 6, idcislo = 0;
            
            akekuzlo = (rbuf[5]-48);
            
            /*x = (rbuf[7]-48)*1000;
            x = (rbuf[8]-48)*100;
            x = (rbuf[9]-48)*10;
            x = (rbuf[10]-48)*1;*/
            for(int i = 0; i < 4; i++)
            {
              if(rbuf[7+i] == '?') break;
              x *= 10;
              x += (rbuf[7+i]-48);
            }
            for(int i = 0; i < 3; i++)
            {
              if(rbuf[12+i] == '?') break;
              y *= 10;
              y += (rbuf[12+i]-48);
            }
            /*y = (rbuf[12]-48)*100;
            y = (rbuf[13]-48)*10;
            y = (rbuf[14]-48)*1;*/
            
            smer = (rbuf[16]-48);
            idcislo = (rbuf[18]-48);
            it->new_kuzlo(akekuzlo, x, y, smer, idcislo);
          }
          //72 - znickuzlo    idkoho, idktore, idcislo
          else if(rbuf[0] == '7' && rbuf[1] == '2')
          {
            int idktore = 0, idcislo = 0;
            idktore = (rbuf[5]-48);
            idcislo = (rbuf[7]-48);
            it->znic_kuzlo(idktore, idcislo);
          }
          //73 - zabil ma     idkoho, idkto, idktore, idcislo
          else if(rbuf[0] == '7' && rbuf[1] == '3')
          {
            int idkto = 0, idktore = 0, idcislo = 0;
            idkto   = (rbuf[5]-48);
            idktore = (rbuf[7]-48);
            idcislo = (rbuf[9]-48);
            if(search_player(idkto)->team != it->team)
            {
              search_player(idkto)->skore++;
              it->skore--;
            }
            if(search_player(idkto)->team == 3)
            {
              search_player(idkto)->skore++;
              it->skore--;
            }
            search_player(idkto)->znic_kuzlo(idktore, idcislo);
          }
          //skore
          else if(rbuf[0] == '8' && rbuf[1] == '0')
          {
            int skore = 0;
            skore = (rbuf[5]-48)*100;
            skore+= (rbuf[6]-48)*10;
            skore+= (rbuf[7]-48)*1;
            it->skore = skore;
          }
        }
      }
  }
    
 /*
    70 - pozicia      id, x, y, smer, frame, frameutok, team, frozen[1/0]
    71 - kuzlo        id, kuzlo, x, y, smer, idcislo
    72 - znickuzlo    idkoho, idktore, idcislo
    73 - zabil ma     idkoho, idkto, idktore, idcislo
    80 - skore        id, skore[3]*/
  
  //manage(player_id, 1, c);
  //coldet s utokmi - 73
  list<PLAYER>::iterator itme = search_player(player_id);
  list<PLAYER>::iterator it;
  BUFFER msg;
  for(it = players.begin(); it != players.end(); it++)
  {
    if(it != itme)
    {
      for(int i = 0; i < 3; i++)
      {
          it->fb[i].manage(camleft);
          if(it->fb[i].vystreleny == 1)
          {
            if(itme->life > 0 && it->fb[i].x > itme->x && it->fb[i].x < itme->x+32 && it->fb[i].y > itme->y && it->fb[i].y < itme->y+64)
            {
             itme->life -= 50;
             it->fb[i].vystreleny = 0;
             it->fb[i].par->Stop();
            }
            if(itme->life <= 0.0f)
            {
              //73 - zabil ma     idkoho, idkto, idktore, idcislo
              sprintf(msg.buffer, "73%d%d?%d?%d?%d?", itme->ID/10, itme->ID%10, it->ID, 1, i);
              c->dl_send(msg.buffer);
              int n = hgge->Random_Int(1,12);
              if(n == 1 && itme->team == 1)
              {
                itme->x = redsp.x*32;
                itme->y = redsp.y*32;
              }
              if(n == 2 && itme->team == 2)
              {
                itme->x = bluesp.x*32;
                itme->y = bluesp.y*32;
              }
              if(n > 2)
              {
                itme->x = roguesp[n-2].x*32;
                itme->y = roguesp[n-2].y*32;
              }
            }
          }
      }
      for(int i = 0; i < 2; i++)
      {
          it->fr[i].manage(camleft);
          if(it->fr[i].vystreleny == 1)
          {
            if(itme->life > 0 && it->fr[i].x > itme->x && it->fr[i].x < itme->x+32 && it->fr[i].y > itme->y && it->fr[i].y < itme->y+64)
            {
              if(itme->frozen <= 0.0f) itme->frozen = 10.0f;
              it->fr[i].vystreleny = 0;
              it->fr[i].par->Stop();
            }
            if(itme->life <= 0.0f)
            {
              //73 - zabil ma     idkoho, idkto, idktore, idcislo
              sprintf(msg.buffer, "73%d%d?%d?%d?%d?", itme->ID/10, itme->ID%10, it->ID, 2, i);
              c->dl_send(msg.buffer);
              int n = hgge->Random_Int(1,12);
              if(n == 1 && itme->team == 1)
              {
                itme->x = redsp.x*32;
                itme->y = redsp.y*32;
              }
              if(n == 2 && itme->team == 2)
              {
                itme->x = bluesp.x*32;
                itme->y = bluesp.y*32;
              }
              if(n > 2)
              {
                itme->x = roguesp[n-2].x*32;
                itme->y = roguesp[n-2].y*32;
              }
            }
          }
      }
    }
  }
  sprintf(msg.buffer, "70%d%d?%d?%d?%d?%d?%d?%d?%d?", itme->ID/10, itme->ID%10, (int)itme->x, (int)itme->y, itme->smer, (int)itme->frame, (int)itme->frameutok, itme->team, (itme->frozen > 0.0f)?1:0);
  c->dl_send(msg.buffer);
}


/*int DL_LEVEL::draw_mp()
{
    //prvy slice = camleft / 128
    camleft = (it->x - 512)/5;
    if(camleft < 0) camleft = 0;
    if(camleft > 1024) camleft = 1024;
    
    
    for(int i = camleft/128; i < camleft/128+8; i++)
    {
        if(i < 16)
        {
            bg[i]->v[0].x = (int)(i*128-camleft);
            bg[i]->v[1].x = (int)(i*128-camleft+128);
            bg[i]->v[2].x = (int)(i*128-camleft+128);
            bg[i]->v[3].x = (int)(i*128-camleft);
            hgge->Gfx_RenderQuad(bg[i]);
        }
    }
    
    //kreslenie brickov
    if(it->x < 512) camleft = 0;
    else if(it->x > 5632)camleft = 5120;
    else
    {
        camleft = it->x-512;
    }
    
    for(int yy = 0; yy < hh; yy++)
    for(int i = 0; i < camleft/32+32; i++)
    {
        if(data[i][yy] > 0)
        {
            if(i < 192)
            {
                int b = data[i][yy];
                //printf("%d %d gogo 1 %d\n", i, yy, b);
                brick[b-1]->v[0].x = i*32-camleft;    brick[b-1]->v[0].y = yy*32;
                brick[b-1]->v[1].x = i*32-camleft+32; brick[b-1]->v[1].y = yy*32;
                brick[b-1]->v[2].x = i*32-camleft+32; brick[b-1]->v[2].y = yy*32 + 32;
                brick[b-1]->v[3].x = i*32-camleft;    brick[b-1]->v[3].y = yy*32 + 32;
                hgge->Gfx_RenderQuad(brick[b-1]);
                //printf("%d %d gogo 2\n", i, yy);
            }
        }
    }
    list<PLAYER>::iterator it;
    for(it = players.begin(); it != players.end(); it++)
    {
        it->draw(camleft);       
    }
}
*/
int DL_LEVEL::deinit()
{
  if(!hgge->Input_GetKeyState(HGEK_ESCAPE))
  {
    if(curlvl == 0 && donelevels[0] == 1) unlockedlevels[1] = 1;
    if(curlvl == 1 && donelevels[1] == 1) unlockedlevels[2] = 1;
    if(curlvl == 2 && donelevels[2] == 1) unlockedlevels[3] = 1;
    if(curlvl == 3 && donelevels[3] == 1){unlockedlevels[4] = 1;unlockedlevels[5] = 1;}
    
    if(curlvl == 4 && donelevels[5] == 1 && donelevels[4] == 1) unlockedlevels[6] = 1;
    if(curlvl == 5 && donelevels[5] == 1 && donelevels[4] == 1) unlockedlevels[6] = 1;
    
    if(curlvl == 6 && donelevels[6] == 1) unlockedlevels[7] = 1;
    if(curlvl == 7 && donelevels[7] == 1) unlockedlevels[8] = 1;
    if(curlvl == 8 && donelevels[8] == 1) unlockedlevels[9] = 1;
    if(curlvl == 9 && donelevels[9] == 1){unlockedlevels[10] = 1;unlockedlevels[11] = 1;}
    
    if(curlvl ==10 && donelevels[12] == 1 && donelevels[10] == 1) unlockedlevels[13] = 1;
    if(curlvl ==11 && donelevels[11] == 1) unlockedlevels[12] = 1;
    if(curlvl ==12 && donelevels[12] == 1 && donelevels[10] == 1) unlockedlevels[13] = 1;
    
    if(curlvl ==13 && donelevels[13] == 1) unlockedlevels[14] = 1;
  }
  FILE *prog;
  prog = fopen("lvl/progress.txt","w");
  for(int i = 0; i < 15; i++)
    fprintf(prog, "%d ", unlockedlevels[i]);
  for(int i = 0; i < 15; i++)
    fprintf(prog, "%d ", donelevels[i]);
  fclose(prog);
  //printf("\ncentrala 10\n");
  for(int i = 0; i < 16; i++)
    hgge->Texture_Free(bg[i]->tex);
  //printf("\ncentrala 20\n");
  for(int i = 0; i < 25; i++)
    hgge->Texture_Free(brick[i]->tex);
  //printf("\ncentrala 30\n");
  free((void*)data);
  
  if(data == NULL) printf("zmazal som data\n");
  else printf("nezmazal som data\n");
  
  type = -1;
  ww = 0;
  hh = 0;
  camleft = 0;
  players.clear();
  slide1 = 0; slide2 = 0; slide3 = 0; slide4 = 0;
  showing = 0;
  unload_slide();
  //printf("\ncentrala 40\n");
  memset(slidefn[0], '\0', 33);
  memset(slidefn[1], '\0', 33);
  memset(slidefn[2], '\0', 33);
  memset(slidefn[3], '\0', 33);
}

int DL_LEVEL::init(int levelno)//const char *level, const char *pozadie, int type)
{ 
  FILE *prog;
  prog = fopen("lvl/progress.txt","r");
  for(int i = 0; i < 15; i++)
    fscanf(prog, "%d", &unlockedlevels[i]);
  for(int i = 0; i < 15; i++)
    fscanf(prog, "%d", &donelevels[i]);
  fclose(prog);
  curlvl = levelno;
  // what level to open?
  char fn[16] = "lvl/";
  fn[4] = 48+levelno/10;
  fn[5] = 48+levelno%10;
  fn[6] = '.';
  fn[7] = 'l';
  fn[8] = 'v';
  fn[9] = 'l';
  fn[10] = '\0';
  // now open it
  //    let's get it on
  FILE *f;
  f = fopen(fn,"r");
  list<PLAYER>::iterator itp = search_player(0);
  ww = 192;
  hh = 24;
  //printf("\n\n\nTU NEPADAM 4\n\n\n");
  fscanf(f, "%d %d %d %d %d %d %d %d %d %d %d %f %f %d %d %d %d", &typpozadia, &itp->is_ged, &itp->is_tenar, &itp->is_therru, &itp->nof_kuziel_ged, &itp->nof_kuziel_tenar, &itp->nof_kuziel_therru, &itp->startx, &itp->starty, &itp->endx, &itp->endy, &itp->maxlife, &itp->maxmana, &itp->atk, &itp->fbstrength, &itp->slstrength, &itp->psstrength);
  if(itp->is_ged == 1) itp->type = GED;
  else if(itp->is_tenar == 1) itp->type = KNAZKA;
  else if(itp->is_therru == 1) itp->type = DECKO;
  //printf("\n\n\nTU NEPADAM 5\n\n\n");
  itp->x = itp->startx*32;
  itp->y = itp->starty*32;
  itp->life = itp->maxlife;
  itp->mana = itp->maxmana;
  //printf("%d %d", ww, hh);
  //printf("\n\n\nTU NEPADAM 6\n\n\n");
  //    what's happening? d-d-d-dot-a
  for(int i = 0; i < hh; i++)
  {
   for(int j = 0; j < ww; j++)
   {
     fscanf(f, "%d", &data[j][i]);
   }
  }
  int nof_sekac = 0;
  fscanf(f, "%d", &nof_sekac);
  int life, sx, sy, ex, ey, sekactype;
  for(int k = 0; k < nof_sekac; k++)
  {
    fscanf(f, "%d %d %d %d %d %d", &sekactype, &life, &sx, &sy, &ex, &ey);
    search_player(0)->add_sekac(k, data, sekactype, life, sx, sy, ex, ey, typpozadia);
  }
  //    i hear you man!
  int nof_cernoch = 0;
  fscanf(f, "%d", &nof_cernoch);
  for(int k = 0; k < nof_cernoch; k++)
  {
    fscanf(f, "%d %d %d", &life, &sx, &sy);
    search_player(0)->add_cernoch(k, data, life, sx, sy, typpozadia);
  }
  int nof_modri = 0;
  fscanf(f, "%d", &nof_modri);
  for(int k = 0; k < nof_modri; k++)
  {
    fscanf(f, "%d %d %d", &life, &sx, &sy);
    search_player(0)->add_magemodry(k, data, life, sx, sy, typpozadia);
  }
  
  int nof_vtakov = 0;
  fscanf(f, "%d", &nof_vtakov);
  for(int k = 0; k < nof_vtakov; k++)
  {
    fscanf(f, "%d %d %d %d", &life, &sx, &sy, &ex);
    search_player(0)->add_vtak(k, data, life, sx, sy, ex, typpozadia);
  }
  
  int nof_potions = 0;
  int potiontype = 0;
  fscanf(f, "%d", &nof_potions);
  for(int k = 0; k < nof_potions; k++)
  {
    fscanf(f, "%d %d %d", &potiontype, &sx, &sy);
    search_player(0)->add_potion(k, potiontype, sx, sy);
  }
  
  int nof_runes = 0;
  int runax, runay;
  fscanf(f, "%d", &nof_runes);
  for(int k = 0; k < nof_runes; k++)
  {
    fscanf(f, "%d %d", &runax, &runay);
    search_player(0)->add_runa(k, runax*32.0f, runay*32.0f);
  }
  //printf("\n\n\nTU NEPADAM 6\n\n\n");
  //nacitaj info o slidoch
  fscanf(f, "%d %d %d %d", &slide1, &slide2, &slide3, &slide4);
  if(slide1)
    fscanf(f, "%s", slidefn[0]);
  if(slide2)
    fscanf(f, "%s", slidefn[1]);
  if(slide3)
    fscanf(f, "%s", slidefn[2]);
  if(slide4)
    fscanf(f, "%s", slidefn[3]);
  for(int k = 0; k < 33; k++)
  {
    if(slidefn[0][k] == '\n' || slidefn[0][k] == EOF)
       slidefn[0][k] == '\0';
    if(slidefn[1][k] == '\n' || slidefn[1][k] == EOF)
       slidefn[1][k] == '\0';
    if(slidefn[2][k] == '\n' || slidefn[2][k] == EOF)
       slidefn[2][k] == '\0';
    if(slidefn[3][k] == '\n' || slidefn[3][k] == EOF)
       slidefn[3][k] == '\0';
  }
  if(slide1)
  {
    load_slide(1);
    showing = 1;
  }
  else if(slide2)
  {
    load_slide(2);
    showing = 2;
  }
  else showing = 0;
  
  //printf("\n\n\nTU NEPADAM 7\n\n\n");
  fclose(f);
  // tu sa zacnu nacitavat bricky
  char pozadiefn[17];
  memset(pozadiefn, '\0', 17);
  if(typpozadia == FORREST || typpozadia == MEADOW)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTopLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTopRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid6.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid7.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveright.png");
    if(typpozadia == FORREST)
      sprintf(pozadiefn, "img/bg/for");
    if(typpozadia == MEADOW)
      sprintf(pozadiefn, "img/bg/mea");
  }
  if(typpozadia == CAVE || typpozadia == VOLCANO)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickCaveTopLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickCaveTopRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop4.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveucurveright.png");
    if(typpozadia == CAVE)
      sprintf(pozadiefn, "img/bg/cav");
    if(typpozadia == VOLCANO)
      sprintf(pozadiefn, "img/bg/vol");
  }
  if(typpozadia == CASTLE)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid6.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid7.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveright.png");
    sprintf(pozadiefn, "img/bg/cas");
  }
  if(typpozadia == BEACH)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoupLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoupRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMidskull.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMidskull.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvupleft.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvupright.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvdownleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvdownright.png");
    sprintf(pozadiefn, "img/bg/bea");
  }
  // tu sa zacnu nacitavat slajcy
  pozadiefn[12] = '.';
  pozadiefn[13] = 'p';
  pozadiefn[14] = 'n';
  pozadiefn[15] = 'g';
  pozadiefn[16] = '\0';
  for(int i = 0; i < 16; i++)
  {
    pozadiefn[10] = (i/10)+48;
    pozadiefn[11] = (i%10)+48;
    
    bg[i] = dl_util_makeHgeQuad(hgge, i*128, 0, 128, 768, 0xffffffff, pozadiefn);
  }
  
  //printf("\n\n\nvykonal som init levelu\n\n\n");
}

int DL_LEVEL::init_mp(int levelno)//1 - og 2 - dano 3 - lan
{ 
  curlvl = 20+levelno;
  // what level to open?
  char fn[16];
  if(levelno == 1)
    sprintf(fn,"lvl/mp1.lvl");
  if(levelno == 2)
    sprintf(fn,"lvl/mp2.lvl");
  if(levelno == 3)
    sprintf(fn,"lvl/mp3.lvl");
  // now open it
  //    let's get it on
  FILE *f;
  f = fopen(fn,"r");
  ww = 192;
  hh = 24;
  fscanf(f, "%d %f %f %d %d", &typpozadia, &mp_maxlife, &mp_maxmana, &mp_atk, &mp_fbstrength);
  //    what's happening? d-d-d-dot-a
  for(int i = 0; i < hh; i++)
  {
   for(int j = 0; j < ww; j++)
   {
     fscanf(f, "%d", &data[j][i]);
   }
  }
  //    i hear you man!
  //chillout
  fscanf(f, "%d %d", &bluesp.x, &bluesp.y);
  fscanf(f, "%d %d", &redsp.x, &redsp.y);
  int nof_sp = 0;
  fscanf(f, "%d", &nof_sp);
  for(int i = 0; i < nof_sp; i++)
  {
    fscanf(f, "%d %d", &roguesp[i].x, &roguesp[i].y);
  }
  fclose(f);
  showing = 0;
  // tu sa zacnu nacitavat bricky
  char pozadiefn[17];
  memset(pozadiefn, '\0', 17);
  if(typpozadia == FORREST || typpozadia == MEADOW)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTopLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTopRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestTop5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid6.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid7.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveright.png");
    if(typpozadia == FORREST)
      sprintf(pozadiefn, "img/bg/for");
    if(typpozadia == MEADOW)
      sprintf(pozadiefn, "img/bg/mea");
  }
  if(typpozadia == CAVE || typpozadia == VOLCANO)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickCaveTopLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickCaveTopRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveTop4.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveMid5.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/cavebricks/brickcaveucurveright.png");
    if(typpozadia == CAVE)
      sprintf(pozadiefn, "img/bg/cav");
    if(typpozadia == VOLCANO)
      sprintf(pozadiefn, "img/bg/vol");
  }
  if(typpozadia == CASTLE)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/castlebricks/brickcastleMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid6.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestMid7.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurveup.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestCurvedown.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/forrestbricks/brickForrestucurveright.png");
    sprintf(pozadiefn, "img/bg/cas");
  }
  if(typpozadia == BEACH)
  {
    brick[0]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoupLeft.png");
    brick[1]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoupRight.png");
    brick[2]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachLeft.png");
    brick[3]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachRight.png");
    brick[4]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup1.png");
    brick[5]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup2.png");
    brick[6]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup3.png");
    brick[7]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup4.png");
    brick[8]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachup5.png");
    brick[9]  = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid1.png");
    brick[10] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid2.png");
    brick[11] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid3.png");
    brick[12] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid4.png");
    brick[13] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMid5.png");
    brick[14] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMidskull.png");
    brick[15] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachMidskull.png");
    brick[16] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvupleft.png");
    brick[17] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvupright.png");
    brick[18] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoDownleft.png");
    brick[19] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcoDownright.png");
    brick[20] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown1.png");
    brick[21] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown2.png");
    brick[22] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachDown3.png");
    brick[23] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvdownleft.png");
    brick[24] = dl_util_makeHgeQuad(hgge, 0, 0, 32, 32, 0xffffffff, "img/beachbricks/brickbeachcvdownright.png");
    sprintf(pozadiefn, "img/bg/bea");
  }
  // tu sa zacnu nacitavat slajcy
  pozadiefn[12] = '.';
  pozadiefn[13] = 'p';
  pozadiefn[14] = 'n';
  pozadiefn[15] = 'g';
  pozadiefn[16] = '\0';
  for(int i = 0; i < 16; i++)
  {
    pozadiefn[10] = (i/10)+48;
    pozadiefn[11] = (i%10)+48;
    
    bg[i] = dl_util_makeHgeQuad(hgge, i*128, 0, 128, 768, 0xffffffff, pozadiefn);
  }
  
  //printf("\n\n\nvykonal som init levelu\n\n\n");
}

int DL_LEVEL::load_slide(int slideno)
{
  slide = dl_util_makeHgeQuad(hgge, 0,0,1024,768,0xffffffff, slidefn[slideno-1]);
}
int DL_LEVEL::unload_slide()
{
  if(slide != NULL && slide->tex != 0)
  {
    hgge->Texture_Free(slide->tex);
    delete slide;
  }
}

int DL_LEVEL::add_player_single(int type, bool godlike)
{
 PLAYER p(hgge);
 //printf("tunak nepadam\n");
 p.type = type;  
 p.init(0, data, godlike);
 //printf("\n\nza initom\n\n");
 players.push_back(p);
 
 //printf("uspesne som pridal playera\n\n\n"); 
 return 1;  
}

int DL_LEVEL::add_player_multi(int id, char *nick)
{
 PLAYER p(hgge);
 //printf("tunak nepadam\n");
 p.type = 0;
 sprintf(p.nick, nick);
 p.init(id, data, false);
 //printf("\n\nza initom\n\n");
 players.push_back(p);
 
 //printf("uspesne som pridal playera\n\n\n"); 
 return 1;  
}

list<PLAYER>::iterator DL_LEVEL::search_player(int id)
{
  list<PLAYER>::iterator it;
  for(it = players.begin(); it != players.end(); it++)
  {
    if(it->ID == id)break;
  }
  return it;
}
