#ifndef __DL_LEVEL
#define __DL_LEVEL

#include "player.h"

#define MEADOW  1
#define FORREST 2
#define CAVE    3
#define VOLCANO 4
#define CASTLE  5
#define BEACH   6

typedef struct _SPAWNPOINT{
  int x;
  int y;
} SPAWNPOINT;

class DL_LEVEL
{
  public:
         DL_LEVEL();
         ~DL_LEVEL();
         int manage(int id, int soundvol);
         int draw_mp();
         int draw();
         int manage_mp(DL_WS_CLIENT *c, int player_id);
         int init(int lvlno);
         int init_mp(int lvlno);
         int deinit();
         bool pt_in(float x, float y);
         
         hgeQuad *bg[16];
         hgeQuad *brick[30];
         
         hgeQuad *slide;
         int slide1, slide2, slide3, slide4;
         int showing; // 0 - the game, 1-4 - slides
         char slidefn[4][33];
         int load_slide(int slideno);
         int unload_slide();
         int typpozadia;
         int curlvl;
         
         //int data[192][24];
         int unlockedlevels[15], donelevels[15];
//         int 
         int **data;
         int type;
         int ww, hh;
         float camleft;
         HGE *hgge;
         list<PLAYER> players;
         list<PLAYER>::iterator search_player(int id);
         int add_player_single(int type, bool godlike);//type = ged, tenar, therru
         int add_player_multi(int id, char *nick);
         
         //multiplayer veci
         SPAWNPOINT bluesp, redsp, roguesp[10];
         float mp_maxlife, mp_maxmana;
         int mp_atk, mp_fbstrength;
};

#endif
