#include "player.h"

PLAYER::PLAYER(HGE *nhge)
{
 hgge = nhge;
 //printf("mame playera");
 vx = 0.0f;
 vy = 0.0f;
 idedolava = 0;
 idedoprava = 0;
 lieta = 0;
 idehore = 0;
 smer = 6;
 frame = 0.0f;
 frameutok = 0.0f;
 utoci = qutoci = wutoci = eutoci = rutoci = autoci = sutoci = dutoci = futoci = false; //  ... :-| :-| ...
 is_par_cc = 0.0f;
 is_neg_aura = 0.0f;
 raged = 0.0f;
 frozen = 0.0f;
 kraca = 0.0f;
 skoncillevel = 0;
 startx= starty = endx = endy = 0;
 fbsfx = hgge->Effect_Load("snd/Fireball_20954.wav");
 team = 1;
 skore = 0;
}

PLAYER::~PLAYER()
{
 //printf("nemame playera");                 
}

int PLAYER::init(int id, int **dta, bool godlike)
{
  this->godlike = godlike;
  HTEXTURE texturka;
  texturka = hgge->Texture_Load("img/particles.png");
  HTEXTURE srdiecko;
  srdiecko = hgge->Texture_Load("img/srdiecko.png");
  bubblequad = dl_util_makeHgeQuad(hgge, 0, 0, 64, 64, 0xffffffff, "img/bubble.png");
  ragequad = dl_util_makeHgeQuad(hgge, 0, 0, 64, 64, 0xffffffff, "img/rage.png");
  bubbletime = 0.0f;
  for(int i = 0; i < 5; i++)
  {
    ps[i].init(texturka);
    ps[i].hgge = hgge;
  }
  for(int i = 0; i < 3; i++)
  {
    fb[i].init(texturka);
    fb[i].hgge = hgge;
  }
  for(int i = 0; i < 2; i++)
  {
    fr[i].init(texturka);
    fr[i].hgge = hgge;
  }
  for(int i = 0; i < 2; i++)
  {
    sp[i].init(texturka);
    sp[i].hgge = hgge;
  }
  int momo;
  for(momo = 0; momo < 2; momo++)
  {
   ch[momo].init(srdiecko);
   ch[momo].hgge = hgge;         
  }
  
  for(momo = 0; momo < 3; momo++)
  {
   sl[momo].init(texturka);
   sl[momo].hgge = hgge;         
  }
  
  for(momo = 0; momo < 3; momo++)
  {
   mn[momo].hgge = hgge;
   mn[momo].init(texturka);         
  }
  md.init(texturka);
  md.hgge = hgge;
  ld.init(texturka);
  ld.hgge = hgge;
  
  mw.init(hgge, "img/magicwall.png");
  as.init(hgge, texturka);
  
  spr_cc = new hgeSprite(texturka, 0, 64, 32, 32);
  spr_cc->SetColor(0xffffffff);
  spr_cc->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
  par_cc = new hgeParticleSystem("par/changecharacter.psi", spr_cc);
  
  spr_na = new hgeSprite(texturka, 0, 96, 32, 32);
  spr_na->SetColor(0xffffffff);
  spr_na->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE);
  par_na = new hgeParticleSystem("par/negativeaura.psi", spr_na);
  
  heal_spr = new hgeSprite(texturka, 64, 0, 32, 32);
  heal_spr->SetColor(0xffffffff);
  heal_spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
  heal_par = new hgeParticleSystem("par/heal.psi", heal_spr);
  
  spr_el = new hgeSprite(texturka, 0, 32, 32, 32);
  spr_el->SetColor(0xffffffff);
  spr_el->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
  par_el = new hgeParticleSystem("par/endoflevel.psi", spr_el);
  par_el->info.nEmission = 60;
  is_eol = 0;
  is_par_cc = 0.0f;
  
  gedwalkanim = new animation(hgge, 32,64);
  gedwalkanim->add_frame("img/gedwalk1.png");
  gedwalkanim->add_frame("img/gedwalk2.png");
  gedwalkanim->add_frame("img/gedwalk3.png");
  gedwalkanim->add_frame("img/gedwalk4.png");
  gedwalkanim->add_frame("img/gedwalk5.png");
  gedwalkanim->add_frame("img/gedwalk6.png");
  gedwalkanim->add_frame("img/gedwalk7.png");
  gedwalkanim->add_frame("img/gedwalk8.png");
  gedwalkanim->set_frame(0);
  
  tenarwalkanim = new animation(hgge, 32,64);
  tenarwalkanim->add_frame("img/tenarwalk1.png");
  tenarwalkanim->add_frame("img/tenarwalk2.png");
  tenarwalkanim->add_frame("img/tenarwalk3.png");
  tenarwalkanim->add_frame("img/tenarwalk4.png");
  tenarwalkanim->add_frame("img/tenarwalk5.png");
  tenarwalkanim->add_frame("img/tenarwalk6.png");
  tenarwalkanim->add_frame("img/tenarwalk7.png");
  tenarwalkanim->add_frame("img/tenarwalk8.png");
  tenarwalkanim->set_frame(0);
  
  therruwalkanim = new animation(hgge, 32,64);
  therruwalkanim->add_frame("img/therruwalk1.png");
  therruwalkanim->add_frame("img/therruwalk2.png");
  therruwalkanim->add_frame("img/therruwalk3.png");
  therruwalkanim->add_frame("img/therruwalk4.png");
  therruwalkanim->add_frame("img/therruwalk5.png");
  therruwalkanim->add_frame("img/therruwalk6.png");
  therruwalkanim->add_frame("img/therruwalk7.png");
  therruwalkanim->add_frame("img/therruwalk8.png");
  therruwalkanim->set_frame(0);
  
  gedoffanim = new animation(hgge,64,64);
  gedoffanim->add_frame("img/gedoff1.png");
  gedoffanim->add_frame("img/gedoff2.png");
  gedoffanim->add_frame("img/gedoff3.png");
  gedoffanim->add_frame("img/gedoff4.png");
  gedoffanim->add_frame("img/gedoff4.png");
  gedoffanim->add_frame("img/gedoff3.png");
  gedoffanim->add_frame("img/gedoff2.png");
  gedoffanim->add_frame("img/gedoff1.png");
  gedoffanim->set_frame(0);
  
  geddefanim = new animation(hgge,64,64);
  geddefanim->add_frame("img/geddef1.png");
  geddefanim->add_frame("img/geddef2.png");
  geddefanim->add_frame("img/geddef3.png");
  geddefanim->add_frame("img/geddef4.png");
  geddefanim->add_frame("img/geddef4.png");
  geddefanim->add_frame("img/geddef3.png");
  geddefanim->add_frame("img/geddef2.png");
  geddefanim->add_frame("img/geddef1.png");
  geddefanim->set_frame(0);
  
  tenarspcanim = new animation(hgge,64,64);
  tenarspcanim->add_frame("img/tenarat1.png");
  tenarspcanim->add_frame("img/tenarat2.png");
  tenarspcanim->add_frame("img/tenarat3.png");
  tenarspcanim->add_frame("img/tenarat4.png");
  tenarspcanim->add_frame("img/tenarat5.png");
  tenarspcanim->add_frame("img/tenarat6.png");
  tenarspcanim->add_frame("img/tenarat1.png");
  tenarspcanim->add_frame("img/tenarat1.png");
  tenarspcanim->set_frame(0);
  
  tenarcstanim = new animation(hgge,64,64);
  tenarcstanim->add_frame("img/tenarat1.png");
  tenarcstanim->add_frame("img/tenarat2.png");
  tenarcstanim->add_frame("img/tenarat3.png");
  tenarcstanim->add_frame("img/tenarat4.png");
  tenarcstanim->add_frame("img/tenarat5.png");
  tenarcstanim->add_frame("img/tenarat6.png");
  tenarcstanim->add_frame("img/tenarat1.png");
  tenarcstanim->add_frame("img/tenarat1.png");
  tenarcstanim->set_frame(0);
  
  therruspcanim = new animation(hgge,64,64);
  therruspcanim->add_frame("img/therruat1.png");
  therruspcanim->add_frame("img/therruat2.png");
  therruspcanim->add_frame("img/therruat3.png");
  therruspcanim->add_frame("img/therruat4.png");
  therruspcanim->add_frame("img/therruat4.png");
  therruspcanim->add_frame("img/therruat3.png");
  therruspcanim->add_frame("img/therruat2.png");
  therruspcanim->add_frame("img/therruat1.png");
  therruspcanim->set_frame(0);
  
  therrucstanim = new animation(hgge,64,64);
  therrucstanim->add_frame("img/therrucast1.png");
  therrucstanim->add_frame("img/therrucast2.png");
  therrucstanim->add_frame("img/therrucast3.png");
  therrucstanim->add_frame("img/therrucast4.png");
  therrucstanim->add_frame("img/therrucast4.png");
  therrucstanim->add_frame("img/therrucast3.png");
  therrucstanim->add_frame("img/therrucast2.png");
  therrucstanim->add_frame("img/therrucast1.png");
  therrucstanim->set_frame(0);
 
  sekac1anim = new animation(hgge,64,64);
  sekac1anim->add_frame("img/enknsilver1.png");
  sekac1anim->add_frame("img/enknsilver2.png");
  sekac1anim->add_frame("img/enknsilver3.png");
  sekac1anim->add_frame("img/enknsilver4.png");
  sekac1anim->add_frame("img/enknsilver5.png");
  sekac1anim->add_frame("img/enknsilver6.png");
  sekac1anim->add_frame("img/enknsilver7.png");
  sekac1anim->add_frame("img/enknsilver8.png");
  sekac1anim->set_frame(0);
  
  sekac2anim = new animation(hgge,64,64);
  sekac2anim->add_frame("img/enknblue1.png");
  sekac2anim->add_frame("img/enknblue2.png");
  sekac2anim->add_frame("img/enknblue3.png");
  sekac2anim->add_frame("img/enknblue4.png");
  sekac2anim->add_frame("img/enknblue5.png");
  sekac2anim->add_frame("img/enknblue6.png");
  sekac2anim->add_frame("img/enknblue7.png");
  sekac2anim->add_frame("img/enknblue8.png");
  sekac2anim->set_frame(0);
  
  sekac3anim = new animation(hgge,64,64);
  sekac3anim->add_frame("img/enknbrown1.png");
  sekac3anim->add_frame("img/enknbrown2.png");
  sekac3anim->add_frame("img/enknbrown3.png");
  sekac3anim->add_frame("img/enknbrown4.png");
  sekac3anim->add_frame("img/enknbrown5.png");
  sekac3anim->add_frame("img/enknbrown6.png");
  sekac3anim->add_frame("img/enknbrown7.png");
  sekac3anim->add_frame("img/enknbrown8.png");
  sekac3anim->set_frame(0);
  
  cernochanim = new animation(hgge,64,64);
  cernochanim->add_frame("img/enmgnigga1.png");
  cernochanim->add_frame("img/enmgnigga2.png");
  cernochanim->add_frame("img/enmgnigga3.png");
  cernochanim->add_frame("img/enmgnigga4.png");
  cernochanim->add_frame("img/enmgnigga4.png");
  cernochanim->add_frame("img/enmgnigga3.png");
  cernochanim->add_frame("img/enmgnigga2.png");
  cernochanim->add_frame("img/enmgnigga1.png");
  cernochanim->set_frame(0);
  
  modrymageanim = new animation(hgge,64,64);
  modrymageanim->add_frame("img/enmgblue1.png");
  modrymageanim->add_frame("img/enmgblue2.png");
  modrymageanim->add_frame("img/enmgblue3.png");
  modrymageanim->add_frame("img/enmgblue4.png");
  modrymageanim->add_frame("img/enmgblue4.png");
  modrymageanim->add_frame("img/enmgblue3.png");
  modrymageanim->add_frame("img/enmgblue2.png");
  modrymageanim->add_frame("img/enmgblue1.png");
  modrymageanim->set_frame(0);
  
  ID = id;
  data = dta;
  emptyball = dl_util_makeHgeQuad(hgge, 0, 0, 128, 128, 0xffffffff, "img/emptysphere.png");
  lifeball = dl_util_makeHgeQuad(hgge, 0, 0, 128, 128, 0xffffffff, "img/healthsphere.png");
  manaball = dl_util_makeHgeQuad(hgge, 896, 0, 128, 128, 0xffffffff, "img/manasphere.png");
  runa1 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla1.png");
  runa2 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla2.png");
  runa3 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla3.png");
  runa4 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla4.png");
  runa5 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla5.png");
  runa6 = dl_util_makeHgeQuad(hgge, -32, -32, 32, 32, 0xffffffff, "img/starobyla6.png");
 
 return 1;              
}

list<SEKAC>::iterator PLAYER::search_sekac(int id)
{
  list<SEKAC>::iterator it;
  for(it = sekaci.begin(); it != sekaci.end(); it++)
  {
    if(it->ID == id) break;
  }
  return it;
}

list<CERNOCH>::iterator PLAYER::search_cernoch(int id)
{
  list<CERNOCH>::iterator it;
  for(it = cernosi.begin(); it != cernosi.end(); it++)
  {
    if(it->ID == id) break;
  }
  return it;
}

list<MAGEMODRY>::iterator PLAYER::search_magemodry(int id)
{
  list<MAGEMODRY>::iterator it;
  for(it = modri.begin(); it != modri.end(); it++)
  {
    if(it->ID == id) break;
  }
  return it;
}

int PLAYER::draw_mp(float cl)
{
    
}

int PLAYER::draw(float cl)
{
 if(frame > MAXFRAME)
   frame = 0.0f;
 if(frame < -MAXFRAME)
   frame = 0.0f;
 if(!idedolava && !idedoprava && frame > 0.0f && frame < MAXFRAME/2)
   frame -= 0.1;
 if(!idedolava && !idedoprava && frame > 0.0f && frame > MAXFRAME/2)
   frame += 0.1;
 if(!idedolava && !idedoprava && frame < 0.0f && frame > -MAXFRAME/2)
   frame += 0.1;
 if(!idedolava && !idedoprava && frame < 0.0f && frame < -MAXFRAME/2)
   frame -= 0.1;
  if(type == GED)
    gedwalkanim->set_frame(abs((int)frame));
  if(type == KNAZKA)
    tenarwalkanim->set_frame(abs((int)frame));
  if(type == DECKO)
    therruwalkanim->set_frame(abs((int)frame));
  if(israged == 1)
  {
    ragequad->v[0].x = x-cl-16;    ragequad->v[0].y = y;
    ragequad->v[1].x = x-cl+48;    ragequad->v[1].y = y;
    ragequad->v[2].x = x-cl+48;    ragequad->v[2].y = y+64;
    ragequad->v[3].x = x-cl-16;    ragequad->v[3].y = y+64; 
    hgge->Gfx_RenderQuad(ragequad);
  }
  
  hgeQuad *q;
  DWORD colour;
  if(frozen > 0.0f)
  {
    if(frame >= MAXFRAME) frame = 0.0f;
    if(frame <= -MAXFRAME) frame = 0.0f;
    if(type == GED)
    {
      if(utoci || qutoci || wutoci || eutoci || rutoci)
        q = *(gedoffanim->get_frame(frameutok));
      else if(autoci || sutoci || dutoci || futoci)
        q = *(geddefanim->get_frame(frameutok));
      else
        q = *(gedwalkanim->get_frame(abs((int)frame)));
    }
    else if(type == KNAZKA)
    {
      if(utoci)
        q = *(tenarspcanim->get_frame(frameutok));
      else if(autoci || sutoci || dutoci || futoci || qutoci || wutoci || eutoci || rutoci)
        q = *(tenarcstanim->get_frame(frameutok));
      else
        q = *(tenarwalkanim->get_frame(abs((int)frame)));
    }
    else if(type == DECKO)
    {
      if(utoci)
        q = *(therruspcanim->get_frame(frameutok));
      else if(autoci || sutoci || dutoci || futoci || qutoci || wutoci || eutoci || rutoci)
        q = *(therrucstanim->get_frame(frameutok));
      else
        q = *(therruwalkanim->get_frame(abs((int)frame)));
    }
    if(q != NULL)
    {
      colour = q->v[0].col;
      q->v[0].col = 0xff0000ff;
      q->v[1].col = 0xff0000ff;
      q->v[2].col = 0xff0000ff;
      q->v[3].col = 0xff0000ff;
      q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
    }
    else printf("q je zle\n");
  }
  if(smer == 4)
  {
    if(utoci || qutoci || wutoci || eutoci || rutoci)
    {
      if(type == GED)
        gedoffanim->draw_at(x-cl-32, y, true);
      //if(type == KNAZKA)
        //tenaroffanim->draw_at(x-cl-32, y, true);
      //if(type == DECKO)
        //therruoffanim->draw_at(x-cl-32, y, true);
    }
    else if(autoci || sutoci || dutoci || futoci)
    {
      if(type == GED)
        geddefanim->draw_at(x-cl-32, y, true);
      //if(type == KNAZKA)
        //tenardefanim->draw_at(x-cl-32, y, true);
      //if(type == DECKO)
        //therrudefanim->draw_at(x-cl-32, y, true);
    }
    else
    {
      if(type == GED)
        gedwalkanim->draw_at(x-cl, y, true);
      //if(type == KNAZKA)
        //tenarwalkanim->draw_at(x-cl, y, true);
      //if(type == DECKO)
        //therruwalkanim->draw_at(x-cl, y, true);
    }
    if(type==KNAZKA)
    {
      if(utoci)
        tenarspcanim->draw_at(x-cl-32, y, true);
      else if(qutoci || wutoci || eutoci || rutoci || autoci || sutoci || dutoci || futoci)
        tenarcstanim->draw_at(x-cl-32, y, true);
      else
        tenarwalkanim->draw_at(x-cl, y, true);
    }
    if(type==DECKO)
    {
      if(utoci)
        therruspcanim->draw_at(x-cl-32, y, true);
      else if(qutoci || wutoci || eutoci || rutoci || autoci || sutoci || dutoci || futoci)
        therrucstanim->draw_at(x-cl-32, y, true);
      else
        therruwalkanim->draw_at(x-cl, y, true);
    }
  }
  else if(smer == 6)
  {
    if(utoci || qutoci || wutoci || eutoci || rutoci)
    {
      if(type == GED)
        gedoffanim->draw_at(x-cl, y, false);
      //if(type == KNAZKA)
        //tenaroffanim->draw_at(x-cl, y, false);
      //if(type == DECKO)
        //therruoffanim->draw_at(x-cl, y, false);
    }
    else if(autoci || sutoci || dutoci || futoci)
    {
      if(type == GED)
        geddefanim->draw_at(x-cl, y, false);
      //if(type == KNAZKA)
        //tenardefanim->draw_at(x-cl, y, false);
      //if(type == DECKO)
        //therrudefanim->draw_at(x-cl, y, false);
    }
    else
    {
      if(type == GED)
        gedwalkanim->draw_at(x-cl, y, false);
      //if(type == KNAZKA)
        //tenarwalkanim->draw_at(x-cl, y, false);
      //if(type == DECKO)
        //therruwalkanim->draw_at(x-cl, y, false);
    }
    if(type== KNAZKA)
    {
      if(utoci)
        tenarspcanim->draw_at(x-cl, y, false);
      else if(qutoci || wutoci || eutoci || rutoci || autoci || sutoci || dutoci || futoci)
        tenarcstanim->draw_at(x-cl, y, false);
      else
        tenarwalkanim->draw_at(x-cl, y, false);
    }
    if(type== DECKO)
    {
      if(utoci)
        therruspcanim->draw_at(x-cl, y, false);
      else if(qutoci || wutoci || eutoci || rutoci || autoci || sutoci || dutoci || futoci)
        therrucstanim->draw_at(x-cl, y, false);
      else
        therruwalkanim->draw_at(x-cl, y, false);
    }
  }
  if(frozen > 0.0f)
  {
    if(q != NULL)
    {
      q->v[0].col = colour;
      q->v[1].col = colour;
      q->v[2].col = colour;
      q->v[3].col = colour;
      q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
    }
    else printf("Q JE ZLE!!!\n");
  }
 list<RUNA>::iterator itr;
 hgeQuad *runa = NULL;
 for(itr = runy.begin(); itr != runy.end(); itr++)
 {
   if(itr->visible && itr->x - cl > -32 && itr->x - cl < 1024)
   {
    switch(itr->type)
    {
      case 1:
        runa = runa1;
        break;
      case 2:
        runa = runa2;
        break;
      case 3:
        runa = runa3;
        break;
      case 4:
        runa = runa4;
        break;
      case 5:
        runa = runa5;
        break;
      case 6:
        runa = runa6;
        break;
    }
    if(runa != NULL)
    {
      runa->v[0].x = itr->x - cl;    runa->v[0].y = itr->y;
      runa->v[1].x = itr->x - cl+32; runa->v[1].y = itr->y;
      runa->v[2].x = itr->x - cl+32; runa->v[2].y = itr->y+32;
      runa->v[3].x = itr->x - cl;    runa->v[3].y = itr->y+32;
      hgge->Gfx_RenderQuad(runa);
    }
   }
 }
 list<SEKAC>::iterator its;
 for(its = sekaci.begin(); its != sekaci.end(); its++)
 {
   if(its->life > 0 && (its->x-cl) > -32 && (its->x-cl) < 1024)
   {
     if(its->type == ANIM_SEKAC1)
      sekac1anim->set_frame(its->frame);
     if(its->type == ANIM_SEKAC2)
      sekac2anim->set_frame(its->frame);
     if(its->type == ANIM_SEKAC3)
      sekac3anim->set_frame(its->frame);
     if(its->frozen > 0)
     {
       if(its->type == ANIM_SEKAC1)
        q = *(sekac1anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC2)
        q = *(sekac2anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC3)
        q = *(sekac3anim->get_frame(its->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff0000ff;
       q->v[1].col = 0xff0000ff;
       q->v[2].col = 0xff0000ff;
       q->v[3].col = 0xff0000ff;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       if(its->type == ANIM_SEKAC1)
        sekac1anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC2)
        sekac2anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC3)
        sekac3anim->draw_at(its->x-cl, its->y, !its->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(its->charmed > 0)
     {
       if(its->type == ANIM_SEKAC1)
        q = *(sekac1anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC2)
        q = *(sekac2anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC3)
        q = *(sekac3anim->get_frame(its->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xffff0000;
       q->v[1].col = 0xffff0000;
       q->v[2].col = 0xffff0000;
       q->v[3].col = 0xffff0000;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       if(its->type == ANIM_SEKAC1)
        sekac1anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC2)
        sekac2anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC3)
        sekac3anim->draw_at(its->x-cl, its->y, !its->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(its->sleeped > 0)
     {
       if(its->type == ANIM_SEKAC1)
        q = *(sekac1anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC2)
        q = *(sekac2anim->get_frame(its->frame));
       if(its->type == ANIM_SEKAC3)
        q = *(sekac3anim->get_frame(its->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff808080;
       q->v[1].col = 0xff808080;
       q->v[2].col = 0xff808080;
       q->v[3].col = 0xff808080;
       if(its->type == ANIM_SEKAC1)
        sekac1anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC2)
        sekac2anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC3)
        sekac3anim->draw_at(its->x-cl, its->y, !its->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
     }
     else
     {
       if(its->type == ANIM_SEKAC1)
        sekac1anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC2)
        sekac2anim->draw_at(its->x-cl, its->y, !its->direction);
       if(its->type == ANIM_SEKAC3)
        sekac3anim->draw_at(its->x-cl, its->y, !its->direction);
     }    
     its->parsleep->Render();
   }  
 }
 list<CERNOCH>::iterator itc;
 // CERNOSI! NA NASEJ SKOLE! VELA CERNOCHOV! Mal si dojst, noob. (Kubo Liptak, 14.04.2008, 12:58)
 float cx = -32;
 for(itc = cernosi.begin(); itc != cernosi.end(); itc++)
 {
   if(itc->life > 0 && (itc->x-cl) > -32 && (itc->x-cl) < 1024)
   {
     if(itc->direction)
       cx = itc->x-cl;
     else
       cx = itc->x-cl-32;
     cernochanim->set_frame(itc->frame);
     if(itc->frozen > 0)
     {
       q = *(cernochanim->get_frame(itc->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff0000ff;
       q->v[1].col = 0xff0000ff;
       q->v[2].col = 0xff0000ff;
       q->v[3].col = 0xff0000ff;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       cernochanim->draw_at(cx, itc->y, !itc->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(itc->charmed > 0)
     {
       q = *(cernochanim->get_frame(itc->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xffff0000;
       q->v[1].col = 0xffff0000;
       q->v[2].col = 0xffff0000;
       q->v[3].col = 0xffff0000;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       cernochanim->draw_at(cx, itc->y, !itc->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(itc->sleeped > 0)
     {
       q = *(cernochanim->get_frame(itc->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff808080;
       q->v[1].col = 0xff808080;
       q->v[2].col = 0xff808080;
       q->v[3].col = 0xff808080;
       cernochanim->draw_at(cx, itc->y, !itc->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
     }
     else
     {
       cernochanim->draw_at(cx, itc->y, !itc->direction);
     }
     
     itc->parsleep->Render();
   }
   itc->cfb.draw(); 
 }
 
 list<MAGEMODRY>::iterator itm;
 float mx = -32;
 // magemodri
 for(itm = modri.begin(); itm != modri.end(); itm++)
 {
   if(itm->life > 0 && (itm->x-cl) > -32 && (itm->x-cl) < 1024)
   {
     if(itm->direction)
       mx = itm->x-cl;
     else
       mx = itm->x-cl-32;
     modrymageanim->set_frame(itm->frame);
     if(itm->frozen > 0)
     {
       q = *(modrymageanim->get_frame(itm->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff0000ff;
       q->v[1].col = 0xff0000ff;
       q->v[2].col = 0xff0000ff;
       q->v[3].col = 0xff0000ff;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       modrymageanim->draw_at(mx, itm->y, !itm->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(itm->charmed > 0)
     {
       q = *(modrymageanim->get_frame(itm->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xffff0000;
       q->v[1].col = 0xffff0000;
       q->v[2].col = 0xffff0000;
       q->v[3].col = 0xffff0000;
       q->blend = BLEND_COLORADD | BLEND_ALPHAADD | BLEND_NOZWRITE;
       modrymageanim->draw_at(mx, itm->y, !itm->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
       q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
     }
     else if(itm->sleeped > 0)
     {
       q = *(modrymageanim->get_frame(itm->frame));
       DWORD colour = q->v[0].col;
       q->v[0].col = 0xff808080;
       q->v[1].col = 0xff808080;
       q->v[2].col = 0xff808080;
       q->v[3].col = 0xff808080;
       modrymageanim->draw_at(mx, itm->y, !itm->direction);
       q->v[0].col = colour;
       q->v[1].col = colour;
       q->v[2].col = colour;
       q->v[3].col = colour;
     }
     else
     {
       modrymageanim->draw_at(mx, itm->y, !itm->direction);
     }
     
     itm->parsleep->Render();
   }
   itm->cfr.draw(); 
 }
 list<VTAK>::iterator itv;
 for(itv = vtaci.begin(); itv != vtaci.end(); itv++)
 {
   itv->draw(cl);
 }
 for(int i = 0; i < 3; i++)
 {
   fb[i].draw();
   sl[i].draw();
   mn[i].draw(cl);
 }
 for(int i = 0; i < 5; i++)
 {
   ps[i].draw();
 }
 fr[0].draw();
 fr[1].draw();
 ch[0].draw();
 ch[1].draw();
 sp[0].draw();
 sp[1].draw();
 ld.draw();
 md.draw();
 mw.draw(cl);
 as.draw(cl);
 
 par_cc->Render();
 par_na->Render();
 heal_par->Render();
 
 if(bubbletime > 0.0f)
 {
    bubblequad->v[0].x = x-16-cl;
    bubblequad->v[1].x = x+48-cl;
    bubblequad->v[2].x = x+48-cl;
    bubblequad->v[3].x = x-16-cl;
    bubblequad->v[0].y = y;
    bubblequad->v[1].y = y;
    bubblequad->v[2].y = y+64;
    bubblequad->v[3].y = y+64;
    hgge->Gfx_RenderQuad(bubblequad);
 }
 //potions
 list<POTION>::iterator itp;
 for(itp = potions.begin(); itp != potions.end(); itp++)
 {
    itp->draw(cl);
 }
 if(is_eol == 1)
 {
   par_el->Transpose((endx*32)-cl, (endy*32));
   par_el->Render();
 }
 
 emptyball->v[0].x = 0;   emptyball->v[0].y = 0;
 emptyball->v[1].x = 128; emptyball->v[1].y = 0;
 emptyball->v[2].x = 128; emptyball->v[2].y = 128;
 emptyball->v[3].x = 0;   emptyball->v[3].y = 128;
 hgge->Gfx_RenderQuad(emptyball);
  
 lifeball->v[0].x = 0;   lifeball->v[0].y = 118-(int)((life/maxlife)*108.0f);
 lifeball->v[1].x = 128; lifeball->v[1].y = 118-(int)((life/maxlife)*108.0f);
 lifeball->v[2].x = 128; lifeball->v[2].y = 118;
 lifeball->v[3].x = 0;   lifeball->v[3].y = 118;
 
 lifeball->v[0].tx = 0.0f;   lifeball->v[0].ty = 1.0f-((life/maxlife)*0.84375f+0.078125f);
 lifeball->v[1].tx = 1.0f;   lifeball->v[1].ty = 1.0f-((life/maxlife)*0.84375f+0.078125f);
 lifeball->v[2].tx = 1.0f;   lifeball->v[2].ty = 0.921875f;
 lifeball->v[3].tx = 0.0f;   lifeball->v[3].ty = 0.921875f;
 hgge->Gfx_RenderQuad(lifeball);
 
 
 emptyball->v[0].x = 896;   emptyball->v[0].y = 0;
 emptyball->v[1].x = 1024; emptyball->v[1].y = 0;
 emptyball->v[2].x = 1024; emptyball->v[2].y = 128;
 emptyball->v[3].x = 896;   emptyball->v[3].y = 128;
 hgge->Gfx_RenderQuad(emptyball);
 
 manaball->v[0].x = 896;  manaball->v[0].y = 118-(int)((mana/maxmana)*108.0f);
 manaball->v[1].x = 1024; manaball->v[1].y = 118-(int)((mana/maxmana)*108.0f);
 manaball->v[2].x = 1024; manaball->v[2].y = 118;
 manaball->v[3].x = 896;  manaball->v[3].y = 118;
 
 manaball->v[0].tx = 0.0f;  manaball->v[0].ty = 1.0f-((mana/maxmana)*0.84375f+0.078125f);
 manaball->v[1].tx = 1.0f;  manaball->v[1].ty = 1.0f-((mana/maxmana)*0.84375f+0.078125f);
 manaball->v[2].tx = 1.0f;  manaball->v[2].ty = 0.921875f;
 manaball->v[3].tx = 0.0f;  manaball->v[3].ty = 0.921875f;
 
 hgge->Gfx_RenderQuad(manaball);
 
 return 1;    
}



int PLAYER::manage_mp(float camleft, DL_WS_CLIENT *c)
{
 float dt;
 dt = hgge->Timer_GetDelta();
 BUFFER msg;
 /*if(it->utoci)
 {
  sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?", (player_id/10), (player_id%10), 0, it->x, it->y, it->smer);
  c->dl_send(msg);
 }
 if(it->qutoci)
 {
  sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?", (player_id/10), (player_id%10), 1, it->x, it->y, it->smer);
  c->dl_send(msg);
 }*/
  
 //mana regen
 mana += 0.01f;
 if(mana > maxmana)mana = maxmana;
 if(life > maxlife)life = maxlife;
 if(frozen > 0.0f) frozen -= 0.1f;
 //q u geda
 if(hgge->Input_KeyDown(HGEK_Q) && frozen <= 0.0f && mana >= 10)
  {
   for(int i = 0; i < 3; i++)
   {
     if(fb[i].vystreleny == 0)
     {
       fb[i].y = y+16;
       fb[i].vystreleny = 1;
       mana -= 10;
       hgge->Effect_Play(fbsfx);
       if(smer == 4)
       {
        fb[i].x = x-48;
        fb[i].vx = -3.5f;
       }
       if(smer == 6)
       {
        fb[i].x = x+48;
        fb[i].vx = 3.5f;
       }
       sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?%d?", ID/10, ID%10, 1, (int)fb[i].x, (int)fb[i].y, smer, i);
       c->dl_send(msg.buffer);
       qutoci = true;
       frameutok = 0.0f;
       fb[i].par->Fire();
       break;
     }
   }
 }
 for(int i = 0; i < 3; i++)
 {
   fb[i].manage(camleft);
   if(fb[i].x > 0 && fb[i].x < 6144)
   if(data[(int)fb[i].x/32][(int)fb[i].y/32] > 0 && data[(int)fb[i].x/32][(int)fb[i].y/32] < 100)
   {
     fb[i].vystreleny = 0;
     fb[i].par->Stop();
     sprintf(msg.buffer, "72%d%d?%d?%d?", ID/10, ID%10, 1, i);
     c->dl_send(msg.buffer);
   }
 }
 if(hgge->Input_KeyDown(HGEK_W) && frozen <= 0.0f && mana >= 10)
  {
   for(int i = 0; i < 2; i++)
   {
     if(fr[i].vystreleny == 0)
     {
       fr[i].y = y+16;
       fr[i].vystreleny = 1;
       mana -= 10;
       if(smer == 4)
       {
        fr[i].x = x-48;
        fr[i].vx = -2.5f;
       }
       if(smer == 6)
       {
        fr[i].x = x+48;
        fr[i].vx = 2.5f;
       }
       sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?%d?", ID/10, ID%10, 2, (int)fr[i].x, (int)fr[i].y, smer, i);
       c->dl_send(msg.buffer);
       wutoci = true;
       frameutok = 0.0f;
       fr[i].par->Fire();
       break;
     }
   }
 }
 for(int i = 0; i < 2; i++) 
 {
  fr[i].manage(camleft);
  if(fr[i].x > 0 && fr[i].x < 6144)
  if(data[(int)fr[i].x/32][(int)fr[i].y/32] > 0 && data[(int)fr[i].x/32][(int)fr[i].y/32] < 100)
  {
    fr[i].vystreleny = 0;
    fr[i].par->Stop();
     sprintf(msg.buffer, "72%d%d?%d?%d?", ID/10, ID%10, 2, i);
     c->dl_send(msg.buffer);
    
  }
 }
 
 if(hgge->Input_KeyDown(HGEK_E) && frozen <= 0.0f && mana >= 10)
 {
  if(!lieta && x > 160 && x < 6108 && smer == 4)
  {
    if(data[(int)(x-160)/32][(int)y/32] == 0 && data[(int)(x-128)/32][(int)y/32] == 0 &&
       data[(int)(x-160)/32][(int)(y+32)/32] == 0 && data[(int)(x-128)/32][(int)(y+32)/32] == 0 &&
       data[(int)(x-160)/32][(int)(y+64)/32] != 0 && data[(int)(x-128)/32][(int)(y+64)/32] != 0)
    {
       x -= 160;
       mana -= 10;
       sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?%d?", ID/10, ID%10, 3, (int)x, (int)y, smer, 1);
       c->dl_send(msg.buffer);
    }
  }
  if(!lieta && x >= 0 && x < 5947 && smer == 6)
  {
    if(data[(int)(x+160)/32][(int)y/32] == 0 && data[(int)(x+192)/32][(int)y/32] == 0 &&
       data[(int)(x+160)/32][(int)(y+32)/32] == 0 && data[(int)(x+192)/32][(int)(y+32)/32] == 0 &&
       data[(int)(x+160)/32][(int)(y+64)/32] != 0 && data[(int)(x+192)/32][(int)(y+64)/32] != 0)
    {
       x += 160;
       mana -= 10;
       sprintf(msg.buffer, "71%d%d?%d?%d?%d?%d?%d?", ID/10, ID%10, 3, (int)x, (int)y, smer, 1);
       c->dl_send(msg.buffer);
    }
  }
 }
 if(qutoci || wutoci)
 {
   if(frameutok < MAXFRAME)
   {
     if(frozen <= 0.0f)frameutok+=0.1;
   }
   gedoffanim->set_frame(frameutok);
     
   if(frameutok >= MAXFRAME)
     utoci = qutoci = wutoci = eutoci = rutoci = false;
 }
}

int PLAYER::manage(float camleft, int soundvol)
{
 //nejaky manage();
 float dt;
 dt = hgge->Timer_GetDelta();
 
 list<SEKAC>::iterator its, itss;
 list<CERNOCH>::iterator itc, itcc;
 list<MAGEMODRY>::iterator itm, itmm;
 list<POTION>::iterator itp, itpp;
 list<RUNA>::iterator itr, itrr;
 int i;
 //kolizia s runami
 int nof_runes_invisible = 0;
 for(itr = runy.begin(); itr != runy.end(); itr++)
 {
   if((x - itr->x) < 32 && (itr->x - x) < 32 && (y - itr->y) < 32 && (itr->y - y) < 64)
   {
     itr->visible = 0;
   }
   if(itr->visible == 0) nof_runes_invisible++;
 }
 if(nof_runes_invisible == runy.size() && is_eol == 0)
 {
   is_eol = 1;
   //par_el->FireAt(endx*32.0f, endy*32.0f);
   par_el->FireAt(0,0);
 }
 if(is_eol == 1)
 {
   par_el->Update(dt);
   if(x - endx*32 < 32 && endx*32 - x < 32 && y - endy*32 < 32 && endy*32 - y < 64)
   skoncillevel = 1;
 }
 //mana regen
 mana += 0.01f;
 if(mana > maxmana)mana = maxmana;
 if(life > maxlife)life = maxlife;
 if(frozen > 0.0f) frozen -= 0.1f;
 //decko:
 //rage
  if(hgge->Input_KeyDown(HGEK_S) && type == DECKO && frozen <= 0.0f && mana >= 10.0f && nof_kuziel_therru >= 5)
  {
    sutoci = true;
    frameutok = 0.0f;
    if(!godlike)
      mana -= 10.0f;
    raged = 20.0f;
    israged = 1;
    atk *= 2;
    fbstrength *= 2;
    slstrength *= 2;
    psstrength *= 2;
  }
  if(raged > 0.0f)
  {
    life--;
    raged -= 0.1f;
  }
  if(israged == 1 && raged <= 0.0f)
  {
    raged = 0.0f;
    israged = 0;
    atk /= 2;
    fbstrength /= 2;
    slstrength /= 2;
    psstrength /= 2;
  }
 //negative aura
  if(hgge->Input_KeyDown(HGEK_A) && type == DECKO && frozen <= 0.0f && mana >= 10 && nof_kuziel_therru >= 4)
  {
    if(!godlike)
      mana -= 10;
    autoci = true;
    frameutok = 0.0f;
    par_na->FireAt(x, y+16);
    is_neg_aura = 10.0f;
  }
  par_na->Update(dt);
  if(is_neg_aura > 0.0f)
  {
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && itss->x < x+128 && itss->x > x-128 && itss->y > y-128 && itss->y < y+64)
      {
        itss->life--;
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && itcc->x < x+128 && itcc->x > x-128 && itcc->y > y-128 && itcc->y < y+64)
      {
        itcc->life--;
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && itmm->x < x+128 && itmm->x > x-128 && itmm->y > y-128 && itmm->y < y+64)
      {
        itmm->life--;
      }
    }
    par_na->MoveTo(x-16,y);
    par_na->Transpose(-camleft, 0);
    is_neg_aura -= 0.1f;
    if(is_neg_aura < 0.0f)
    {
     par_na->Stop();
    } 
  }
 //lift
  if(hgge->Input_KeyDown(HGEK_E) && type == DECKO && frozen <= 0.0f && mana >= 10 && nof_kuziel_therru >= 3)
  {
    if(!godlike)
      mana -= 10;
    eutoci = true;
    frameutok = 0.0f;
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(!itss->lifted)
      {
        itss->liftedstarty = itss->y;
        itss->lifted = 1;
        itss->vy = -7.0f;
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(!itcc->lifted)
      {
        itcc->liftedstarty = itcc->y;
        itcc->lifted = 1;
        itcc->vy = -7.0f;
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(!itmm->lifted)
      {
        itmm->liftedstarty = itmm->y;
        itmm->lifted = 1;
        itmm->vy = -7.0f;
      }
    }
  }
 //powershock
 if(hgge->Input_KeyDown(HGEK_W) && type == DECKO && frozen <= 0.0f && mana >= 10 && nof_kuziel_therru >= 2)
  {
   for(i = 0; i < 5; i++)
   {
     if(ps[i].vystreleny == 0)
     {
       ps[i].y = y+5;
       ps[i].vystreleny = 1;
    if(!godlike)
      mana -= 10;
       if(smer == 4)
       {
        ps[i].x = x-48;
        ps[i].vx = -3.5f;
       }
       if(smer == 6)
       {
        ps[i].x = x+48;
        ps[i].vx = 3.5f;
       }
       wutoci = true;
       frameutok = 0.0f;
       ps[i].par->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 5; i++)
 {
   ps[i].manage(camleft);
   if(ps[i].vystreleny == 1)
   {
     for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
     {
       if(itss->life > 0 && ps[i].x > itss->x && ps[i].x < itss->x+32 && ps[i].y > itss->y && ps[i].y < itss->y+64)
       {
         if(itss->sleeped > 0) itss->sleeped = 0;
         else itss->life -= psstrength;
         ps[i].vystreleny = 0;
         ps[i].par->Stop();
       }
     }
     for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
     {
       if(itcc->life > 0 && ps[i].x > itcc->x && ps[i].x < itcc->x+32 && ps[i].y > itcc->y && ps[i].y < itcc->y+64)
       {
         if(itcc->sleeped > 0) itcc->sleeped = 0;
         else itcc->life -= psstrength;
         ps[i].vystreleny = 0;
         ps[i].par->Stop();
       }
     }
     for(itmm = modri.begin(); itmm != modri.end(); itmm++)
     {
       if(itmm->life > 0 && ps[i].x > itmm->x && ps[i].x < itmm->x+32 && ps[i].y > itmm->y && ps[i].y < itmm->y+64)
       {
         if(itmm->sleeped > 0) itmm->sleeped = 0;
         else itmm->life -= psstrength;
         ps[i].vystreleny = 0;
         ps[i].par->Stop();
       }
     }
   }
   if(ps[i].x > 0 && ps[i].x < 6144)
   if(data[(int)ps[i].x/32][(int)ps[i].y/32] > 0 && data[(int)ps[i].x/32][(int)ps[i].y/32] < 100)
   {
     ps[i].vystreleny = 0;
     ps[i].par->Stop();
   }
 }
 //sleep
 if(hgge->Input_KeyDown(HGEK_Q) && type == DECKO && frozen <= 0.0f && mana >= 10 && nof_kuziel_therru >= 1)
  {
   for(i = 0; i < 2; i++)
   {
     if(sp[i].vystreleny == 0)
     {
       sp[i].y = y+16;
       sp[i].vystreleny = 1;
    if(!godlike)
      mana -= 10;
       if(smer == 4)
       {
        sp[i].x = x-48;
        sp[i].vx = -2.5f;
       }
       if(smer == 6)
       {
        sp[i].x = x+48;
        sp[i].vx = 2.5f;
       }
       qutoci = true;
       frameutok = 0.0f;
       sp[i].par1->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 2; i++) 
 {
  sp[i].manage(camleft);
  if(sp[i].vystreleny == 1)
  {
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && sp[i].x > itss->x && sp[i].x < itss->x+32 && sp[i].y > itss->y && sp[i].y < itss->y+64)
      {
        itss->sleeped = 1000;
        sp[i].vystreleny = 0;
        sp[i].par1->Stop();
        itss->parsleep->FireAt(0,0);
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && sp[i].x > itcc->x && sp[i].x < itcc->x+32 && sp[i].y > itcc->y && sp[i].y < itcc->y+64)
      {
        itcc->sleeped = 1000;
        sp[i].vystreleny = 0;
        sp[i].par1->Stop();
        itcc->parsleep->FireAt(0,0);
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && sp[i].x > itmm->x && sp[i].x < itmm->x+32 && sp[i].y > itmm->y && sp[i].y < itmm->y+64)
      {
        itmm->sleeped = 1000;
        sp[i].vystreleny = 0;
        sp[i].par1->Stop();
        itmm->parsleep->FireAt(0,0);
      }
    }
  }
  if(sp[i].x > 0 && sp[i].x < 6144)
  if(data[(int)sp[i].x/32][(int)sp[i].y/32] > 0 && data[(int)sp[i].x/32][(int)sp[i].y/32] < 100)
  {
    sp[i].vystreleny = 0;
    sp[i].par1->Stop();
  }
 }
 
 //knazka:
 //bubble
 if(hgge->Input_KeyDown(HGEK_D) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 6)
  {
    if(!godlike)
      mana -= 10;
    bubbletime = 20.0f;
 }
 if(bubbletime > 0.0f)
 {
   bubbletime -= 0.1f;
 }
 //heal
 if(hgge->Input_KeyDown(HGEK_A) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 4)
  {
    if(!godlike)
      mana -= 10;
  heal_par->FireAt(x, y+16);
  life += (int)(maxlife/10);
  if(life > maxlife)life = maxlife;
 }
 heal_par->Update(dt);
 heal_par->MoveTo(x, y);
 heal_par->Transpose(-camleft, 0);
 //manadrain
 if(hgge->Input_KeyDown(HGEK_S) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 5)
  {
   if(md.vystreleny == 0)
   {
     md.y = y+16;
     md.vystreleny = 1;
    if(!godlike)
      mana -= 10;
     if(smer == 4)
     {
      md.x = x-48;
      md.vx = -3.5f;
     }
     if(smer == 6)
     {
      md.x = x+48;
      md.vx = 3.5f;
     }
     sutoci = true;
     frameutok = 0.0f;
     md.par->Fire();
   }
 }
 md.manage(camleft);
 if(md.vystreleny == 1)
 {
    if(!md.vraciasa)
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && md.x > itss->x && md.x < itss->x+32 && md.y > itss->y && md.y < itss->y+64)
      {
        md.nesiem = itss->life/5;
        md.vraciasa = true;
        itss->life -= itss->life/4;
        md.vx *= -1;
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && md.x > itcc->x && md.x < itcc->x+32 && md.y > itcc->y && md.y < itcc->y+64)
      {
        md.nesiem = itcc->life/5;
        md.vraciasa = true;
        itcc->life -= itcc->life/4;
        md.vx *= -1;
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && md.x > itmm->x && md.x < itmm->x+32 && md.y > itmm->y && md.y < itmm->y+64)
      {
        md.nesiem = itmm->life/5;
        md.vraciasa = true;
        itmm->life -= itmm->life/4;
        md.vx *= -1;
      }
    }
    if(md.vraciasa && md.x > x && md.x < x+32 && md.y > y && md.y < y+64)
    {
      mana += md.nesiem;
      md.nesiem = 0;
      md.vraciasa = false;
      md.vystreleny = 0;
      md.par->Stop();
    }
 }
 if(md.x > 0 && md.x < 6144)
 if(data[(int)md.x/32][(int)md.y/32] > 0 && data[(int)md.x/32][(int)md.y/32] < 100)
 {
    md.nesiem = 0;
    md.vraciasa = false;
    md.vystreleny = 0;
    md.par->Stop();
 }   
    
    
    
 if(hgge->Input_KeyDown(HGEK_E) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 3)
  {
  for(i = 0; i < 3; i++)
  {
   if(mn[i].polozena == 0 && !lieta && (
      (
      smer == 4 &&
      data[(int)(x-48)/32][(int)(y+32)/32] == 0 && data[(int)(x-16)/32][(int)(y+32)/32] == 0 &&
      data[(int)(x-48)/32][(int)(y+64)/32] != 0 && data[(int)(x-16)/32][(int)(y+64)/32] != 0
      ) || 
      (smer == 6 &&
      data[(int)(x+48)/32][(int)(y+32)/32] == 0 && data[(int)(x+16)/32][(int)(y+32)/32] == 0 &&
      data[(int)(x+48)/32][(int)(y+64)/32] != 0 && data[(int)(x+16)/32][(int)(y+64)/32] != 0
      )
      ))
   {
    if(smer == 4)mn[i].x = x-48;
    if(smer == 6)mn[i].x = x+48;
    
    mn[i].y = y+48;
    
    mn[i].mina->v[0].y = y+48;
    mn[i].mina->v[1].y = y+48;
    mn[i].mina->v[2].y = y+48+16;    
    mn[i].mina->v[3].y = y+48+16;
    
    
    mn[i].cas = 1000;
    mn[i].polozena = 1;
    if(!godlike)
      mana -= 10;
    eutoci = true; 
    frameutok = 0.0f;
    
    break;                 
   }//if moze polozit      
  }//for vsetky miny                            
 }//for key_e
 
  for(i = 0; i < 3; i++)
  {
   mn[i].manage();
  }
 
 if(hgge->Input_KeyDown(HGEK_Q) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 1)
  {
   for(i = 0; i < 2; i++)
   {
     if(ch[i].vystreleny == 0)
     {
       ch[i].y = y+16;
       ch[i].vystreleny = 1;
    if(!godlike)
      mana -= 10;
       if(smer == 4)
       {
        ch[i].x = x-48;
        ch[i].vx = -2.5f;
       }
       if(smer == 6)
       {
        ch[i].x = x+48;
        ch[i].vx = 2.5f;
       }
       qutoci = true;
       frameutok = 0.0f;
       ch[i].par->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 2; i++) 
 {
  ch[i].manage(camleft);
  if(ch[i].vystreleny == 1)
  {
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && ch[i].x > itss->x && ch[i].x < itss->x+32 && ch[i].y > itss->y && ch[i].y < itss->y+64)
      {
        itss->charmed = 1000;
        ch[i].vystreleny = 0;
        ch[i].par->Stop();
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && ch[i].x > itcc->x && ch[i].x < itcc->x+32 && ch[i].y > itcc->y && ch[i].y < itcc->y+64)
      {
        itcc->charmed = 1000;
        ch[i].vystreleny = 0;
        ch[i].par->Stop();
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && ch[i].x > itmm->x && ch[i].x < itmm->x+32 && ch[i].y > itmm->y && ch[i].y < itmm->y+64)
      {
        itmm->charmed = 1000;
        ch[i].vystreleny = 0;
        ch[i].par->Stop();
      }
    }
  }
  if(ch[i].x > 0 && ch[i].x < 6144)
  if(data[(int)ch[i].x/32][(int)ch[i].y/32] > 0 && data[(int)ch[i].x/32][(int)ch[i].y/32] < 100)
  {
    ch[i].vystreleny = 0;
    ch[i].par->Stop();
  }
 }
  //W v knazke
  
  if(hgge->Input_KeyDown(HGEK_W) && type == KNAZKA && frozen <= 0.0f && mana >= 10 && nof_kuziel_tenar >= 2)
  {
   for(i = 0; i < 3; i++)
   {
     if(sl[i].vystreleny == 0)
     {
       sl[i].y = y+16;
       sl[i].vystreleny = 1;
    if(!godlike)
      mana -= 10;
       if(smer == 4)
       {
        sl[i].x = x-48;
        sl[i].vx = -3.5f;
       }
       if(smer == 6)
       {
        sl[i].x = x+48;
        sl[i].vx = 3.5f;
       }
       wutoci = true;
       frameutok = 0.0f;
       sl[i].par->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 3; i++)
 {
   sl[i].manage(camleft);
   if(sl[i].vystreleny == 1)
   {
     for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
     {
       if(itss->life > 0 && sl[i].x > itss->x && sl[i].x < itss->x+32 && sl[i].y > itss->y && sl[i].y < itss->y+64)
       {
         if(itss->sleeped > 0) itss->sleeped = 0;
         else itss->life -= slstrength;
         sl[i].vystreleny = 0;
         sl[i].par->Stop();
       }
     }
     for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
     {
       if(itcc->life > 0 && sl[i].x > itcc->x && sl[i].x < itcc->x+32 && sl[i].y > itcc->y && sl[i].y < itcc->y+64)
       {
         if(itcc->sleeped > 0) itcc->sleeped = 0;
         else itcc->life -= slstrength;
         sl[i].vystreleny = 0;
         sl[i].par->Stop();
       }
     }
     for(itmm = modri.begin(); itmm != modri.end(); itmm++)
     {
       if(itmm->life > 0 && sl[i].x > itmm->x && sl[i].x < itmm->x+32 && sl[i].y > itmm->y && sl[i].y < itmm->y+64)
       {
         if(itmm->sleeped > 0) itmm->sleeped = 0;
         else itmm->life -= slstrength;
         sl[i].vystreleny = 0;
         sl[i].par->Stop();
       }
     }
   }
   //printf("data[0][23] = %d\n", data[0][23]);
     //printf("data: %d %d\n", data[(int)fb[i].x/32][(int)fb[i].y/32], (int)fb[i].x/32);
   if(sl[i].x > 0 && sl[i].x < 6144)
   if(data[(int)sl[i].x/32][(int)sl[i].y/32] > 0 && data[(int)sl[i].x/32][(int)sl[i].y/32] < 100)
   {
     sl[i].vystreleny = 0;
     sl[i].par->Stop();
   }
 }
 
 //q u geda
 if(hgge->Input_KeyDown(HGEK_Q) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 1)
  {
   for(i = 0; i < 3; i++)
   {
     if(fb[i].vystreleny == 0)
     {
       fb[i].y = y+16;
       fb[i].vystreleny = 1;
    if(!godlike)
      mana -= 10;
       hgge->Effect_PlayEx(fbsfx, soundvol);
       if(smer == 4)
       {
        fb[i].x = x-48;
        fb[i].vx = -3.5f;
       }
       if(smer == 6)
       {
        fb[i].x = x+48;
        fb[i].vx = 3.5f;
       }
       qutoci = true;
       frameutok = 0.0f;
       fb[i].par->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 3; i++)
 {
   fb[i].manage(camleft);
   if(fb[i].vystreleny == 1)
   {
     for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
     {
       if(itss->life > 0 && fb[i].x > itss->x && fb[i].x < itss->x+32 && fb[i].y > itss->y && fb[i].y < itss->y+64)
       {
         if(itss->sleeped > 0) itss->sleeped = 0;
         else itss->life -= fbstrength;
         fb[i].vystreleny = 0;
         fb[i].par->Stop();
       }
     }
     for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
     {
       if(itcc->life > 0 && fb[i].x > itcc->x && fb[i].x < itcc->x+32 && fb[i].y > itcc->y && fb[i].y < itcc->y+64)
       {
         if(itcc->sleeped > 0) itcc->sleeped = 0;
         else itcc->life -= fbstrength;
         fb[i].vystreleny = 0;
         fb[i].par->Stop();
       }
     }
     for(itmm = modri.begin(); itmm != modri.end(); itmm++)
     {
       if(itmm->life > 0 && fb[i].x > itmm->x && fb[i].x < itmm->x+32 && fb[i].y > itmm->y && fb[i].y < itmm->y+64)
       {
         if(itmm->sleeped > 0) itmm->sleeped = 0;
         else itmm->life -= fbstrength;
         fb[i].vystreleny = 0;
         fb[i].par->Stop();
       }
     }
   }
   //printf("data[0][23] = %d\n", data[0][23]);
     //printf("data: %d %d\n", data[(int)fb[i].x/32][(int)fb[i].y/32], (int)fb[i].x/32);
   if(fb[i].x > 0 && fb[i].x < 6144)
   if(data[(int)fb[i].x/32][(int)fb[i].y/32] > 0 && data[(int)fb[i].x/32][(int)fb[i].y/32] < 100)
   {
     fb[i].vystreleny = 0;
     fb[i].par->Stop();
   }
 }
 if(hgge->Input_KeyDown(HGEK_W) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 2)
  {
   for(i = 0; i < 2; i++)
   {
     if(fr[i].vystreleny == 0)
     {
       fr[i].y = y+16;
       fr[i].vystreleny = 1;
       if(!godlike)
         mana -= 10;
       if(smer == 4)
       {
        fr[i].x = x-48;
        fr[i].vx = -2.5f;
       }
       if(smer == 6)
       {
        fr[i].x = x+48;
        fr[i].vx = 2.5f;
       }
       wutoci = true;
       frameutok = 0.0f;
       fr[i].par->Fire();
       break;
     }
   }
 }
 for(i = 0; i < 2; i++) 
 {
  fr[i].manage(camleft);
  if(fr[i].vystreleny == 1)
  {
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && fr[i].x > itss->x && fr[i].x < itss->x+32 && fr[i].y > itss->y && fr[i].y < itss->y+64)
      {
        itss->frozen = 1000;
        fr[i].vystreleny = 0;
        fr[i].par->Stop();
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && fr[i].x > itcc->x && fr[i].x < itcc->x+32 && fr[i].y > itcc->y && fr[i].y < itcc->y+64)
      {
        itcc->frozen = 1000;
        fr[i].vystreleny = 0;
        fr[i].par->Stop();
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && fr[i].x > itmm->x && fr[i].x < itmm->x+32 && fr[i].y > itmm->y && fr[i].y < itmm->y+64)
      {
        itmm->frozen = 1000;
        fr[i].vystreleny = 0;
        fr[i].par->Stop();
      }
    }
  }
  if(fr[i].x > 0 && fr[i].x < 6144)
  if(data[(int)fr[i].x/32][(int)fr[i].y/32] > 0 && data[(int)fr[i].x/32][(int)fr[i].y/32] < 100)
  {
    fr[i].vystreleny = 0;
    fr[i].par->Stop();
  }
 }
 if(hgge->Input_KeyDown(HGEK_E) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 3)
  {
   if(ld.vystreleny == 0)
   {
     ld.y = y+16;
     ld.vystreleny = 1;
     if(!godlike)
       mana -= 10;
     if(smer == 4)
     {
      ld.x = x-48;
      ld.vx = -3.5f;
     }
     if(smer == 6)
     {
      ld.x = x+48;
      ld.vx = 3.5f;
     }
     eutoci = true;
     frameutok = 0.0f;
     ld.par->Fire();
   }
 }
 ld.manage(camleft);
 if(ld.vystreleny == 1)
 {
    if(!ld.vraciasa)
    for(itss = sekaci.begin(); itss != sekaci.end(); itss++)
    {
      if(itss->life > 0 && ld.x > itss->x && ld.x < itss->x+32 && ld.y > itss->y && ld.y < itss->y+64)
      {
        ld.nesiem = itss->life/5;
        ld.vraciasa = true;
        itss->life -= itss->life/4;
        ld.vx *= -1;
      }
    }
    for(itcc = cernosi.begin(); itcc != cernosi.end(); itcc++)
    {
      if(itcc->life > 0 && ld.x > itcc->x && ld.x < itcc->x+32 && ld.y > itcc->y && ld.y < itcc->y+64)
      {
        ld.nesiem = itcc->life/5;
        ld.vraciasa = true;
        itcc->life -= itcc->life/4;
        ld.vx *= -1;
      }
    }
    for(itmm = modri.begin(); itmm != modri.end(); itmm++)
    {
      if(itmm->life > 0 && ld.x > itmm->x && ld.x < itmm->x+32 && ld.y > itmm->y && ld.y < itmm->y+64)
      {
        ld.nesiem = itmm->life/5;
        ld.vraciasa = true;
        itmm->life -= itmm->life/4;
        ld.vx *= -1;
      }
    }
    if(ld.vraciasa && ld.x > x && ld.x < x+32 && ld.y > y && ld.y < y+64)
    {
      life += ld.nesiem;
      ld.nesiem = 0;
      ld.vraciasa = false;
      ld.vystreleny = 0;
      ld.par->Stop();
    }
 }
 if(ld.x > 0 && ld.x < 6144)
 if(data[(int)ld.x/32][(int)ld.y/32] > 0 && data[(int)ld.x/32][(int)ld.y/32] < 100)
 {
    ld.nesiem = 0;
    ld.vraciasa = false;
    ld.vystreleny = 0;
    ld.par->Stop();
 }
 
 if(hgge->Input_KeyDown(HGEK_A) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 4)
  {
   if(mw.vystreleny == 0 && lieta == 0 && x > 32 && x < 6112)
   {
     if(((smer == 4 && data[(int)x/32-1][(int)y/32] == 0 && data[(int)x/32-1][(int)y/32+1] == 0) &&
         (data[(int)(x)/32][(int)y/32+2] > 0 && data[(int)(x)/32][(int)y/32+2] < 100)) ||
        ((smer == 6 && data[(int)x/32+2][(int)y/32] == 0 && data[(int)x/32+2][(int)y/32+1] == 0) &&
         (data[(int)(x+32)/32][(int)y/32+2] > 0 && data[(int)(x+32)/32][(int)y/32+2] < 100)))
     {
       mw.y = y;
       mw.vystreleny = 1;
       if(!godlike)
         mana -= 10;
       if(smer == 4)
       {
        mw.x = x-32;
       }
       if(smer == 6)
       {
        mw.x = x+32;
       }
       mw.bmp->v[0].y = y;
       mw.bmp->v[1].y = y;
       mw.bmp->v[2].y = y+64;
       mw.bmp->v[3].y = y+64;
       mw.t = 5.0f;
       autoci = true;
       frameutok = 0.0f;
     }
   }
 }
 mw.manage();
 
 if(hgge->Input_KeyDown(HGEK_S) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 5)
  {
    if(as.vystreleny == 0 && lieta == 0 && x > 32 && x < 6112)
    {
      as.x1 = x - 96;
      as.x2 = x + 96;
      as.y1 = y + 32;
      as.y2 = y + 32;
    if(!godlike)
      mana -= 10;
      if(as.x1 > 0)
      {
        if(data[(int)as.x1/32][(int)as.y1/32] > 0 && data[(int)as.x1/32][(int)as.y1/32] < 100) as.is1 = false;
        else if(data[(int)(as.x1+30)/32][(int)as.y1/32] > 0 &&  data[(int)(as.x1+30)/32][(int)as.y1/32] < 100) as.is1 = false;
        else if(data[(int)as.x1/32][(int)(as.y1+32)/32] == 0 && data[(int)(as.x1+30)/32][(int)(as.y1+30)/32] == 0) as.is1 = false;
        else as.is1 = true;
      } 
      if(as.x2 < 6112)
      {
        if(data[(int)as.x2/32][(int)as.y2/32] > 0 && data[(int)as.x2/32][(int)as.y2/32] < 100) as.is2 = false;
        else if(data[(int)(as.x2+30)/32][(int)as.y2/32] > 0 && data[(int)(as.x2+30)/32][(int)as.y2/32] < 100) as.is2 = false;
        else if(data[(int)as.x2/32][(int)(as.y2+32)/32] == 0 && data[(int)(as.x2+30)/32][(int)(as.y2+30)/32] == 0) as.is2 = false;
        else as.is2 = true;
      }
      
      sutoci = true;
      as.t = 5.0f;
      as.vystreleny = 1;
      frameutok = 0.0f;
      if(as.is1)
        as.par1->Fire();
      if(as.is2)
        as.par2->Fire();
    }
 }
 as.manage();
 
 if(hgge->Input_KeyDown(HGEK_D) && type == GED && frozen <= 0.0f && mana >= 10 && nof_kuziel_ged >= 6)
  {
  if(!lieta && x > 160 && x < 6108 && smer == 4)
  {
    if(data[(int)(x-160)/32][(int)y/32] == 0 && data[(int)(x-128)/32][(int)y/32] == 0 &&
       data[(int)(x-160)/32][(int)(y+32)/32] == 0 && data[(int)(x-128)/32][(int)(y+32)/32] == 0 &&
       data[(int)(x-160)/32][(int)(y+64)/32] != 0 && data[(int)(x-128)/32][(int)(y+64)/32] != 0)
       x -= 160;
    if(!godlike)
      mana -= 10;
  }
  if(!lieta && x >= 0 && x < 5947 && smer == 6)
  {
    if(data[(int)(x+160)/32][(int)y/32] == 0 && data[(int)(x+192)/32][(int)y/32] == 0 &&
       data[(int)(x+160)/32][(int)(y+32)/32] == 0 && data[(int)(x+192)/32][(int)(y+32)/32] == 0 &&
       data[(int)(x+160)/32][(int)(y+64)/32] != 0 && data[(int)(x+192)/32][(int)(y+64)/32] != 0)
       x += 160;
    if(!godlike)
      mana -= 10;
  }
 }
 
 
 if(hgge->Input_KeyDown(HGEK_1) && type != GED && frozen <= 0.0f && mana >= 10 && is_ged == 1)
  {
    if(!godlike)
      mana -= 10;
    par_cc->MoveTo(x-camleft-16,y);
    par_cc->Fire();
    type = GED;
    is_par_cc = 10.0f;
 }
 if(hgge->Input_KeyDown(HGEK_2) && type != KNAZKA && frozen <= 0.0f && mana >= 10 && is_tenar == 1)
  {
    if(!godlike)
      mana -= 10;
    par_cc->MoveTo(x-camleft-16,y);
    par_cc->Fire();
    type = KNAZKA;
    is_par_cc = 10.0f;
 }
 if(hgge->Input_KeyDown(HGEK_3) && type != DECKO && frozen <= 0.0f && mana >= 10 && is_therru == 1)
  {
    if(!godlike)
      mana -= 10;
    par_cc->MoveTo(x-camleft-16,y);
    par_cc->Fire();
    type = DECKO;
    is_par_cc = 10.0f;
 }
 par_cc->Update(dt);
 if(is_par_cc >= 0.0f)
 {
    par_cc->MoveTo(x-16,y);
    par_cc->Transpose(-camleft, 0);
    is_par_cc -= 0.1f;
    if(is_par_cc < 0.0f)
    {
     par_cc->Stop();
    } 
 }
 if(hgge->Input_KeyDown(HGEK_SPACE) && frozen <= 0.0f)
 {
   utoci = true;
   frameutok = 0.0f;
 }
 if(utoci || qutoci || wutoci || eutoci || rutoci)
 {
   if(frameutok < MAXFRAME)
   {
     if(frozen <= 0.0f)frameutok+=0.1;
   }
   
   if(type == GED)
     gedoffanim->set_frame(frameutok);
   if(type == KNAZKA && utoci)
     tenarspcanim->set_frame(frameutok);
   if(type == KNAZKA && (qutoci || wutoci || eutoci || rutoci))
     tenarcstanim->set_frame(frameutok);
   if(type == DECKO && utoci)
     therruspcanim->set_frame(frameutok);
   if(type == DECKO && (qutoci || wutoci || eutoci || rutoci))
     therrucstanim->set_frame(frameutok);
     
   if(frameutok >= MAXFRAME)
     utoci = qutoci = wutoci = eutoci = rutoci = false;
 }
 if(autoci || sutoci || dutoci || futoci)
 {
    if(frameutok < MAXFRAME)
    {
      if(frozen <= 0.0f)frameutok+=0.1;
    }
    else
      autoci = sutoci = dutoci = futoci = false;
    if(type == GED)
      geddefanim->set_frame(frameutok);
    if(type == KNAZKA)
      tenarcstanim->set_frame(frameutok);
    if(type == DECKO)
      therrucstanim->set_frame(frameutok);
 }
 for(its = sekaci.begin(); its != sekaci.end(); its++)
 {
   if(its->life > 0)
     its->manage(camleft, x, y, &life, utoci, atk, smer, bubbletime, mw.vystreleny, mw.x, mw.y, 20, as.is1, as.is2, as.x1, as.y1, as.x2, as.y2, &(mn[0]), &(mn[1]), &(mn[2]));
 }
 for(itc = cernosi.begin(); itc != cernosi.end(); itc++)
 {
   if(itc->life > 0)
     itc->manage(camleft, x, y, &life, utoci, atk, smer, bubbletime, mw.vystreleny, mw.x, mw.y, 20, as.is1, as.is2, as.x1, as.y1, as.x2, as.y2, &(mn[0]), &(mn[1]), &(mn[2]));
   //manage cernoch fireball
   itc->cfb.manage(camleft);
   if(itc->cfb.vystreleny == 1)
   {
     if(life > 0 && itc->cfb.x > x && itc->cfb.x < x+32 && itc->cfb.y > y && itc->cfb.y < y+64 && bubbletime <= 0.0f)
     {
       life -= 50;
       itc->cfb.vystreleny = 0;
       itc->cfb.par->Stop();
     }
   }
   if(itc->cfb.x > 0 && itc->cfb.x < 6144)
    if(data[(int)itc->cfb.x/32][(int)itc->cfb.y/32] > 0 && data[(int)itc->cfb.x/32][(int)itc->cfb.y/32] < 100)
    {
      itc->cfb.vystreleny = 0;
      itc->cfb.par->Stop();
    } 
 }
 for(itm = modri.begin(); itm != modri.end(); itm++)
 {
   if(itm->life > 0)
     itm->manage(camleft, frozen, x, y, &life, utoci, atk, smer, bubbletime, mw.vystreleny, mw.x, mw.y, 20, as.is1, as.is2, as.x1, as.y1, as.x2, as.y2, &(mn[0]), &(mn[1]), &(mn[2]));
   //manage modry freeze
   itm->cfr.manage(camleft);
   if(itm->cfr.vystreleny == 1)
   {
     if(life > 0 && itm->cfr.x > x && itm->cfr.x < x+32 && itm->cfr.y > y && itm->cfr.y < y+64 && bubbletime <= 0.0f)
     {
       if(frozen <= 0.0f) frozen = 10.0f;
       itm->cfr.vystreleny = 0;
       itm->cfr.par->Stop();
     }
   }
   if(itm->cfr.x > 0 && itm->cfr.x < 6144)
    if(data[(int)itm->cfr.x/32][(int)itm->cfr.y/32] > 0 && data[(int)itm->cfr.x/32][(int)itm->cfr.y/32] < 100)
    {
      itm->cfr.vystreleny = 0;
      itm->cfr.par->Stop();
    }
 }
 for(itp = potions.begin(); itp != potions.end(); itp++)
 {
   if(itp->potion > 0)
   {
     if((itp->x - x) < 32 && (x - itp->x) < 32 && (y - itp->y) < 32 && (itp->y - y) < 64)
     {
       if(itp->type == PTYPE_LIFE || itp->type == PTYPE_LIFE_G)
       {
         life += itp->potion;
         itp->potion = 0;
       }
       else if(itp->type == PTYPE_MANA || itp->type == PTYPE_MANA_G)
       {
         mana += itp->potion;
         itp->potion = 0;
       }
       else if(itp->type == PTYPE_RE || itp->type == PTYPE_RE_G)
       {
         mana += itp->potion;
         life += itp->potion;    
         itp->potion = 0;
       }
     }
   }
 }
 
 list<VTAK>::iterator itv;
 for(itv = vtaci.begin(); itv != vtaci.end(); itv++)
 {
   itv->manage(x, y, &life);
 }
 
 if(life <= 0)
 {
   for(its = sekaci.begin(); its != sekaci.end(); its++)
   {
     its->life = its->maxlife;
     its->x = its->startx*32;
     its->y = its->starty*32+5.0f;
     its->direction = true;
     its->vx = 1.0f;
     its->vy = 0.0f;
     its->frame = 0.0f;
     its->liftedstarty = its->y;
     its->frozen = 0;
     its->charmed = 0;
     its->sleeped = 0;
     its->lifted = 0;
     its->udrel = 0.0f;
     its->ubralsi = 0.0f;
   }
   for(itc = cernosi.begin(); itc != cernosi.end(); itc++)
   {
     itc->life = itc->maxlife;
     itc->x = itc->startx*32;
     itc->y = itc->starty*32+5.0f;
     itc->direction = true;
     itc->vy = 0.0f;
     itc->frame = 0.0f;
     itc->liftedstarty = 0.0f;
     itc->frozen = 0;
     itc->charmed = 0;
     itc->sleeped = 0;
     itc->lifted = 0;
     itc->cas = 0.0f;
     itc->ubralsi = 0.0f;
   }
   for(itm = modri.begin(); itm != modri.end(); itm++)
   {
     itm->life = itm->maxlife;
     itm->x = itm->startx*32;
     itm->y = itm->starty*32+5.0f;
     itm->direction = true;
     itm->vy = 0.0f;
     itm->frame = 0.0f;
     itm->liftedstarty = 0.0f;
     itm->frozen = 0;
     itm->charmed = 0;
     itm->sleeped = 0;
     itm->lifted = 0;
     itm->cas = 0.0f;
     itm->ubralsi = 0.0f;
   }
   for(itv = vtaci.begin(); itv != vtaci.end(); itv++)
   {
     itv->life = itv->maxlife;
     itv->x = itv->startx*32;
     itv->kamleti = 6;
   }
   for(itp = potions.begin(); itp != potions.end(); itp++)
   {
      itp->potion = itp->startpotion;
   }
   list<RUNA>::iterator itr;
   for(itr = runy.begin(); itr != runy.end(); itr++)
   {
     itr->visible = 1;
   }
   is_eol = 0;
   skoncillevel = 0;
   par_el->Stop(true);
   life = maxlife;
   mana = maxmana;
   x = startx*32;
   y = starty*32;
   vy = 0.0f;
   vx = 0.0f;
   frozen = 0.0f;
 }
}

int PLAYER::add_sekac(int id, int **dta, int sekactype, int life, int sx, int sy, int ex, int ey, int bgtype)
{
  SEKAC s;
  s.hgge = hgge;
  s.init(id, dta);
  s.startx = sx;
  s.starty = sy;
  s.endx = ex;
  s.endy = ey;
  s.x = sx*32;
  s.y = sy*32+5.0f;
  s.bgtype = bgtype;
  s.vx = 1.0f;
  s.vy = 0.0f;
  s.life = life;
  s.maxlife = life;
  s.data = dta;
  s.type = sekactype;
  /*
  for(int m = 0; m < 192; m++)
  {
  for(int n = 0; n < 24; n++)
  {
   s.data[m][n] = dta[m][n];
   //printf("%d ", data[m][n]);
  }
  //printf("\n");
  }*/
  sekaci.push_back(s);
}

int PLAYER::add_cernoch(int id, int **dta, int life, int x, int y, int bgtype)
{
  //printf("TY VOE: %d %d", x, y);
  CERNOCH c;
  c.hgge = hgge;
  c.init(id, dta);
  c.startx = x;
  c.starty = y;
  c.x = x*32;
  c.y = y*32+5.0f;
  //printf(" %f %f\n\n", c.x, c.y);
  c.bgtype = bgtype;
  c.vy = 0.0f;
  c.life = life;
  c.maxlife = life;
  c.data = dta;
  
  cernosi.push_back(c);
}

int PLAYER::add_magemodry(int id, int **dta, int life, int x, int y, int bgtype)
{
  MAGEMODRY m;
  m.hgge = hgge;
  m.init(id, dta);
  m.startx = x;
  m.starty = y;
  m.x = x*32;
  m.y = y*32+5.0f;
  m.bgtype = bgtype;
  m.vy = 0.0f;
  m.life = life;
  m.maxlife = life;
  m.data = dta;
  
  modri.push_back(m);
}

int PLAYER::add_vtak(int id, int **dta, int life, int sx, int sy, int ex, int bgtype)
{
  VTAK v;
  v.hgge = hgge;
  v.startx = sx;
  v.starty = sy;
  v.endx = ex;
  v.x = sx*32;
  v.y = sy*32;
  v.vx = 1.0f;
  v.kamleti = 6;
  v.life = life;
  v.maxlife = life;
  v.data = dta;
  v.init();
  vtaci.push_back(v);
}

int PLAYER::add_potion(int id, int type, int x, int y)
{
  POTION p;
  if(type == PTYPE_MANA)
    p.init(hgge, "img/potmanami.png", x*32, y*32, type, 30);
  else if(type == PTYPE_MANA_G)
    p.init(hgge, "img/potmanamn.png", x*32, y*32, type, 60);
  else if(type == PTYPE_LIFE)
    p.init(hgge, "img/pothlthmi.png", x*32, y*32, type, 30);
  else if(type == PTYPE_LIFE_G)
    p.init(hgge, "img/pothlthmn.png", x*32, y*32, type, 60);
  else if(type == PTYPE_RE)
    p.init(hgge, "img/potreunmi.png", x*32, y*32, type, 30);
  else if(type == PTYPE_RE_G)
    p.init(hgge, "img/potreunmn.png", x*32, y*32, type, 60);
  p.ID = id;
  potions.push_back(p);
}

int PLAYER::add_runa(int id, float x, float y)
{
  RUNA r;
  r.ID = id;
  r.init(x, y, hgge->Random_Int(1,6));
  runy.push_back(r);
}

int PLAYER::new_kuzlo(int akekuzlo, int x, int y, int smer, int idcislo)
{
  if(akekuzlo == 1) // q fireball
  {
    qutoci = true;
  }
  if(akekuzlo == 2) // w freeze
  {
    wutoci = true;
  }
  if(akekuzlo == 3) // e blink
  {
    this->x = x;
    this->y = y;
  }
}

int PLAYER::znic_kuzlo(int akekuzlo, int n)
{
  
}
