#ifndef __PLAYER_H
#define __PLAYER_H
#include "sekac.h"
#include "dl_ws_client.h"

#define GED 0
#define KNAZKA 1
#define DECKO 2

//int player_id;

class PLAYER
{
 public:
        PLAYER(HGE *nhge);
        ~PLAYER();
        float x, y, vx, vy;
        int type;
        animation *gedwalkanim, *tenarwalkanim, *therruwalkanim;
        animation *gedoffanim, *tenarspcanim, *therruspcanim;
        animation *geddefanim, *tenarcstanim, *therrucstanim;
        animation *sekac1anim, *sekac2anim, *sekac3anim;
        animation *cernochanim, *modrymageanim;
        int draw(float cl);
        int draw_mp(float cl);
        int init(int id, int **dta, bool godlike);
        int manage(float camleft, int soundvol);
        int manage_mp(float camleft, DL_WS_CLIENT *c);
        int idedolava, idedoprava, lieta, idehore;
        int smer; //4,6
        int ID;
        int is_ged, is_tenar, is_therru, nof_kuziel_ged, nof_kuziel_tenar, nof_kuziel_therru; 
        bool godlike;
        HEFFECT fbsfx;
        int team, skore;
        char nick[32];
        
        list<SEKAC> sekaci;
        list<CERNOCH> cernosi;
        list<MAGEMODRY> modri;
        list<VTAK> vtaci;
        list<POTION> potions;
        list<RUNA> runy;
        
        list<SEKAC>::iterator search_sekac(int id);
        list<CERNOCH>::iterator search_cernoch(int id);
        list<MAGEMODRY>::iterator search_magemodry(int id);
        
        int add_sekac(int id, int **dta, int sekactype, int life, int sx, int sy, int ex, int ey, int bgtype);
        int add_cernoch(int id, int **dta, int life, int x, int y, int bgtype);
        int add_magemodry(int id, int **dta, int life, int x, int y, int bgtype);
        int add_vtak(int id, int **dta, int life, int sx, int sy, int ex, int bgtype);
        int add_potion(int id, int type, int x, int y);
        int add_runa(int id, float x, float y);
        
        int new_kuzlo(int akekuzlo, int x, int y, int smer, int idcislo);
        int znic_kuzlo(int akekuzlo, int n);
        
        float frame;
        float frameutok;
        float kraca;
        bool utoci, qutoci, wutoci, eutoci, rutoci, autoci, sutoci, dutoci, futoci;
        int **data;
        int startx, starty;
        int endx, endy;
        float life, maxlife;
        float mana, maxmana;
        int atk;
        int fbstrength;
        float bubbletime;
        float raged;
        int israged;
        float frozen;
        int slstrength;
        int psstrength;
        FIREBALL fb[3];
        FREEZE fr[2];
        LIFEDRAIN ld;
        MAGICWALL mw;
        ARCANESPOT as;
        CHARM ch[2];
        SOUL sl[3];
        MINE mn[3];
        MANADRAIN md;
        SLEEP sp[2];
        POWERSHOCK ps[5];
        
        hgeQuad *emptyball, *manaball, *lifeball;
        hgeQuad *runa1, *runa2, *runa3, *runa4, *runa5, *runa6;
        hgeQuad *bubblequad, *ragequad;
        float par_cc_x, par_cc_y;
        float is_par_cc;
        float is_neg_aura;
        int is_eol;
        int skoncillevel;
        hgeParticleSystem *par_cc, *par_na, *par_el;
        hgeSprite *spr_cc, *spr_na, *spr_el;
        HGE *hgge;    
        hgeSprite *heal_spr;
        hgeParticleSystem *heal_par;
};
#endif
