#ifndef __POTION
#define __POTION

#define PTYPE_LIFE   1
#define PTYPE_LIFE_G 2
#define PTYPE_MANA   3
#define PTYPE_MANA_G 4
#define PTYPE_RE     5
#define PTYPE_RE_G   6

#include "runa.h"

class POTION
{
  public:
        POTION();
        ~POTION();
        int init(HGE *nhge, char *filename, float x, float y, int type, int potion);
        int manage();
        int draw(float cl);
        hgeQuad *potionquad;
        float x, y;
        int type;
        int potion, startpotion;
        int ID;
        HGE *hgge;
};

#endif
