#include "vajco.h"

VAJCO::VAJCO()
{
 //printf("mame vajco");  
 hodene = 0;
 vy = 0.0f;        
 cas = 0.0f;    
}

VAJCO::~VAJCO()
{
 //printf("nemame vajco");              
}

int VAJCO::init(int **dta)
{
  data = dta;
  vajco_quad = dl_util_makeHgeQuad(hgge, -32,-32,32,32,0xffffffff, "img/skala.png");
  vy = 0.0f;
  y = -32;
  x = -32;
  hodene = 0;
}

int VAJCO::manage(float vtak_x, float vtak_y, float px, float py, float *life)
{
  vy += 0.05f;
  y += vy;
  if(hodene != 1 && cas <= 0.0f)
  {
    hodene = 1;
    y = vtak_y+32;
    x = vtak_x+16;
    vy = 0.0f;
    cas = 25.0f;
  }
  else
  {
    if(cas > 0.0f) cas -= 0.1f;
    if(x >= 0 && x < 6108 && y >= 0 && y < 730 && hodene == 1)
    {
      if(data[(int)x/32][(int)(y+32)/32] != 0 || data[(int)(x+32)/32][(int)(y+32)/32] != 0)
      {
        hodene = 0;
      }
      if((px - x) < 32 && (x - px) < 32 && (py - y) < 32 && (y - py) < 64)
      {
        *life -= 50;
        hodene = 0;
      }
    }
  }
}

int VAJCO::draw(float cl)
{
  if((x-cl) > -32 && (x-cl) < 1024)
  {
    if(hodene != 0)
    {
      vajco_quad->v[0].x = x-cl;    vajco_quad->v[0].y = y;
      vajco_quad->v[1].x = x-cl+32; vajco_quad->v[1].y = y;
      vajco_quad->v[2].x = x-cl+32; vajco_quad->v[2].y = y+32;
      vajco_quad->v[3].x = x-cl;    vajco_quad->v[3].y = y+32;
      hgge->Gfx_RenderQuad(vajco_quad);
    }
  }
}
