#include "wall.h"

MAGICWALL::MAGICWALL(HGE *nhge)
{
 hgge = nhge;          
 x = 5.0f;
 y = 500.0f; 
 vystreleny = 0;
 t = 0.0f;
 //printf("mame freeze");                   
}

MAGICWALL::MAGICWALL()
{
 x = 5.0f;
 y = 200.0f;                   
 vystreleny = 0;
 t = 0.0f;
 //printf("mame freeze");                    
}

MAGICWALL::~MAGICWALL()
{
 //printf("nemame freeze");                    
}

int MAGICWALL::init(HGE *nhge, char *filename)
{
  hgge = nhge;
  bmp = dl_util_makeHgeQuad(hgge, 0, 0, 32, 64, 0xffffffff, filename);
 
 return 1;    
}

int MAGICWALL::draw(float camleft)
{
  if(t > 0.0f)
  {
    if(x-camleft > -32 && x-camleft < 1024)
    {
      bmp->v[0].x = x-camleft;
      bmp->v[1].x = x-camleft+32;
      bmp->v[2].x = x-camleft+32;
      bmp->v[3].x = x-camleft;
      
      hgge->Gfx_RenderQuad(bmp);
    }
  }
  
  return 1;    
}

int MAGICWALL::manage()
{
 float dt;
 dt = hgge->Timer_GetDelta();
 if(vystreleny)
 {
    t -= dt;
    if(t <= 0.0f)
      vystreleny = 0;
 }
 return 1;    
}
